-------------------------------------------------------------------------------------------------------------------------------------------------
v1.11.5.0 (Winter Update Hotfix 1)
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed players sometimes retaining their old inventory items if they die and respawn on a later round.
- Fixed inability to order bots to deconstruct items that don't yield anything when deconstructed.
- Fixed weak points causing the "high pressure" icon to appear in the room, despite the pressure not being high enough to cause damage.
- Fixed relay connections being in an incorrect order in circuit boxes.
- Fixed ImpactTolerance, ImpactDamage and ImpactDamageProbability resetting back to defaults when saving and reloading a sub.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.11.4.1 (Winter Update 2025)
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes and additions:
- Wallaby, a new tier 2 Attack class submarine. Boasts an unexpectedly high amount of firepower for its size, while also providing a full set of fabrication facilities, but also includes weak points in the pipe system which can cause water hazards inside the sub.
- Added valves and weakpoints. Weakpoints are pipes that can break, causing a water hazard (which floods the submarine and is hard to pass).
   - Weakpoints are repairable with a wrench. Turning off a valve makes it easier to repair, but makes any linked pumps not work while the valve is closed
   - Wall weakpoints have their condition linked to a wall. This means these walls cannot be cut as a shortcut between rooms
- Added level background visuals to the sub editor's test mode to make it easier to see what the sub looks like in the actual in-game environments.
- Balancing combat mission NPCs: improved the higher-level enemy NPCs and gave them better gear.
- Made the rotation tool snap to 1-degree increments and the scale tool snap to 0.1 increments in the sub editor. Holding Shift while using the tools temporarily disables snapping.
- Added 2 more input and output connections (0 and 9) to circuit boxes to make it match the mux/demux components and use 0-indexing like other components.
- Increased the number of signal connections on relays from 2 to 5.
- You can no longer revive characters with CPR when the character has no oxygen available (e.g. by giving CPR to someone wearing a diving suit with an empty oxygen tank). Not only was this weird, it made it easy to farm medical skill by repeatedly reviving the character with CPR.

Multiplayer: 
- Fixed inventories and wallets sometimes resetting in multiplayer: more specifically, happened when a client was still connected to the server (for example in the lobby) and their character had despawned by the end of the round.
- Fixed characters sometimes suffocating or dying if loading into the round takes a long time. Now the characters don't spawn until the client has fully loaded into the round.
- Adjusted certain multiplier timeout thresholds to make errors such as "timed out", "expected old event" and "expected removed event" less frequent. Also made many of the timeout thresholds editable in the server config file (however, you should be careful when changing these values, as setting them too high may cause other issues).
- Fixed AFK setting staying enabled when a client chooses to load a campaign, causing them to load into a round with no character.
- Small improvements to the "direct join" prompt: autofocus on the text box, you can press enter to join.
- Fixed non-player teams being affected by the friendly fire setting (e.g. bandits were unable to damage monsters when friendly fire was disabled).
- Fixed input selector and output selector components' "move_input"/"move_output" signals not getting synced in multiplayer.
- Fixed a syncing issue with the timed detonators that made it possible to make them explode immediately at the start of the next round by letting the timer reach 0, and then putting an explosive inside and waiting for the next round.

Fixes:
- Attempt to fix reported freezes at 80% in the loading screen, which failed when the game failed to fetch an authentication ticket from Steam to be used for checking whether you've given consent to collect gameplay analytics.
- Fixed explosions not showing up on the sonar if you've selected a status monitor linked to the nav terminal, instead of having directly selected the nav terminal.
- Fixed reactors automatically adjusting themselves at the start of the round when the reactor is off or controlled by signals. The intention of the rapid autoadjustment is to make sure there's no overloads when the load suddenly drops as the sub starts receiving power from the outpost, but it should not run when the reactor is off or controlled by signals.
- Fixed fire damaging characters through walls that are just slightly damaged, and overall improved the logic for calculating fire damage through gaps.
- Fixed items sometimes disappearing when you drop them standing half-way through a door way (or more specifically, when the character is considered to be in the sub, but their hands are outside hulls).
- Fixed inability to undo nudging entities with arrow keys in the sub editor.
- Fixed adding water to newly added hulls not working in the sub editor until the sub is saved and loaded.
- Fixed monsters sometimes spawning near the enemy submarine when there's a sub-vs-sub mission active (sometimes leading to the mission completing by itself when the monsters manage to take down the sub).
- Fixed items such as the "diver's remains" loot appearing on sonar despite being in a monster's inventory. More specifically, affected items with a SonarSize greater than 0.
- Fixed tooltips not refreshing on the affliction icons above the character portrait (meaning if the strength of the affliction changed, changing the description, the old description would still appear in the tooltip).
- Fixed "eliminate thalamus" mission not working in MP's mission mode unless the difficulty is set above 50.
- Fixed outpost NPCs panicking and calling security when they saw you dragging a dead pet - they should only do so if you're dragging another outpost NPC's corpse.
- Fixed purchasing genes when your inventory is full causing the genes to automatically combine with any genes in your inventory.
- Fixed NPCs that are configured to dual-wield weapons (e.g. some elite bandits) only equipping one of the weapons.
- Fixed pumps calculating the desired water level incorrectly for linked hulls when controlled via the "set_target_level" input. 
- Fixed variants of husk infection always causing the "you try to scream but no sound comes out" message to pop up, even if the affliction doesn't prevent speaking (e.g. husk symbiosis). 
- Fixed ability to aim with the rifle scope when you're stunned/unconscious.
- Fixed circuit boxes not saving the wires if there's no components in the box.
- Fixed wires not getting transferred when swapping e.g. a blank loader to a flak cannon loader (or more specifically, to any loader with differently named connections) in the mission mode.
- Fixed fabricators showing thalamus veins as suitable materials for items that require a wire as a material.
- Fixed assigning a specific character to operate turrets throwing a console error ("Controller not specified") when there's only one turret in the sub.
- Fixed swarm feeders, or other monsters that can latch on to characters, deattaching when you ragdoll.
- Fixed monsters becoming unable to run (or swim fast) after they've used a rope attack (e.g. latcher's tongue or the fractal guardian's harpoon).
- Fixed machines (e.g. fractal guardians, defense bot) not being immune to the "infected wound" affliction.
- Fixed outpost events that should spawn things in mines often spawning them in some random module instead (e.g. the mudraptor eggs in the "occupational hazards" event).
- Fixed portable pump working without power.
- Fixed hidden missions showing up in the scrolling text that appears at the top of the screen at the start of a round.
- Fixed traveling tradesman talent giving a larger-than-intended sale price bonus for certain items. More specifically, it gave the 20% bonus for each tag the item had.
- Fixed icons of all afflictions (even hidden ones) briefly appearing above the health bar when a character dies.
- Fixed docking port staying open if you leave a level with some non-persistent sub (e.g. respawn shuttle or an enemy sub) docked to it.

Modding:
- Support for defining mission variants (the same way as e.g. item or character variants): allows creating variants of missions that change certain properties of the base mission without having to redefine the whole XML.
- Fixed ExplosionRadiusMultiplier not affecting the range of damage done to characters.
- Fixed items updating in preloaded characters' inventories. Meant that e.g. characters with a Disposable Diving Suit would appear to spawn with the suit already degraded or broken.
- Fixed fabricator icons using the inventory icon color even if the item has no inventory icon and uses the normal sprite (and its color) instead.
- Fixed crashing when an item fails to play a looping, streamed sound (e.g. because the maximum number of instances of that sound is already playing). Did not seem to occur in the vanilla game.
- Added support for configuring monsters as "multiplayeronly" in NestMission and MonsterMission (this worked in AbandonedOutpostMission and SalvageMission already, just hadn't been implemented here). 
- Fixed StatusEffect's Equip attribute only working if the item spawns in ThisInventory (not when it spawns it e.g. in SameInventory).
- Improved reactor modding compatibility: added the tag "reactoritem" as a containable item to allow items other than fuel to be contained.
- Fixed assault rifle defining the required ammo using the identifier "assaultriflemagazine" instead of the tag "assaultrifleammo", making it difficult to add new types of ammo for the weapon.
- Fixed fabrication being a lot faster than intended (= a lot faster than the RequiredTime set in XML) if there's no skill requirements. 
- Fixes characters never being considered "in water" for the first frame after they spawn, causing NotInWater effects to trigger on monsters spawning outside.
- When swapping a turret, the old turret's HudTint value is transferred to the new one.
- Fixed pump particles getting rotated incorrectly on mirrored pumps.
- Better Research Station modding compatibility: 
    - Added smallitem and mediumitem as containables to give more flexibility on what items can be put inside.
    - Increased the number of output slots to 3 to support recipes that produce more than 1 item, and to prevent from items falling out if the input is invalid and gets moved to the output slots.
- Fixed crashing when applying an affliction's status effects causes other afflictions to apply their status effects.
- Added a new "AffectedByAttackMultipliers" property to afflictions: can be used to prevent specific afflictions from being affected by Attack's damage multipliers. Buffs aren't affected by default.
- Added a new "VitalityLossRequiredForTreatment" property to afflictions: can be used to make bots treat afflictions even if the affliction doesn't cause vitality loss.
- Added a new "CanGiveMedicalSkill" property to StatusEffects: can be used to prevent the effect from giving the user medical skill, even if it causes healing.
- Made missions' SideObjective setting more useful for modders: previously all it did was affecting which beacon and hunting grounds missions can get "spontaneously" selected for levels with beacons and hunting grounds. Now all side objectives available in a level are automatically selected, without having to manually select them in the mission selection UI.
- Set mantis's group to "mantisoid" and watcher's to "watcheroid" (doesn't do anything in the vanilla game but useful for mods).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.10.7.2
-------------------------------------------------------------------------------------------------------------------------------------------------

- Improvements to the spam server filtering.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.10.7.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Additional fixes to multiplayer exploits.
- Fixed inability to rename a bot you've taken over in permadeath mode.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.10.7.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Additional fixes to multiplayer exploits.
- Fixed crashing when editing a beacon station's, wreck's or enemy sub's min/max level difficulty settings in the sub editor before you have saved the sub for the first time.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.10.6.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed contextual orders no longer working even if you were within radio/speaking range of a bot.
- Fixes to several multiplayer exploits, including one that allowed clients to cause server-side lag by sending specifically crafted messages to the server, even if the server didn't allow them to join.
- Fixed a bug caused by the water flow changes in the previous update: water flow through gaps in inside the submarine was much faster than intended when there were multiple breaches on the submarine's outer hull.
- Reduced the water flow through gaps when the hulls on are not linked. Linked hulls are intended to behave as if they were one room, and should allow unrestricted water flow.
- Railgun shells now disappear shortly after the first impact: the change in the previous update (which allowed them to penetrate multiple limbs/targets) had the side-effect that a shell that went through a single limb could fall back on the submarine and still do full damage.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.10.5.0 (Autumn Update 2025)
-------------------------------------------------------------------------------------------------------------------------------------------------

Balance:
- Railgun rebalance: The railgun has been deemed on the weaker side by the community. It has been given a satisfaction pass, where now the high-power shell behaves more as expected, capable of penetrating multiple limbs or submarine walls, dealing more damage.
- Broad-spectrum Antibiotics now affect all limbs with infected wound with one application, but cure less infection per limb. Base prices for Plastiseal, Antibiotic Glue and Broad-Spectrum Antibiotics have been adjusted.
- Antibiotic Glue is now less effective on healing burns, bleeding and infections and inflicts organ damage even with successful application (and even more with failure). 
- Added a pass to make grenades more easy to aim (and less likely to always hit the wall in the back due to excessive sliding/rolling)
    - Reduced and equalized throwforce of most throwables (grenades, explosives) to 3.5 (some were 3.5 already, some 4.0).
    - Add angular dampening on grenades to reduce excessive sliding/rolling.
    - Frag grenade now uses a rectangular body instead of round/capsule, to avoid rolling too far (more in line with other grenades).
    - Reduced throw force when aiming throwables downwards.
- Lower the rate at which skyholder artifacts and portable pumps drain water (both were way too effective for managing leaks).
- Made all variants of fractal guardians vulnerable to EMPs.
- Security NPCs on submarine encounters are now better armed, with weapons fitting the faction.

Blueprints:
- Added new "blueprint" type of items, which unlock crafting recipes.
- Three new alien material blueprints: physicorium, dementonite (gravity) and incendium, which unlock relevant (ammo) recipes.
- Alien blueprints need to be researched at a Research station.
- Merchants of all factions now sell item blueprints fitting to the faction's identity, locked behind reputation.

Miscellaneous changes:
- Made vent sounds a bit more quiet.
- Made crate shelf and makeshift shelf container UIs vertical to match the look of the sprites.
- Made some items be attachable only to the floor.
    - Planters cannot overlap, and attach only to the floor, rather than attaching to the wall.
    - Makeshift shelves are attached to the floor.
- Outpost NPCs react to players dragging other outpost NPC's corpses. Normal NPCs flee, security arrests you.

Fixes:
- Fixed gaps significantly slowing down the flow of water, especially when water is flowing up through the gaps.
- Fixed PvP outpost selection not working reliably (when you selected some specific outpost, it was possible for some other outpost to get selected regardless).
- Fixed bot AI not running if a bot below 0 vitality is forced to stay unconscious with e.g. adrenaline or talents.
- Fixed incorrect offset on the light that renders on a boarding pod that's in a loader.
- Fixed defense bot only escaping if it attemps to fire it's weapon and fails due to being out of ammo, but not when it doesn't have any ammo available.
- Fixed outpost NPCs sometimes spawning on non-human spawnpoints, e.g. the monster spawnpoints in research modules.
- Fixed NPC conversations about the submarine being very deep starting to appear too late (at the point when the sub is already at crush depth, instead of the point where camera shake and audio effects start appearing). 
- Fixed yet another issue with modded hairs: hairs got misaligned in the bottom-right character portrait if they were set to inherit the origin of the head sprite, and the head sprite's origin was not at the center.
- Fixed all pets in the level getting added to the player crew at the end of a round, e.g. even hostile pets or pets inside beacon stations.
- Fixed id cards only being sold in normal outposts and cities (not mining, research or military outposts).
- Fixed loading screen tips often cycling too fast to read during the initial loading screen.
- Fixed "Find Jacov Subra" mission completing if you enter the outpost he's hiding in, even if you don't find him.
- Fixed vents' oxygen output warning being incorrectly shown when vents have been moved between hulls in the sub editor.
- The "drop item" hotkey is disabled when the inventory is not visible (e.g. when operating a turret).
- Fixed inability to issue orders that don't target any character in particular (e.g. ignore or deconstruct orders) when no-one can hear the order.
- Server log fixes:
    - Fixed new lines added to the log ignoring the filtering.
    - Fixed log jumping up when new lines are added while you've scrolled up to read older messages.

Modding:
- When saving a submarine or an outpost in the editor, the game suggests saving it in a subfolder that contains subs of the same type instead of always saving it in the root folder of the mod.
- Fixed "Equipped" item requirement only checking held items, not worn items as the documentation says.
- Option to define tags for wrecks and beacon stations in the sub editor, and to make a wreck or beacon mission choose a random wreck or beacon station with the specified tags using the attributes "BeaconTags" and "WreckTags".
- Fixed new elements defined in an item variant failing to be added to the variant if there's ClearAll elements present.
- Fixed submarine upgrade UI displaying an incorrect icon on items that don't have an inventory icon but use the item's normal sprite instead.
- The "sort stacks" and "merge stacks" buttons can be hidden from containers using the attributes "ShowSortButton" and "ShowMergeButton".
- Changed how store item availabilities work by default: if no min/max amount is defined, there can be 0-5 items available instead of there always being 5.
- Some new decorative outpost props: empty versions of the existing storage shelves which contained some decorative items.
- Fixed game freezing if a bot uses a weapon that has both a RangedWeapon and a RepairTool component. 
- AnimController properties can now be accessed using conditionals.
- Fixed bots being able to unequip and reload non-interactable items if they have those in their inventory (e.g. if some custom event forces them to spawn with non-interactable items).
- Fixed corpses spawning in wrecks that have neither human or corpse spawnpoints (making it impossible to create wrecks with no corpses).
- Fixed unnecessary console errors about failing to load a texture when trying to preload some monster/enemy with [GENDER] tags in the filename.

﻿-------------------------------------------------------------------------------------------------------------------------------------------------
v1.9.8.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed RegEx components occasionally timing out for no apparent reason (even if the expression isn't particularly performance-intensive). Seemed to have been caused by RegEx changes in .NET 8.
- Fixed the game sometimes freezing for a long time at a specific point during the loading screen. Only affected some players: the issue had to do with the game failing to connect to a server to check whether the player has given their consent collect gameplay analytics.
- Fixed streamed sounds always starting from the beginning when they're re-played. Particularly noticeable in the night club modules, when the music always starts from the beginning if you step outside the range of the sounds. 
- Fixed distance attenuation and positioning not working on the music played by jukeboxes and bar speakers (meaning they'd play at full volume regardless of your distance to the speakers).

Modding:
- Fixed oneshot delayed effects (which should only ever trigger once) still continuing to run some of the logic after the first trigger, causing an unnecessary performance hit. Did not seem to affect any vanilla items.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.9.7.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Multiplayer:
- Fixed anyone being allowed to modify turrets and the sub's upgrades. Now it requires campaign management permissions.

Modding:
- Fixed only the first OnInserted effect defined for an item being executed when the item is placed in a container.
- Fixed conditional's TargetSelf property not working on melee weapons.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.9.6.0 (Summer Update 2025)
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes and additions:
- Added Power Distributor item. Includes 8 power outputs and sliders that can be used to control how much of the input power is distributed to each output. Can be used to, for example, build a circuit that redirects power from less vital systems to weapons or pumps in an emergency.
- Added Rifle Scope.
- Better Steam Timeline support: when recording gameplay using Steam, the game adds markers about notable events in the game.
- Added scaling and rotation tools to the submarine editor. Enabled using buttons in the top-right corner of the editor.
- Characters don't throw flares when also holding a ranged weapon (allows shooting with a flare in hand).
- Improvements to pets (kudos to uberpendragon): improved ragdolls and animations, gave them head slots so they can wear hats, added damage modifiers to shells.
- Mindwipe resets the extra talents gained via the assistant's Apprentice talent tree, preventing the use of Mindwipes as a way to make an assistant unlock the specialization trees of all classes.
- Alien Blood is now less powerful, by curing less "Bloodloss" affliction and causing more psychosis. It is widely available and made saline and blood packs pretty redundant. It now also requires more medical skill.
- Added option to filter by name and to change the sorting of the save files listed in the "load game" menu.
- Made circuit boxes' external connections (the once that hook up to other items) use the same labels that have been set inside the circuit box.
- Made the freecam console command a toggle: entering it again gives you back control of the character.
- Added "loslightingfreecam" console command (convenient for testing, executes those 3 commands).
- Upgraded to .NET 8. This should not cause any noticeable changes, aside from perhaps very minor performance improvements. Allows code mods to use C# 12 features.

Multiplayer:
- Fixed sending rapid reports of leaks, fires, enemies etc easily causing the spam filter to kick players with no warning. 
- Added buttons for selecting or deselecting all mission types to the server lobby's mission type selection.
- Fixed wall damage desyncing if you purchase wall repairs in an outpost, undock and then save and reload (the walls would appear repaired client-side, even though they're actually broken server-side).
- Fixed the "nudge buttons" that appear next to the nav terminal's docking button not working in multiplayer.
- Fixed oxygen and fuel tank explosions not appearing client-side in multiplayer, making it seem like you're taking burn damage out of nowhere when you happened to be near one an "infinite explosion loop" (described below in the fixes section).
- Fixed players only getting a karma penalty for overheating the reactor if they stay at the reactor.
- Fixed another networking issue that sometimes caused the biome and outpost selection dropdowns to break in the server lobby, causing the clients to constantly spam the server with requests to change the biome/outpost.

Optimization:
- Optimized memory usage of text files. Now only the text files for the language you have currently selected are kept in memory.
- Optimized the memory usage of submarine files. Previously the XML of all the enabled submarines was kept in memory, causing excessive memory usage when you have a ton of custom submarines installed.

Fixes:
- Fixed oxygen tank shelves sometimes causing "infinite explosion loops", when tanks in the shelves exploded other tanks while the shelves were filling the tanks.
- Fixed camera not following your character when ragdolled/unconscious.
- Fixed "unsubscribe" option not showing up on the mod list on mods that have pending updates. 
- Fixed NPCs spawned by events sometimes spawning inside jail cells in outposts.
- Fixed clowns never turning psychotic in the clown escort missions (there should be a small chance of that happening as the mission progresses).
- Fixed talent progress not being mentioned in the tooltip on "extra talents" (talents unlocked from outside the tree).
- Fixed salt bulbs exploding immediately in water (as opposed to having a small delay like other water-reactant items).
- Fixed hair and other attachment sprites still being misaligned in some UIs (character creation menu and outpost medic UI) if their origin doesn't match the head's origin.
- Fixes to several outpost and ruin generation issues:
    - Pre-built "fallback outposts" sometimes spawning instead of a proper outpost, and sometimes even instead of a ruin.
    - PvP outposts still sometimes generating outside the PvP mode (particularly when using mods with new location/outpost types).
- Fixed some consumables (e.g. energy drinks, beer, protein bars) getting consumed immediately if you hit E while drinking/eating.
- Fixed lights rendering upside-down on planters that have been flipped horizontally.
- Fixed inability to sit while using a surveillance center.
- Fixed option to give an item to another character showing up when you drag a large item (an item that won't go in the inventory slots) over someone, even though these items can't be given by dragging and dropping.
- Fixed ability to give characters multi-line names, which would break some UI elements.
- Fixed spawncharacter console command spawning monsters in the player team if the team argument is not given.
- Fixed R-29's bottom wall not leaking. Might've affected other submarines as well: there was a bug in the logic that prevents overlapping walls leaking faster than individual walls, which caused the game to sometimes interpret large gaps next to the wall as "overlapping walls".
- Fixed fabricator no longer communicating in any way when an item can't be fabricated because it requires a recipe.
- Fixed inability to focus on unconscious characters by clicking on the crew list.
- Fixed parts of the Jove sculptures found in ruins being misaligned in mirrored levels (= when travelling through the level backwards).
- Fixed the Multi-tool not functioning as a screwdriver for event checks.

Changes and additions:
- Upgraded to .NET 8. This should not cause any noticeable changes, aside from perhaps very minor performance improvements. Allows code mods to use C# 12 features.
- Added option to filter by name and to change the sorting of the save files listed in the "load game" menu.
- Made circuit boxes' external connections (the once that hook up to other items) use the same labels that have been set inside the circuit box.
- Made the freecam console command a toggle: entering it again gives you back control of the character.
- Added "loslightingfreecam" console command (convenient for testing, executes those 3 commands).

Fixes:
- Fixed bots being reluctant to go into rooms with low oxygen, even if they're trying to get diving gear from that room.
- Fixed "fake fires" you see when under psychosis sometimes turning into real fires in single player.
- Fixed PvP mode weapon crates showing up in the sub editor.
- Fixed undoing the removal of an item from a container sometimes causing a crash in the sub editor.
- Fixed hulls extending below the floor in Kastrull's drone and the lowest deck, preventing them from draining fully.
- Fixed endworm's jaws sometimes doing AOE damage to characters after the endworm has died.
- Fixed rotated structures not appearing rotated on the sonar.
- Fixed talent refund points getting lost on save and reload.
- Fixed multi-part subs (subs consisting of multiple docked subs with other subs ducked to them) getting flipped incorrectly in PvP mode. 
- Fixed "teleportsub endoutpost" crashing the game when a level is not loaded (e.g. in the sub editor's test mode).
- Fixed selected outpost module sometimes not loading in the sub editor's test mode, and a random outpost generating instead.
- Fixed pre-built "fallback outposts" failing to load in the sub editor (generating a full outpost instead).
- Fixed ability to put items in locked containers (e.g. running deconstructors) by hitting the drop key.
- Fixed wearing "mother's providence" and "mother's countenance" (special clown suits worn by the Jestmasters) not unlocking the "Praise the Honkmother" achievement.
- Fixed "secondary explosion" 2 seconds after a gravity shell has exploded and disappeared. 
- Yet another fix to contained items rendering incorrectly on flipped items: affected contained items that are set to draw at an angle of 90 degrees relative to the container (e.g. fuel rod in a rapid fissile accelerator), causing them to draw backwards.
- Hid PvP weapon crates in the sub editor (because these require the PvP event and do nothing by themselves when placed in the editor).
- Fixed inability to make motion sensors react to non-humans that are in the "human" group (e.g. some custom android type of character) - they were not considered either humans, pets or monsters. Now characters in the human group are treated as humans, except if they're pets (in that case the sensor only triggers if set to trigger on pets).
- Fixed "firing blanks" traitor event requiring you to replace standard coilgun ammo boxes with fake ones, instead of accepting any type of coilgun ammo.
- Fixed PvP variants of underwater scooters sometimes spawning in cabinets in the campaign.

Modding:
- Better support for configuring custom location types and configuring where they appear. Examples in the locationTypes.xml file.
    - You can spawn a fixed number of a location type on the map (e.g. to have unique named locations).
    - More control where specific location types spawn (e.g. near the beginning of a biome).
    - Location types can be configured to "inherit" things such as event or outpost modules from another location type.
- Escort mission fixes and improvements:
    - Fixed ""terroristAnnounceDialogTag" being completely ignored, making the terrorists always say the default separatist lines regardless of what's configured in XML.
    - Added support for spawning multiple items for the terrorist, or optionally choosing random ones using a "ChooseRandom" element. Previously only one random item was chosen.
    - Added some documentation for the mission type.
- Added support for making an item variant clear all elements of a certain type from the XML. Done by adding the element <ClearAll> to the item variant, and then defining the elements to clear as it's child elements (e.g. <Fabricate /> would clear all fabrication recipes).
- Support for streaming any audio clip instead of loading them into memory (previously streaming was only supported for background music). Enabled by adding stream="true" to the sound element. Recommended for longer audio clips (such as music tracks played by items). Please note though that streaming audio comes with some CPU and IO overhead, so it's not recommended to blindly enable it on everything.
- Fixed specific kinds of looping sounds sometimes not playing in multiplayer (specifically, long sounds that are triggered right at the start of the round by a status effect, but not in the player's hearing range, e.g. rave music in Dynamic Europa's pirate outposts).
- Fixed NPCs made to hold an item using NPCOperateItemAction repeatedly equipping and unequipping it.
- Fixed delayed effects executing at the position where the entity was when the effect was triggered, not where the entity is when the delay passes.
- Fixed salvage missions causing a crash and the "interact" target type not working if the target item has no physics body.
﻿- Fixed performance issue caused by <RequiredItem> element when using an invalid item identifier.
- Fixed colored text not working in the options in conversation prompts.
- Added CameraAimOffset property to Holdable component. Allows modifying how far the camera can be offset when aiming, making it possible to implement e.g. scopes.
- Added AbandonOnReset property to CombatAction and NPCWaitAction.
- Fixed some issues with PvP outpost selection that made it difficult to implement custom maps:
    - If a mission was set to use a PvP outpost with some custom tag, the game might still not use it, because it chose the PvP level generation parameters, which would enforce an outpost with the vanilla "PvPOutpost" tag. Now the game tries to choose an outpost with the specified tag regardless of the level generation parameters.
    - When "random" was selected on the outpost dropdown, the game would choose any random outpost without taking the selected mission into account.
- Fixed sounds configured to loop while an item is worn not stopping when the item is unequipped. Did not affect any vanilla items.
- Option to force a specific type of location as the campaign's start location by adding ForceAsStartOutpost="true" to the location type config. Ignored when the tutorial is enabled.
- Option to disallow attaching items over specific kinds of other items (e.g. DisallowAttachingOverTags="container,wallattachment").
- Fixed inability to make motion sensors react to non-humans that are in the "human" group (e.g. some custom android type of character) - they were not considered either humans, pets or monsters. Now characters in the human group are treated as humans, except if they're pets (in that case the sensor only triggers if set to trigger on pets).
- Fixed OnInserted status effects triggering when loading a submarine/container which already contains items. Now the effects only trigger when the item is placed in the container.
- Fixed ability to equip/unequip noninteractable items using the "quick use" button above the slot. Only affects modded content (non-interactable items that are forced into a player inventory).
- Fixed Items' HasBeenInstantiatedOnce property not being saved, making it basically unusable.
- Fabrication recipes can be unlocked using StatusEffects (e.g. unlockrecipe="autoinjectorheadset").
- Fixed SpawnRotationType.This not doing anything if the item executing the effect doesn't have a physics body, or if it's attached to a wall (which makes the item "temporarily" not have a body).
- Hidden missions (ShowInMenus="false") don't show up on the campaign map nor the mission selection panel. In the vanilla game, all hidden mission were triggered when the round starts so they wouldn't be visible there anyway, but that may not be the case with modded missions.
- Added CauseOfDeathType property to Character. Not used by the vanilla game, but can be used by mods to check the cause of death of the character using conditionals (e.g. if some OnDeath effects should or should not be triggered by certain causes of death).
- Support for animated affliction overlays (works the same as the animated HUD overlays on items such as the surveillance cameras).
- More options for configuring how Holdable items can be attached to the sub: AttachesToFloor (when enabled, the item can only be attached to a position where it touches the floor), AllowAttachInsideDoors (enabled by default), DisallowAttachingOverTags (tags of items the item cannot attach over).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.8.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed client list often appearing empty in the server lobby when joining mid-round while a campaign was active.
- Fixed job variant selection panel rendering below the job selection panel, often making it unusable.
- Fixed job variant selection only working in the server lobby, not in the tab menu mid-round.
- Fixed inability to preview loadouts if there's only one variant of a job available (e.g. assistants).
- Fixed fires no longer spreading from room to room.
- Fixed a pathfinding issue that sometimes caused both to get stuck running back and forth towards the target they're trying to reach (one common place where this occurred was Barsuk's engine room).
- Fixed non-hitscan projectiles such as harpoons launching with an incorrect rotation when fired to the left.
- Fixed Herja not having any assistant or non-job-specific spawnpoints, causing assistants and custom classes to spawn at other classes' spawnpoints, potentially giving them ID card tags they shouldn't have.
- Autoinjectors no longer inject meds on dead characters (even though they are technically below the health threshold at which the autoinjection should trigger).
- Fixed team argument not working on the "spawncharacter" console command when spawning non-humans.
- Fixed some edge chunk objects in hydrothermal wastes and the great sea spawning in front of the level walls.
- Fixed missing gap in one of the new crew modules, which prevented water and oxygen from flowing through the module properly.

Modding:
- Fixed transferring afflictions to a newly spawned character using status effects causing a crash if the original character had already been removed. Didn't affect any vanilla content.
>>>>>>> master

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.7.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed an AI bug that made bots scared of water, making them seek safety from flooded rooms even when they were wearing diving suits.
- Fixed non-hitscan projectiles registering hits with characters that are behind the weapon, even if the barrel is in front of the character.
- Fixed submarine maintaining an incorrect position (= starting to steer somewhere completely off) when you enable "maintain position" and then enter a new level.
- Fixed autopilot failing to navigate to a destination if it's already on at the start of the round.
- Fixed dedicated server descriptions still sometimes getting truncated.
- Fixed lights shining out from items inside character inventories.
- Fixed inability to access the inventories of other players when they're manually ragdolling.
- Fixed "firing blanks" traitor event requiring you to replace standard coilgun ammo boxes with fake ones, instead of accepting any type of coilgun ammo.
- Fixed switches flipping around when you attach them while facing left.
- Fixed grenade "cooking" hint not showing the correct keybinding (just saying [usekey] instead of the actual keybinding).
- Fixed main menu notifications (changelog, unstable info) staying open if you don't manually close them and e.g. start a new game or go to the sub editor.
- Fixed normal outpost events triggering in outpost that have been abandoned because of Jovian Radiation.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.6.2 (Calm Before the Storm)
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed some icons still scaling incorrectly (e.g. location icons on the campaign map, device icons on the status monitor).
- Fixed device previews not appearing in the shipyard menu when you've selected a category with only swappable items but no upgrades (doesn't affect any vanilla content).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.6.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed an issue that caused the scaling of item icons in the submarine editor (and potentially other places) to be incorrect.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.6.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed certain scripted events breaking when you switch the character (e.g. interaction icons disappearing from some NPCs).
- Fixed hostages being hostile to you and the outpost team in jailbreak missions.
- Fixed inability to communicate using the headset with characters spawned via the debug console (once again).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.5.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Updated translations.
- Fixed "favorite" checkbox rendering behind the server settings button in the server lobby.
- Fixed server not allowing new characters to be hired to the reserve bench if over the maximum crew size.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.4.2
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed PvP variants of the underwater scooter being sold in campaign stores.
- Hid the new sorting and filtering options from vending machines.
- Fixes to several AI issues that sometimes made it difficult for monsters to board the sub (e.g. repeatedly moving in and out of the airlock).
- Fixes to issues that sometimes caused monsters that are indoors to attempt to attack a target through a wall/floor/ceiling even if they have a valid path to the target.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.4.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed characters sometimes ending up in an invalid state when a player goes back to the server lobby, opts to spectate and rejoins the round: the character wouldn't go unconscious or braindead as it should, but the client would not regain control of it either.
- AI characters no longer accidentally hit friendly characters with melee weapons.
- Fixed bots not reacting to enemies while following, unless being attacked.
- Fixed bots being allowed to operate items in unsafe hulls, meaning they'd attempt to get to a device in a room with e.g. monsters or fires, and then immediately flee, and repeat.
- AI fixes to make characters better at dealing with fires.
- Fixed bots getting stuck in ladders while following the player and aiming at the enemy.
- Fixed bots not facing the enemies (or sometimes glitching while trying to face both the player and the enemy) while following a player.
- Fixes to several AI issues that caused issues when bots where trying to find safety.
- Fixed bots sometimes changing targets when they should just stick to the current target, causing indecisive behavior.
- Made bots crouch by default when using ranged weapons, so that other bots (or players) can shoot past them. 
- Improved AI behavior in close combat: when a bot has a valid ranged weapon in the inventory, they now try to keep the distance to the target and switch back to the ranged weapon when possible. Previously the bots just used melee, because they can't shoot the targets when they are really close.Improved AI behavior in close combat: when a bot has a valid ranged weapon in the inventory, they now try to keep the distance to the target and switch back to the ranged weapon when possible. Previously the bots just used melee, because they can't shoot the targets when they are really close.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.8.4.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes and additions:
- Added PvP versions of outpost levels for all biomes. Previously the outpost deathmatch rounds always used cold caverns levels despite the biome setting (which doesn't make much difference in the vanilla game since you don't usually go outside, but can be more relevant in custom outpost deathmatch missions).
- New alien ruin "outpost" for the outpost deathmatch mode.
- Reworked the loading screens with new handmade art.
- Visual improvements to cold caverns and great sea.
- Reworked the decorative "background fish" that wander around in the levels.
- One small endgame lore related outpost event.
- Renamed and recategorized a bunch of structures to make them easier to find in the sub editor.
- Reworked abandoned outpost modules, added 14 new modules. Kudos to NotWendy!
- Reduced the health of outpost security.
- Outpost security can spawn more batteries and ammo for themselves (making them better at defending themselves, compensating for the reduced health).
- Reorganized abandoned outpost mission types in the server lobby screen (separate types for assassination, destroy monsters, rescue and destroy outpost missions).
- Increased outpost wall health and made the junction boxes in outposts more resistant to overvoltage.
- Improvements to fabricator UI to make it dump less information on the player (especially new players): more options for sorting the items, option to only show the items you can currently fabricate.
- The console commands heal, teleportcharacter and godmode accept “/crew” and “/me” as arguments (making the command apply to either the whole crew or your current character).
- Added “killall” console command: kills every character in the level (players, NPCs, monsters).
- Added “spawnnpc” command: spawns a pre-configured NPC from a prefab.
- Added some sounds and particle effects to drinkable/edible items.

Reserve bench
- Added “reserve bench” feature to multiplayer campaign: bots can be hired to a “reserve bench” instead of active duty, which means they won’t spawn until a player chooses to take them over after dying in the permadeath mode, or until they’re moved to active duty in the HR manager interface in an outpost.
- Allows hiring bots as “backup characters” for the permadeath mode, without having to have the bots as active characters in the crew.
- Also usable when permadeath is not enabled: allows you to for example hire a high-level character you happen to come across for future use.

Alien ruins:
- New alien ruin modules ("husk maze", "toxins maze", "hazard maze"). 
- New "Lost in Ruins" ruin mission.
- Artifacts always spawn in artifact holders in ruins, even if you don't have an artifact mission active.
- Fixed doors that allow fractal guardians to pass through in ruins sometimes getting stuck.
- Fixed ruins sometimes spawning partially inside level walls.

Submarines:
- Reworked the Remora and updated the description to match. The layout should now be less confusing, and the auxiliary engine works with batteries. Added a brig and dedicated gunnery compartment. The drone is also reworked and has tougher shells.
- Minor visual touch-ups to the Kastrull and the Winterhalter.
- Kastrull glass windows at the navigation terminal have increased health.
- Option to disable wall collisions in the sub editor.
- Increased the output of the Typhon's oxygen generator to fix prisoners suffocating in the brig.

Radiation changes:
- Improvements to Jovian radiation: the intensity of the radiation increases when you're deeper in the radiation zone, and eventually becomes too intense to counter with Hazmat suits or PUCS.
- Jovian radiation buffs certain monsters instead of killing them.
- Fixed radiation sickness causing burns at a rate relative to the number of limbs a character has (making characters with lots of limbs take more damage).
- Radiation sickness does less damage at low levels and can wear off a bit faster.

Fixes:
- Fixed particles jittering when the submarine moves.
- Fixes to columns being misaligned and some columns being too narrow on the tab menu's crew list and round summary.
- Fixed ammo boxes (coilgun, chaingun, pulse laser) still firing one more round after appearing empty.
- Fixed grabbing another character causing the inventories to overlap on certain resolutions and higher inventory scale settings.
- Fixed long server descriptions getting cut off on the server list on dedicated servers.
- Fixed "light tower" item emitting light from the center instead of the top of the sprite.
- Fixed perks affecting the enemy sub in "Enemy submarine" missions in mission mode.
- Fixed genes that give you buffs when you receive damage getting triggered by the organ damage you get when you remove the genes.
- Fixed "dying" due to a disconnect giving you the permadeath achievement when permadeath is enabled (despite the death not counting as a "real" permanent death).
- Fixed items held by monsters that are currently inactive appearing at level origin (most often, the weapons held by fractal guardians).
- Fixed deconstruction output not getting automatically moved from the outpost to the main sub the next round if a bot deconstructs something in the outpost, and the item has to be dropped on the floor because there's no more space in the deconstructor's output slots.
- Fixed afflictions' periodic effects (for example, vomiting triggered by nausea) often appearing with some delay client-side.
- Fixed disabling boss health bars also disabling mission progress bars.
- Fixed "path unlock" NPCs sometimes spawning in jail cells.
- Fixed merchants sometimes selling an item they're requesting for less than what they're willing to pay for it.
- Fixed mission state resetting when you save and quit at a friendly outpost. This meant that you could e.g. kill and loot a target you're meant to assassinate, save and quit, and then kill and loot them again.
- Fixed inability to unlock the path to the next biome with reputation if your reputation goes over the threshold during the round (= you needed to already be above the threshold at the start of the round).
- Fixed a rare crash on startup due to an exception in TextManager.TrimSpeciallyHandledCategoriesCache.
- Fixed detonators blowing up even if you remove the explosive before the timer runs out.
- Fixed research station not having a broken version of the sprite.
- Fixed events disappearing from the outpost if you complete a clown or husk cult event and save and reload.
- Fixed artifact missions potentially targeting an artifact inside the sub, instead of spawning the artifact in an abyss cave, beacon station or the abyss like they’re supposed to.
- Fixed locking an item UI and starting a new round sometimes causing it to overlap with other UIs.
- Fixed assistant talent "Tasty Target" affliction not having an icon.
- Fixed afflictions from talents not having a tooltip describing the actual benefit / effect on the affliction.
- "Beat Cop" talent now also affects "Zapped", making it work with Stun Baton / Stun Dart items.
- Fixed inability to play with husked storage containers.
- Fixed opening the command menu in the sub editor's test mode and then switching back to the editor preventing interactions with inventories.
- Fixed sub editor crashing when you delete a wire that's in a circuit box by some other way than the circuit box UI (e.g. by selecting and deleting all wires), and then attempt to save a sub.
- Fixed outpost modules (most often, mine modules) sometimes overlapping with the sub when docked to the outpost.
- Fixed skills getting clamped below the maximum if they've been set above the max with e.g. console commands or modded content.
- Fixed thalamus organs/devices rendering in front of most dropped items.
- Fixed hitscan projectiles not damaging walls outside your own sub when the gun is fired from inside the sub.
- Fixed boarding pods going through indestructible or very tough walls.
- Fixed characters not taking fall damage when they land on a hatch.
- Fixed outposts sometimes having really short hallways between modules. Happened when the modules needed to be moved away from each other just a bit to prevent overlaps between modules: now when they need to be moved, the hallway is forced to be at least 2 meters long.
- Fixed inconsistent draw order between non-damaged and damaged walls (doing damage on a wall sometimes caused the draw order of the walls to change).
- Fixed decorative sprites rotating incorrectly on held items (e.g. the fans on artifact transport case drawing at an incorrect position).
- Fixed items inside items having the “stolen” icon when the team of a character changes to the player team mid-round (e.g. when you hire one of the special faction NPCs).

Optimization:
- Fixed acid clouds spawned by watchers causing a significant performance hit.
- Optimization to situations where the game attempts to loop the same sound multiple times at the same time. Commonly happened when near a large number of hydrothermal vents and lava vents at the bottom of the sea.
- Optimization to situations where the game tries to spawn a very large number of particles at the same time. Commonly happened when near a large number of hydrothermal vents and lava vents at the bottom of the sea.
- Optimizations to reduce save file sizes (which matters in MP because the save files are frequently sent to clients).
- Fixed an issue that occasionally caused performance drops in the outpost deathmatch mode.
- Fixed guardian repair bots causing significant performance hits especially when there's several of them repairing at the same time.

Multiplayer:
- Fixed a syncing issue that made very short (<1s) stuns almost always cause some desync and rubberbanding.
- Fixed a syncing issue that caused inaccuracies in the rotation of the character's collider, often leading to rubberbanding when swimming (since the rotation of the collider affects swimming speed: characters swim faster when they're facing the movement direction).
- Fixed "error while reading a message from server" when moving a docking port's connection panel in multiplayer.
- Players (excluding the host) can return to the lobby without ending the round for everyone. Added an "AFK" checkbox in case a player wants to stay in the lobby when a new round starts.
- Fixed dialog prompts from certain events sometimes triggering when the players are still loading into the round, causing the players to miss the prompt and making them unable to continue the event. Happened for example with some of the events that allow you to hire a special faction NPC.
- Fixed duplicating items by allowing a disconnected player to despawn, taking their items from the duffel bag, and then having that player rejoin and respawn with the same items.
- Fixed players being unable to fabricate items unlocked with bots' talents.
- Fixed errors and disconnects if a new campaign round starts while you're still loading into the previous one.
- Fixed Camaraderie talent icon starting to flicker in multiplayer after a crewmember has died.
- Added a customizable permission preset file (Data/permissionpresets_player.xml) which can be edited without game updates overwriting it.
- Fixed hostage missions displaying as completed even if the hostages have been killed.
- Fixed radio channel presets not persisting between rounds in multiplayer.
- Fixed bot disappearing from the crew if you take control of it with SetClientCharacter, then switch back to your original character, and save and quit.
- Fixed spectators only hearing characters when the camera is within speaking distance (should be based on the radio range if the character is speaking through radio).
- Fixed respawn shuttle dropdown not displaying the name of the selected shuttle (just said "shuttle").
- Fixed paths between biomes unlocked during the round showing up as locked to midround-joining clients. 
- Fixed several issues with conversations that target a specific player: e.g. in the "husk cultist" event it was possible for other players to deliver the eggs the cultist was requesting from a specific player.

AI:
- Fixed a handful of bugs that occasionally caused bots to get stuck on ladders.
- Fixed bots sometimes saying "can't reach [name]" (with the variable not getting replaced by the actual name) when they can't get to a target they're trying to give medical assistance to.
- Fixed bots disguised as husks not targeting husks with turrets.
- Fixed many NPCs ignoring threats, because they were set to wait with 100 priority. Exposed the objective priority for NPCWaitAction and NPCFollowAction.
- Fixed bots with the operate item objective always reacting to fires (and enemies), regardless of the size of the fire and their objective priority.
- Fixed fires close enough to damage not always being considered threats.
- Fixed the find safety objective triggering from enemies/fires, even when ordered to follow.
- Fixed and changed how the bots behave in combat while following/holding position. Now they should stick to the follow/hold position more obediently, yet still should be able to fight back.
- Fixes and changes to how bots react to enemies attacking other bots. Made the security officers be less reactive to hostiles when they have an active order (e.g. operate the turrets).
- Fixed bots attacking handcuffed enemies.
- Fixed outpost security officers reacting if bots take diving gear or fire extinguishers in emergency situations (they shouldn't steal items otherwise).
- Fixed bots not being able to steal oxygen tanks for existing diving gear in emergency situations.
- Fixed bots seemingly ignoring oxygen tanks inside diving gear in containers (also affected other items).
- Bots now drop all stolen items when being inspected, instead of getting arrested because of them.
- Fixed outpost security officers doing inspections in unsafe rooms, such as when they are flooded.

Modding:
- The "decorative background creatures" can be edited in the level editor.
- Fixed event sets with SelectAlways set to true getting selected despite their commonness being zero.
- Fixed level wall damage done by Attacks ignoring damage multipliers.
- Show a warning when enabling a mod that requires some other Workshop mods that aren't currently enabled.
- The “RequiredDeconstructor” attribute now defaults to “deconstructor” on all items when not defined. This means that vanilla items are now only deconstructible in items with the identifier or tag “deconstructor”, which makes it a lot easier to create custom deconstructors that can only deconstruct some custom items (just leave out the “deconstructor” tag and use something else instead).
- Fixed turret barrels getting hidden when the static part of the turret goes off-screen if the turret only has the "rail sprite", but not the barrel part that moves back and forth when firing.
- Note for modders: the issue with ammo boxes spawning one extra round happened because the boxes executed an OnUse effect to spawn an item in the box, and then reduced the condition, which meant that on the last shot that took the condition to 0 they would still spawn a projectile in the box. If your mod uses a similar approach, please check the vanilla ammo boxes for an example on how we handle the spawning now.
- Added a LightOffset property to LightComponents (can be used to make the item emit light from somewhere else than the center).
- Made "residual waste" and "mass production" talents a bit more modder-friendly. The former had a chance of duplicating deconstruction output and the latter a chance of not consuming some of the fabrication ingredients. It was hard to exclude items from those talents though: addressed that by making them ignore items with the tags "disallowduplicatedeconstructoutput" and "disallowremovefabricationingredient" respectively.
- Implemented armor penetration for status effects. Configured with the property "penetration" (1 = completely ignores armor).
- Option to hide an item from the fabricator if you don't have the recipe for it by adding the attribute HideIfNoRecipe="true".
- Fixed overriding a character variant that replaces the base character's texture (such as crawler hatchling) causing it to use the base character's texture instead. 
- Fixed animation triggers breaking animations if a modded character uses animations defined in a custom folder (as opposed to the default Animations folder).
- Added StoreBuyPriceModifier to locations.
- Fixed fabrication recipes where the only difference is that one uses an identifier and the other a tag getting assigned the same hash, preventing the item from loading.
- Fixed statuseffect's "forcesay" making the message appear twice client-side in multiplayer.
- Fixed inability to give stats (via items/talents) to non-human characters.
- Changes to how the game differentiates between a "tags" argument in StatusEffects meaning either tags of the status effect, or setting the Tags property of the target. Previously the game tried to basically guess it, and sometimes got it wrong. Now the tags of the effect should be defined using the attribute "StatusEffectTags" and setting tags of the target should be done with "SetTags". The old "tags" argument is still handled the same way as before for backwards compatibility.
- Added a "ConvulseAmount" setting to affliction effects. Makes the character shake/convulse similarly to late-stage husk infections.
- Fixed StatusEffect's TransferAfflictions setting (which transfers afflictions to a new character spawned by the effect) transferring everything to the main limb.
- Fixed StatusEffects targeting Contained being unable to access the ItemComponents of the contained items (they could only affect the properties of the Item instances).
- Support for configuring monster-specific music tracks. Configured with the attributes “MusicType”, “MusicCommonness” and “MusicRangeMultiplier” in the character xml.
- Support for forcing a music clip to play for a minimum duration of time, even if the situation changes to make it no longer suitable. Configured with the attribute “MinimumPlayDuration” in the sound xml.
- Fixed husk appendage failing to attach correctly if another joint than the first one attaches to the character's normal limbs.
- Fixed stores not updating in the current or adjacent locations when you enable a mod that modifies store items.
- Fixed job-specific spawnpoints not working in the outpost deathmatch mode (doesn't affect the vanilla game).
- Made the "dumpeventtexts" command (which collects texts from events, moves them to a text file and replaces the texts in the event with the appropriate tags) more usable for modding: instead of going through all event files and attempting to modify vanilla content, it now takes in arguments that lets you specify which files or folders you want it to process.
- Improved crosshair accuracy by compensating for the barrel offset. Not very noticeable with vanilla weapons, but can be useful for mods that have weapons with a significant barrel offset.
- Fixed skill modifiers in Wearables not working if the item is worn in multiple slots.
- Fixed submarine upgrade categories being hidden if the category only contains items that can be swapped, but no “normal” upgrades that affect existing installations.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.7.7.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed damage modifiers not working on creature variants (meaning that e.g. mudraptor hatchlings and veterans did the same amount of damage as normal mudraptors).
- Fixed crew list appearing empty when freecaming in single player.
- Fixed alien coils blocking the boss at the end of the campaign.
- Fixed a waypoint issue in Camel.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.7.6.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes:
- Added a "toggle run" input (so you no longer have to keep holding shift to run). Not bound to anything by default, but can be set in the settings menu.
- Improvements to environment visuals: the inside of level walls fades to black to make the texture tiling less obvious when zoomed far out, improvements to the shapes of the level walls (more natural shapes, less long and straight wall segments).
- Ruin scan missions show a progress bar indicating the status of the scans.
- Made dry or partially dry rooms more common in wrecks.
- Option to change the sound of the alarm sirens to a claxon horn sound (the "traditional" AWOOGA-AWOOGA submarine alarm sound).
- "giveaffliction" console command now auto-completes identifiers as well as names.
- Reworked Berilia (kudos to WJohnston): layout improvements, added a bottom docking port, more windows, replaced cameras with searchlights, simplified battery setup and increased reactor output, minor visual improvements and a lot of miscellaneous tweaks.
- Reworked Kastrull drone (less ugly, a little sturdier, the ballast can be accessed through a hatch).
- New playstyle banners.
- Added an option in the settings to launch the game on a specific display.
- Option to refresh the available audio devices (both playback and input devices) in the game settings. The game should now also automatically attempt switch to another device if the current one is disconnected. However, whether this can be done automatically can depend on the audio device, driver and the operating system, and in some cases it may be necessary to choose a new device manually from the game settings.
- Made electrician's goggles easier to get (spawns as a part of the sub's initial supplies, can be purchased from outposts, doesn't require fulgurium to fabricate). The goggles are intended to help less experienced engineers get a hang of wiring in particular, so it doesn't make sense for them to be so difficult to get.
- "Safe rooms" are no longer indestructible in beacon stations (felt confusing, especially when it wasn't apparent from the look of the walls).
- One new research outpost event to foreshadow the longer ruin event chain.

Optimization:
- Rendering optimizations that should give a major performance boost to situations in which there's lots of structures visible.
- Changes to the physics engine to improve collision detection performance. In technical terms, the game now disregards potential collisions between things that can never collide (such as two characters and most items) much earlier in the collision detection logic.
- Significant optimizations to memory usage. These will mainly reduce load times and lag spikes as the game needs to do less cleanup to free memory that's no longer needed by the game.
- Optimized character ragdolls (building them out of simpler collision shapes).
- Optimized LevelTriggers (things in the level that can react to objects and apply effects to them, such as water currents).
- Optimized the logic for refreshing the positions of items that are inside a moving inventory (such as a character's inventory).
- Miscellaneous optimizations to things such as explosions, AI logic when a bot is operating a turret, psychosis effects, idling NPCs' AI.
- Text rendering optimizations.
- Optimizations to periscopes, chairs and other items that force the character to a certain pose.
- Optimizations to piezo crystals.
- Optimized lighting in the nightclub module.
- Minor miscellaneous optimizations to the physics logic, such as simplifying math and the way positions of entities are set.

AI:
- Fixed bandits occasionally failing to power up the beacon station they reside in.
- Fixed non-humans enemies not firing ranged weapons if there's a dropped riot shield (or other "blocking" item) in the way.
- Fixed bots sometimes getting stuck walking towards a door if the button/mechanism for opening the door is somewhere far away the bot can't reach.
- Fixed bots and husks being unable to enter Barsuk, Camel and Remora through the airlock.
- Fixed bots being unable to enter through Camel's bottom hatch.
- Fixed bots spotting characters that should be indetectable by AI (e.g. camouflaged Mantises).
- Fixed some bot dialog using the "technical" names (e.g. Mudraptor_passive) of characters instead of the proper display name.

Multiplayer/networking fixes:
- Implemented lag compensation for hitscan weapons. Should make cases of shots seemingly landing client-side just for the health to rubberband back shortly after significantly less likely. The issue had to do with the lack of lag compensation by the game: a client might fire exactly at a monster, but when the server found out about that shot some fraction of a second later, the monster might've moved and the server would consider the shot to have missed. Now the server takes the latency into account, and checks if the shot would've hit at the point when the client fired the gun. The maximum amount of lag compensation is currently 150 milliseconds, but this can be changed in the server config with the setting "MaxLagCompensation".
- Improvements to syncing character positions (further reducing issues such as shots missing): fixed a bug that caused minor inaccuraries in character velocities between the server and clients, and made the clients better at extrapolating positions while waiting for the next positional update from the server.
- Fixes to syncing ragdolled characters' positions. Should fix corpses and unconscious characters often getting stuck in a glitchy state around platforms, rubberbanding up and down.
- Fixed inability to disable Steam authentication for LAN play if the server is connected to Steam.
- Fixed clients sometimes choosing an incorrect biome in the sandbox, mission and PvP modes, leading to a "level equality check failed" error at the start of the round.
- Fixed character occasionally teleporting out of the sub for a split-second in multiplayer, particularly when the sub was travelling fast during bad networking conditions.
- Fixed occasional crashes with an error message about "SpamFilter.IsFiltered" after getting disconnected from a server and kicked back to the server list.
- Fixed "herpes threshold" server setting doing nothing (should determine how low a player's karma needs to drop for them to contract space herpes).
- Fixed networking errors when multiple clients have died during a permadeath round, and you attempt to continue to the next level.
- Fixed loot that can only go in specific kinds of inventory slots (e.g. mudraptor shell) failing to spawn in the monsters' inventories if they don't have slots of the correct type.
- Fixed occasional "entity event data exceeds the size of the buffer" errors. These happened when the server failed to write a network event for some item (in which case the server should've just skipped that event), which can be caused by issues in mods for example.
- Fixed other clients not seeing creature attacks if the creature is being controlled by a player.
- Fix to clients often getting stuck behind closing doors in MP despite the character seeming to make it through in time client-side.
- Fixed server lobby sometimes appearing empty/nonfunctional when clients join a server. In technical terms, this happened when the lobby's update ID had reached a very large value, which could happen if the server has run for a very long time or if there's been some issues that have caused the server to create a very large number of lobby updates.
- Fixed PvP outpost setting causing unnecessary server lobby updates (even when the PvP mode was not selected), potentially leading to the lobby becoming unusable due to the issue described above.
- Fixed flipping monsters behaving inconsistently in multiplayer when controlling a monster: other clients saw the monster facing in the position of the cursor, even if it hadn't turned at all at the end of the client controlling it. 
- Fixed "ignore" and "unignore" orders not working on stacks of items in multiplayer (just marking the first item in the stack). 
- Fixed components inside a circuit box losing their settings when saving the game while the box is in a player's inventory.
- Fixed moving an item UI potentially moving it outside the screen on other clients' screens when using different resolutions.
- Fixed clients syncing the selected outpost PvP setting unnecessarily to the server when a non-PvP mode was changed. When there were no outposts to select from, the clients would think the setting has changed (since the selected value of "nothing" doesn't match the server setting), and send the value. This could potentially have caused the reported issue of multiple admins constantly changing settings and messing up the lobby.
- Fixed clients sending the value of the win condition slider too eagerly (whenever it moves, as opposed to when it's released). Also changed it adjust in steps of 10 for a little nicer values.
- Fixed occasional "Unexpected error" console errors when the game attempts to unlock an achiement on the Epic Store or with EOS crossplay enabled.

Extra logging for diagnosing networking errors:
- Mention the entity that caused an error to be thrown when reading a network event, and the content package that entity is from (makes it easier to tell when the error is caused by some specific mod).
- Improved logging of the "event count very high" errors: mention the content package the events are from if they're non-vanilla, log the errors client-side too. We are suspecting the occasional "expected old/removed event" disconnects could be due to the server creating so many events the clients can't keep up, and this should give us some more clues for diagnosing the issue.
- Added more info to the "component event creation failed" error messages, the errors are logged into GameAnalytics.

Balance:
- Each successive use of the Mindwipe item increases the penalty to talent points, making it more costly to use it to "farm talents" by repeatedly unlocking talents that unlock other talents or give extra talent points.
- XP gain balancing: the XP is no longer directly tied to mission rewards, but adjusted based on the difficulty of the mission.
- Lowered cost of high-skilled NPCs to hire. High reputation with Coalition or Separatists results in more cost-effective hires.
- Tweaks to monster nest missions: higher reward (as they're some of the riskiest missions in the game) and less monsters in SP (in MP it's the same amount).
- Campaign setting for adjusting the XP gain rates.
- Higher XP gains in later biomes.
- Concussions wears off faster.
- Beds are a bit more effective for some afflictions like nausea and drunkness.
- Added chem addiction and chem withdrawal reduction to beds/bunks.
- Reduced how fast chem addiction and chem withdrawal build up.
- Reduced the amount of devices you need to repair to get the effects of the "Machine Maniac" talent.
- Health scanners spawn as a part of the sub's initial supplies, not given to every respawning medic (a too easy source of free resources).
- Deconstructing headsets no longer yields materials (a too easy source of free resources).

Fixes:
- Fixed choosing "retry" in the pause menu after you've started playing from a backup save loading that same backup save instead of the most recent save.
- Fixed relay components not passing power until they've been toggled on and off.
- Fixed ability to sell the 2nd gene of a combined genetic material in stores.
- Fixed combined genes appearing untainted if the 2nd gene is tainted instead of the 1st one.
- Fixed NPCs still offering services (stores, submarine upgrades, etc) despite their faction being hostile to you, leading to weird situations where you could be trading with a merchant who's actively trying to run away from you.
- Fixed Artie Dolittle continuing to follow you if you refuse to hire him.
- Fixed "Miracle Worker" talent keeping husks from dying if you're friendly with husks (e.g. because you're wearing Zealot Robes).
- Fixed alien turrets not working properly in mirrored ruins (they were using circuits with hard-coded turret rotation angles, which broke in mirrored ruins).
- Fixed alien turrets set to auto-operate failing to fire inside hulls.
- Fixed auto-operated turrets trying to fire at monsters inside ruins.
- Fixed signal components being automatically placed inside circuit boxes in your inventory when you purchase them while there's no free slots in your inventory.
- Fixed holes on overlapping walls multiplying flooding rates (a hole was created on all of the walls, and they'd act independently of each other).
- Fixed lights being visible on contained items (e.g. handheld sonars in cabinets) in the sub editor.
- Fixed crashing when attempting to give contextual orders to a defense bot (i.e. when middle-mouse-clicking a defense bot).
- Reactors attempt to rapidly adjust to the load in the first 5 seconds of a round, during which time junction boxes don't take damage from overvoltage. Intended to address overvoltage in cases where the reactor is outputting a lot of power, and the load suddenly drops when a new round starts (e.g. due to the engines powering down).
- Fixed alien devices (or more specifically, items with a static physics body) shifting from their original position when loaded for the first time if they're used in a normal sub.
- Fixed "Crusty Seaman" talent giving characters medical skill as it heals the character's bleeding.
- Fixed certain level resources (e.g. piezo crystals) facing the wrong way on level walls.
- Fixed certain elements in the debugdraw view (submarine borders, damage texts on walls, gaps, water level indicators on hulls, lines pointing to walls enemies are targeting) "twitching" when the sub moves.
- Fixed headsets purchased with immediate item delivery getting assigned to an incorrect team, preventing them from communicating with the headsets of the rest of the crew.
- Fixed headsets whose fabrication was started on the previous round getting assigned to an incorrect team, preventing them from communicating with the headsets of the rest of the crew.
- Fixed pets (including defense bots) spawned in an outpost being assigned to the "friendly NPC" team, which would e.g. mean that they wouldn't attack the enemy team in the PvP mode.
- Fixed PvP outposts sometimes spawning as alien ruins.
- Fixed multi-tools detaching detonators (the multi-tool is not intended to detach any items, because that would conflict with the repair functionality).
- Fixed unopenable hatch at the top of ResidentialModule01_Colony (rarely caused any issues in the vanilla game, because other modules almost never attach on top of that module).
- Fixed Terminal component's Readonly field not working when it's set in the editor (only if the item is by default set to readonly).
- Fixed large hardpoints not having the "set_auto_operate" and "toggle_auto_operate" inputs.
- Fixed components being attachable inside walls/floors in some subs.
- Fixed broken junction boxes sometimes zapping players despite seemingly not being powered.
- Improved thalamus brain spawning to prevent it from ending up in dry rooms, and dying if it does:
    - Avoid spawning in rooms with doors, hatches or duct blocks.
    - The brain no longer dies in dry rooms.
- Fixed mudraptor beak from mudraptor genes showing through exosuits and other wearable items that should hide the character's head.
- Fixed bandoliers not going in cabinets' "container slots".
- Fixed "man and his raptor" mission failing if you don't speak to the man and spawn the mudraptor.
- Fixed wrecked doors and hatches not being weldable.
- Fixed the hover text saying that you can "open" or "force open" a door when it's already opened.
- Waypoint fixes in Camel.
- Fixed 'Traveling Tradesman' sell bonus not working.
- Fixed chat-linked wifi components sometimes failing to receive messages from the chat (most often in circuit boxes?). Had to do with the order in which the headsets and wifi components are created.
- Fixed conversation prompts not blocking conversations from other events if you've moved past the initial prompt (e.g. answered the first question and gotten a follow-up).
- Fixed treatment suggestions not being shown on some afflictions (e.g opiate addiction). Happened because we used the same thresholds to determine if bots should treat the affliction and to determine if the suggestion should be shown.

Modding:
- Added AddScoreAction: can be used to make scripted events modify a team's score in the PvP mode, which should open up a lot of new possibilities for custom PvP mission types.
- Added RangedAttackMultiplier stat type.
- Beacon stations are no longer automatically damaged, but instead are only damaged through the DamageBeaconStationAction in ScriptedEvent. Recommended (and default) setting for beacon stations is to enable all three: Allow damaged walls, Allow damaged devices, Allow disconnected wires.
- Fixed ragdolls failing to load when inheriting creatures whose ragdolls are not in the default path ("Ragdolls" folder inside the character's folder), but e.g. defined using a direct path to a ragdoll file in the character's or some other character's folder.
- Added option to set the handle positions (Handle1 and Handle2) of a holdable item using status effects.
- Fixed character variants failing to load the correct texture for limbs that use a different texture than the rest of the ragdoll (e.g. the alien bits on a variant of the Cyborgworm).
- Fixed WaitForItemUsedAction not working if there's multiple instances of the same scripted event active at the same time.
- Fixed characters' damage overlays not being affected by the ragdoll's texture scale.
- Fixed stacking ability resistances past 100% making the resistance negative.
- Fixed texts with color tags not working in some UI elements: fabricator, sub editor, store, speech bubbles.
- Made the game load the vanilla human ragdoll (or in the case of monsters, crawler ragdoll) if loading a modded character's ragdoll fails. Should make it easier to diagnose and address issues in the character configuration.
- Fixed hair and other "wearables" in character portraits (in the bottom-right corner and the health interface) getting misaligned if they use a different origin or sourcerect than the head sprite.
- Fixed health multipliers defined in a HumanPrefab not working.
- Fixed crashes when a PvP outpost contains shuttles or other moving parts.
- If an item variant inherits a sprite without the full texture path from the base item, it uses the texture path of the base item instead of that of the variant. Fixes mods being unable to create variants of things like diving suits without reconfiguring all the sprite paths.
- Fixed character variants overriding the targeting parameters of the parent character incorrectly: just overriding the parameters in the order they're defined in, as opposed to overriding a parameter with a matching tag.
- Status effects can make a character say a line in the chat: used by adding a subelement called forcesay, with the attributes "message" and optionally "sayinradio".
- Fixed OnUse sounds not playing when attaching an item to a wall in MP.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.6.19.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed chat input box getting cleared whenever someone changes their team, or when the game mode or team selection mode changes.
- Fixed stun resistance PvP setting doing nothing.
- Made Crimson Acid less powerful against large monsters.
- Fixed everyone's name tags being shown in red until you spawn when you join a campaign mid-round.
- Fixed stackable items with a non-default quality (e.g. grenades) failing to stack in the fabricator's output slot, instead just falling to the floor. 
- Fixed very large PvP outposts often clipping into the level walls.
- Fixed decorative structures such as background walls not showing up on hostile (non-player) subs in multiplayer. 
- Fixed "giveitem" command crashing the game when used with no arguments.
- Fixed Gravity Flak Shell's "gravity pull effect" being affected by gravity.
- Fixed Fulgurium Batteries sometimes spawning automatically in tools at the start of a campaign.
- Changed cargo scooter recipe to be more consistent with the normal scooter recipe (Underwater Scooter + x2 Ti-Al Alloy).

Modding:
- Fixed freezes / lag spikes in multiplayer when a scripted event uses StatusEffectAction when there's lots of mods with custom events enabled.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.6.18.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed several issues when the server rejects a name change due to a client trying to change their name too often: the server would start spamming the "can't change name" message, team and job preference selection would stop working too, and the game would crash when attempting to open the job preferences.
- Fixed equipped genes becoming tainted if you die due to disconnection.
- Fixed kill/death counters not working in the Sub vs. Sub PvP missions.
- Fixed gravity spheres not rotating in the sub editor.
- Fixed current generators not getting properly mirrored in ruins in mirrored levels.
- Fixed spawnpoints for escorted characters and prisoners not working.
- Fixed crashing if an AI character's husk infection is removed when they're using a ranged weapon.
- Fixed psychosis effect persisting if you leave the outpost midway through the "minds unraveled" event.
- Fixed night club merchants spawning in outposts without a night club.
- Fixed night club merchants not selling beer or rum (literally unplayable).
- Fixed bots cleaning up live grenades.
- Fixed server getting stuck in an infinite "restart loop" if autorestart or starting when everyone is ready is enabled and the selected perks are not suitable for the selected sub. The server would just attempt an immediate restart if the players wanted to cancel and reselect the perks.
- Fixed "All" option not working in the server browser's language filter dropdown.
- Fixed Raate Colony pvp map missing hulls near upper turrets.

Modding:
- Fixed outpost generation parameters that reference non-existent NPC prefabs causing a crash during outpost generation.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.6.17.0 (Unto the Breach)
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed water currents stopping subs entirely (regardless of the size of the sub or the current).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.6.16.0
-------------------------------------------------------------------------------------------------------------------------------------------------

PvP and combat:
- Added outpost deathmatch mission type. Teams spawn at different sides of a colony, and need to get x kills to win (configured using a slider in the server lobby). There are periodic weapon/ammo drops around the outpost. The ammo drops spawn more destructive weapons and ammo as the round progresses.
- Added "king of the hull" mission type. The teams must stay in control of a beacon station for x seconds to win (configured using a slider in the server lobby).
- Separatists spawn with different gear in the PvP mode to make it easier to differentiate between the teams.
- New settings for the PvP mode: multiplier for stuns, option to disable monster and wreck spawns.
- Added a perk system that can be used to purchase perks such as extra gear, turrets, submarine upgrades and talents for PvP and mission rounds.
- Added "boarding pod", an item you can go inside and launch through a depth charge tube. The pod penetrates through submarine walls, allowing rapid boarding of enemy subs.
- Added railgun and coilgun harpoons. Can be used to reel enemy subs and other large targets closer to your sub.
- More options for controlling the team assignment logic in the PvP mode:
	- Split team choice logic into two modes: Player Preference (the old behavior) and the new Player Choice mode (players are free to choose their team).
	- Added a server setting for auto-balance threshold (how big of a difference there can be in team sizes before the server forces them to be rebalanced).
- Option to send chat messages only to your team in the server lobby. Only works when Player Choice mode is enabled (because in the Player Preference mode the teams aren't known in the lobby yet).
- Three new background music tracks for the outpost deathmatch mode.
- Option to select the outpost in the outpost deathmatch mission type (or any modded mission type that supports selecting the outpost).
- Show the opposing team's names as red, even when spectating (previously separatists were always red when you're not controlling a character).
- Name tags are more visible in PvP (they're no longer hidden when the character is in a different room, nor faded out when the cursor is not near the character).
- The team you're on is shown above the crew list.
- Option to choose different submarines for both teams.
- Sonars display the approximate position of the enemy submarine in sub vs sub PvP missions. Can be disabled from the server lobby.
- PvP mode levels are much smaller, making submarine vs submarine matches faster.
- Stun weapons reworked and now cause movement spasms before stunning.
- Flamers can set characters on fire.
- Grenades can be "cooked" (pulling the pin to trigger a timed explosion) by pressing E while holding one.
- Stun grenades blind and deafen the target for a while.
- Incendium grenades no longer set the whole room on fire; instead, they start a more localized fire that can also set characters on fire.
- Acid grenades now spread gas around a bit more.
- Detonators now get damaged by explosions and always have a 0.2 second delay before triggering and made them craftable
- Added a timed detonator variant that can be set to explode with a 0-60 countdown, which doesn’t require wiring to use.

Alien ruins:
- New modules: shrine, research facility, current generator room and workshop.
- Updated all alien ruin modules: new puzzles and traps, improvements to old puzzles, visual improvements.
- New lore-heavy three-part event chain that takes place in research outposts, and progresses when ruin missions are completed.
- Made walls and doors much harder to destroy to encourage getting past the puzzles and obstacles in other ways.
- Added a weaker version of the ruin walls, to be used in specific spots in the ruins.
- Alien power cells can be charged in alien generators.
- Most alien devices are now destructible.
- Alien terminals have been reworked to send out a signal when there's a trinket inside: can be used for creating puzzles that require keeping the trinket in the terminal, meaning you can't just reuse the same trinket for every terminal but need to think about where to place it at any given time.
- Improvements to alien device sprites.
- New alien containers/storages: alien assembly device, alien storage vat and alien sample display.
- New alien devices: alien current generator and alien toxins generator.
- New decorative alien structures.
- Additional loot spawning to chests and other containers, making exploring ruins more worthwhile and especially expands the ability to pick up (unidentified) genes along the way.
- Fractal guardians were given additional guardian-only pathways and doorways in ruins, so they can navigate through the modules more effortlessly.
- Alien turrets deal significantly more damage.
- Alien generators indicate more clearly when they're enabled or disabled (adjusted the lights).
- Alien current generators show more clearly (with bubbles) that they're enabled, pushing the player back.
- New alien module: workshop. Introduces repair pods where guardians can hide in.

Husks:
- Three new husk variants: Prowler, Exosuit and Chimera.
- Improved the appendages (ovipositors) coming from the husks’ mouths.
- There's a chance that corpses in wrecks are husks.
- Husks can play dead.
- The amount of husk infection resistance given by e.g. antibiotics stays constant over the duration of the meds. Makes the effects of the meds a lot more intuitive / predictable.
- Significantly buffed calyxanide damage on husks.
- Fixed failed calyxanide injections not doing anything (happens occasionally when the medical skill is low enough). Now applies halved duration instead, like on other poisons/meds.
- Added minor burn reduction on all husks allowing them to (slowly) recover from burn wounds.
- Cultist robes require less reputation to buy, Zealot robes require more.
- Zealot robes no longer block transformation. Full husk transformation immunity was too powerful, which made husk genes and husk symbiosis much less valuable.

Gene splicing:
- Various changes to gene splicing to make it easier to refine genes, swap between different types of genes at will, and make tainted genes more useful (rather than something that's essentially "permanently ruined"): 
    - Removing genetic materials from a splicer doesn't destroy the material.
    - Combining genes can remove taints if one gene is 100% pure.
    - Dying with genetic materials equipped taints the material.
    - When refining genes, the lower quality gene's quality now affects how much it will improve the quality of the higher quality gene - meaning that using higher-quality genes for refining is more effective than low-quality genes.
- Changed the husk immunity genes to instead slow down the infection at lower quality to make higher quality husk genes actually worth getting.
- Mudraptor gene quality affects the damage and damage protection of the beak.
- Spineling gene quality affects the damage done by spineling spikes.
- Effects from gene splicing aren't shown on health scanners (which made it difficult to see the relevant afflictions when treating someone).

Optimizations:
- Optimizations to character creation. Reduces the lag spikes when players respawn.
- Optimized the way afflictions apply overlays to limbs (had an unnecessarily large performance impact when there were lots of characters with a large number of afflictions).
- Minor optimization to the way items in a characters' inventory stick to the position of the character.
- Minor UI optimizations.
- Improved performance when debugdraw is enabled.
- Minor optimizations to level wall rendering.

Talent changes and fixes:
- Reworked Europabrew to be more of a double-edged sword: it's a cheap cure for any poison, but it also increases ALL types of damage taken (works on monsters too!), not just acid damage.
- Fixed "Extra Powder" talent not affecting depth charges.
- Fixed weapons skill gain and medical skill gain from certain talents working the wrong way around.
- Sulphuric Acid Syringe recipe changed and renamed to Crimson Acid. Now causes a very significant slow and much more damage over a longer duration. 
- "Macrodosing" talent had acid burn damage boost removed, but increased the amount of poison applied, making it much easier to poison big enemies. 
- "What A Stench" talent had acid burn damage bonuses reduced, to allow acid burn weapons to be stronger even for those without these specific talents.
- Buffed "Modular Repairs" talent: repair pack is now a "multitool", essentially a combination of a screwdriver and wrench which repairs slightly faster, and is no longer consumed when used. The talent also gives one free "Modular Repairs" submarine upgrade.
- Differentiated the "Art of Submarine Warfare" book given by talents from the one you can purchase from outposts (different names and sprites). Previously these looked identical, and it seemed like a bug when they didn't stack and gave a different amount of skill.
- Fixed "War Stories" book seemingly giving no skill increase sometimes. The amount of skill the book gives is proportional to the number of kills the "author" of the book got, and diminishes the higher the reader's skill is. That meant the book sometimes increased the skill by less than 1 (only making it progress toward the next level), which didn't cause a skill increase notification to pop up.
- Fixed "Bounty Hunter" and "Logistics Expert" not showing the additional reward in UI in multiplayer.
- Fixed "Tasty Target" still making characters super loud (and visible on the sonar).
- Fixed "Lightning Wizard" talent description not mentioning it only affects melee attacks.
- Fixed reputation gain bonus from the "Protect and Serve" talent being multiplicative, meaning you could get ridiculous amounts of rep if you have multiple security officers with the talent.
- Fixed "Mule" talent not working with physicorium bars.

Miscellaneous changes and additions:
- 2 new research modules. 
- 3 new medical modules.
- 2 new security modules.
- 6 new admin modules.
- 4 new crew modules.
- 4 new docking modules.
- 4 new engineering modules.
- 4 new clown modules.
- 2 new Church of Husk modules.
- New bath house and nightclub modules.
- 3 new storage modules, with 4 new events (providing extra loot and some potential challenges).
- Added module ‘probability’, meaning some optional modules (such as storage modules) do not always spawn.
- New "gravity shell" ammo types for railgun and flak cannon. Fabricated from dementonite.
- New "mindsense" item that temporarily gives you the ability to sense living characters through walls. Fabricated from dementonite.
- Clown crates can be carried with a character inside.
- Jukeboxes play music, the track can be changed by interacting with the jukebox. Also added new "speaker" items that work the same as jukeboxes.
- 7 new achievements: 
	- Get Out Alive: get through the entirety of the Cold Caverns without losing your character in permadeath mode.
	- The Abyss Beckons: lose a character in the permadeath mode.
	- King of the Hull: win a PvP King of the Hull mission.
	- Hide And Seek: kill a Cave Mantis.
	- Ancient Novelty: destroy an alien terminal using alien curio.
	- What Smirks Below: kill a psychoclown on a beacon station.
	- Europa's Finest: complete a campaign in ironman mode in multiplayer!
- Added the ability to load saves from back-up save slots, rather than just one save slot per campaign (allows going back further into the past, to avoid getting stuck).
- Disabled portable item finders working outside of the player subs. The intention is that they can't be used as a map of unknown places. Can be adjusted in xml for modding.
- Some new stair variants.
- Made the water ambience sounds inside the sub a little more quiet.
- Adjusted the low pass filter that muffles audio that's coming from far away or from behind obstacles: the sounds are now muffled more heavily.
- Made the ping estimations in the server list more accurate. They are still not perfect, because due to the way SteamP2P works (with the connection potentially getting relayed through Valve's intermediary servers), it can be hard to determine the ping in advance without actually connecting to the server.
- Adjusted railgun shells and depth charges to show the 'explosives' icon. Other items can still be placed into them, but most don't actually do anything. This should help players to understand it's mainly intended for explosives.
- Adjusted the names and descriptions of turret ammunition, to be more clear (and more easily searchable) on what turret they're used with.
- Circuit boxes can be set to require a specific ID card tag to access.
- The docking circuit boxes in vanilla subs require a captain's ID card to access.
- One-handed riot shields (to make them actually useful!).
- Added "surveillance center" item which can be connected to multiple cameras, which can be toggled through with buttons on the UI. There's an example item assembly showing how to connect the center to multiple cameras using the new output selector components.
- Output selector component (the technical term is "demultiplexer"). A component that has one input connection, and multiple output connections, and allows you to choose which of the output to send the input signal to.
- Input selector component (the technical term is "multiplexer"). A component that has multiple input connections, and one output connection, and allows you to choose which of the input signals should be forwarded to the output.
- Made the sound effects and camera shake a lot more noticeable when approaching crush depth.
- Option to make circuit boxes require a specific ID card to access.
- Removed the restriction of 2 security officers and 2 medics per crew in multiplayer.
- Spectators can focus the camera on a character by clicking on one on the crew list.
- Easier testing of outpost modules in the sub editor: when launching the test mode with an outpost module that's suitable for some outpost, the editor generates the whole outpost as opposed to just the single module.
- Higher-res collider indicators (visible in the character editor and when debugdraw is on).
- Adjusting the audio level sliders changes the volume immediately (as opposed to when you click "apply") to make the volume easier to preview.
- Added options for renaming and deleting local mods.
- Added an option to copy a workshop mod to a local mod.
- Fixed the context menu's "unsubscribe" button not working.
- Copying a waypoint while holding Ctrl automatically links it to the original waypoint in the sub editor.
- Option to choose the level difficulty in the level editor.
- Crush depths for different levels of hull upgrades are visualized in the level editor.
- Fixed BrokenSprites not showing up in the sprite editor.
- Ctrl+C copies the sourcerect of the selected sprite or sprites in the sprite editor.
- The total mass of the character is shown in the character editor. Note that the masses don't correspond to any "real units", but they may be of use if you e.g. want to make some status effects affect large monsters.

AI:
- Fixed an issue in the medic AI that made them often use suboptimal medicine when there were better options available. The issue happened when the medic didn't have the meds readily available: when they started searching for the sub for suitable meds, they would accept any of the 4 most suitable ones even if there were more suitable options available.
- Medic bots no longer use saline to treat infections. Saline has such a minor effect on infections that the bots could end up wasting huge amounts of it.
- Bots are now able to change the fuel rods on exosuits.
- Fixed bots being too eager to use welding tools and plasma cutters as weapons.
- Defense bots are now much better at navigating inside the sub, and they can open doors and use ladders.
- Fixed defense bots always being friendly to all humans, regardless of the team.
- Defense bots can now be told to unfollow by interacting with "E" (play). You can also tell someone else's defense bot to follow you.
- Defense bots show a green light when they are following a target.
- Monsters can now see and target searchlights.
- Fixed escorted NPCs getting turned hostile by the negative side-effects of medicine way too easily.
- Fixed security officers starting to consider everyone in the outpost as "belonging to another crew" after they've been alerted in a jailbreak mission, causing them to do constant security inspections on each other.
- Fixed low amounts of poisoning making bots say the target is mildly injured and doesn't need treatment.
- Fixed bots being unable to heal husk infections.
- Fixed bots recharging fulgurium batteries as soon as they're below 100% condition.
- Fixed bots being unable to defend themselves if they are holding an item that cannot be placed in the inventory, such as a cargo scooter or a box. Now they can put the item on their back or drop it when necessary.
- Fixed bots trying to store items like HMG in cabinets instead of putting it on their back when they don't need it.
- Fixed bots wearing both diving mask and diving suit when the suit has no oxygen left and when a mask would suffice.
- Fixed bots using repair tools in combat from an incorrect distance.
- Fixed bots sometimes getting stuck in a flooding room. Happened in situations where the centers of the nearby safe hulls were far away from the current room, e.g. if the rooms were very large.
- Fixed bots refusing to fix small leaks when there are no diving masks available but there are diving suits that they could use.

Fixes:
- Fixed "mission equality check failed" error when you join an ongoing campaign in which the players have selected missions in an outpost, but not departed yet.
- Fixed "lock default wiring" server setting locking components in all circuit boxes (even ones placed mid-round).
- Fixed headsets not working on characters spawned via console command. 
- Fixed iron man mode staying "partially on" when the checkbox is left ticked, and a respawn mode other than permadeath is enabled, causing e.g. character loss to not get reverted when restarting the round.
- Fixed escort and cargo missions still sometimes leading to locations with no outpost. Now these missions should not be offered if there's no adjacent outposts.
- Fixed the sonar marker sometimes disappearing in one of the levels at the end of the campaign if the player stays too long in the level.
- Fixed dropping a melee weapon mid-swing leaving its hit detection active, causing characters to take damage if they touch it afterwards.
- Fixed monsters being unable to walk/swim backwards in multiplayer, causing the animations to look off in the case of e.g. monsters that back off after attacking.
- Fixed mineral scanners working without power.
- Fixed some faction events getting stuck when you choose the "ignore" option in the dialog.
- Fixed wrecked coilgun loader still using the old sprite (that doesn't look like the normal loader).
- Fixed lower docking port not being connected to the power grid in Camel, Orca 2, R-29 and Remora.
- Fixed chitin being damageable.
- Fixed beacon stations being often positioned in a different spot in mirrored levels (e.g. it might be near the outpost at the end of the level, but if you entered that outpost and returned to the level, it might’ve been near the other end of the level).
- Handheld item finders no longer work in ruins, wrecks and outposts (makes it too easy to locate loot - they were originally intended just for finding items on your own sub).
- Fixed "access denied" console errors when you attempt to open a restricted folder in the file selection dialog (e.g. when selecting a preview image in the sub editor). Now folders you don't have access to open a hidden from the menu.
- Fixed lights sometimes going through doors.
- Fixed dropped items sometimes seemingly disappearing client-side in multiplayer (most often, cargo scooters around ruins).
- Fixed inability to select containers that make you automatically pick up the item inside (e.g. weapon holders and fire extinguisher brackets) in the sub editor.
- Fixed occasional "invalid wallet" errors when finishing the campaign with talents that give extra money at the end of the round.
- Fixed rescuing Jacov Subra still not changing the abandoned outpost back to normal.
- Fixed characters losing skills and items if they die due to a disconnection, and then despawn before the end of the round.
- Fixed loading an autosave in the submarine editor not refreshing the list of layers in the sub.
- Disabled drop item hotkey in editors. It seems this is frequently bound to keys that are used in editors too, leading to e.g. people dropping screwdrivers around the sub when they're trying to toggle the entity list.
- Fixed outdated skill requirements in some weapon tooltips (Autoshotgun, HMG and Machine Pistol).
- Fixed crew list order shuffling around whenever characters are added or removed in MP.
- Fixed smoke from volcanoes and lava vents rendering in front of level walls.
- Fixed "man and his raptor" mission completing even if the mudraptor dies.
- Fixed crashing when trying to join a dedicated server via an IPv6 address.
- Fixed logbooks sometimes spawning in locked cabinets in wreck missions, which may make the mission impossible to complete if there's no corpse with an appropriate ID card in the wreck.
- Fixed deleting a wire with a label behind it from a circuit box also deleting the label.
- Fixed incorrect opium skill requirement tooltip.
- Fixed pulse laser loader's light flashing when it's rewired.
- Fixed certain affliction-specific animations, like the "drunken run" animation increasing movement speed when wearing a diving suit.
- Fixed psychosis artifacts sometimes causing excessive amounts of psychosis when the number of characters inside their area of effect changed.
- Fixed bots being able to start deconstructors from a distance if the item they're trying to deconstruct is already inside the deconstructor.
- Fixed a very rare issue that sometimes caused there to be now path between biomes on certain campaign map seeds.
- Fixed missions never triggering in levels that don't lead to an outpost if there's any paths to outposts available.
- Fixed outpost NPCs being unable to sit in cafeteria chairs (literally unplayable).

Modding:
- More modder-friendly event set handling. Previously it was very difficult to ensure custom events always trigger without overriding all of the vanilla event sets. We had support for "additive sets", which can trigger in addition to the normal event sets, but no way to guarantee one triggers. Now an attribute called "SelectAlways" can be added to an event set to ensure the game always selects the set when it's suitable for the current level. If the set is additive, it is guaranteed to get chosen regardless of what other sets get selected. If the set is NOT additive, the game will choose the first available non-additive set that is configured to be always selected.
- Made beacon events more modding-friendly: previously which beacon events were allowed to trigger was based on which layers are present in the beacons, but this was not a good idea because it breaks the events in all existing beacon mods (which for the most part don't use layers). Now trigger based on what kind of spawnpoints there are available in the beacon station.
- Added OnInserted and OnRemoved action types, which can be used in Containable definitions to trigger a status effect when something is placed into or removed from a container.
- Option to allow severing monsters' heads without killing them.
- Add an option to trigger motion sensors by species name or group.
- Monster AI: Added support for multiple targeting tags per target (e.g. an item having two different tags that a monster can target with different targeting params: the guardians now use this when targeting traps: they can either hide in them or flee to them for the repairs).
- Monster AI: Added support for multiple targeting params with the same tag. Currently not used in the vanilla game.
- Add support for targeting only items and for specifying multiple target types in the attack definitions. Or in other words, a monster attack can be configured to work against both characters and items.
- Fixed property conditionals targeting item components always requiring a match for all of the components of the same type, instead of any of them. Can be adjusted in the xml.
- Fixed NPCChangeTeamAction crashing the game if the target doesn't have a character info (= it's a monster or a pet).
- Increased the shadow casting light limit to 100 in the sub editor (can still be bypassed by enabling the "debugdraw" command).
- Made hostile abandoned outpost NPCs able to react offensively to the player even if the mission takes places in a friendly outpost (i.e. assassination/rescue missions can take place elsewhere than abandoned outposts without the hostile NPCs fleeing from the players).
- Made it possible for a CustomInterface to periodically refresh the UI to match the properties of the item (e.g. if there's some timer field, to get the value of the timer from the item).Configured with the attribute "GetValueInterval". Previously it was only possible to make the UI control the values of the properties or send signals, but not the other way around.
- Support for defining characters "the normal way" (using human prefabs, as opposed to the "character types") in pirate missions.
- Support for applying status effects on the pirates in pirate missions.
- Fixed toggling layers not working in outpost modules.
- Fixed contained items not getting hidden when the layer the parent item is in gets hidden.
- Fixed Sprite elements in wearables being case-sensitive.
- Fixed SpawnAction sometimes choosing spawnpoints in the abyss, ruins or caves when set to spawn at the MainPath.
- Fixed items not being positioned/rotated correctly when contained inside a "grandparent container" (item inside a container inside a container).
- Added "researchmaterial" tag to items containable in a research station. Doesn't affect any vanilla content, but allows modders to make research stations usable for things other than genetic materials. Also allow putting medium and small items into the output slots.
- Option to make TriggerComponents trigger based on a species name, species group or a conditional.
- "HUDOverlay" element which can be used to show a full-screen overlay on any arbitrary item the view is focused on. Used on cameras. 
- Fixed there being no guarantee that there's a suitable start outpost in the first biome, especially when using mods that add a lot of new location types.
- Fixed removing an item with multiple inventories using status effects only removing the items inside its first inventory.
- Fixed MissionStateAction always incrementing the state by 1 when set to "Add", disregarding the value set in XML. 
- Fixed delayed effects not filtering the targets properly (ignoring e.g. TargetIdentifiers and TargetItemComponent).
- Fixed character variants overriding the targeting parameters of the parent character incorrectly.
- Mission types are no longer hard-coded.The name of the XML element determines the actual mission class used by the game, but the mission type can be any arbitrary string. Can be used if you for example want to add special types of salvage missions, and categorize them separately in the menus.
- Fixed NPCs losing the reference to the HumanPrefab if they're hired in the crew and a new round has started. Didn't cause any issues in the vanilla game, but made it impossible to refer to the NPC using the human prefab id in events.
- Non-humanoids can now use ladders, if they have both "CanInteract" and "CanClimb" enabled in the character params.
- Fixed making an NPC stop operating an item with NPCOperateItemAction not working.
- Fixed StatusEffectAction not working client-side when it's executed immediately at the start of the round before clients have loaded in.
- Fixed "sprite not found" console errors when the game tries to preload a modded creature with damaged sprites.
- Fixed MeleeWeapon StatusEffects not being synced correctly (the effect didn't specify the MeleeWeapon component as the target client-side). Doesn't seem to have affected any vanilla content.
- Fixed conditional sprites in limbs completely ignoring the texture path defined in the xml and always using the default path.
- Fixed inability to make structure prefabs indestructible (the setting only applied to individual wall instances placed in the sub editor).
- Instead of having to define the pirate sub files in the mission, you can also just leave it out and let the mission choose a random enemy sub. The reward, preferred difficulty, and tags that restrict which mission a sub can be used in, can be configured in the sub editor.
- Fixed specific kinds of item variants causing "sprite not found" errors. Specifically, when a variant in Mod A inherited an item from Mod B, and that item had sprite paths configured using %ModDir%, the game would attempt to find the sprite from Mod A even though it should be looking for it from Mod B.
- Fixed items that take up both the OuterClothes and InnerClothes slots being possible to put in just either of them by swapping them with other items in a specific way.
- Made "RemoveIfLinkedOutpostDoorInUse" affect ladders too (making it possible to remove unused ladders from outpost modules by linking them to doors).
- Fixed inability to set an item's condition or quality using OnSpawn status effects.
- Fixed PowerTransfer.CanTransfer not working.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.5.9.2
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed an exploit that allowed clients to crash servers when hosting through SteamP2P.
- Fixed crashing when loading a save in which a character has a deconstruct order and an item marked for deconstruction is outside hulls.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.5.9.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed outpost security being way too eager to arrest characters who attempt to escape a security inspection, to the point that getting inspected while running past a guard would immediately make them arrest you.
- Fixed some thalamus items being hidden for no reason in some wrecks.
- Fixed "assault enemy" order not working in abandoned/enemy outposts. 
- Added a configurable multiplier for the cost of hiring a new character to replace a permanently killed one. Makes it possible to host permadeath servers without having to assign hiring or money permissions to clients.
- Players are allowed to rename the character they take over in the permadeath mode.

Modding: 
- Fixed forceOutpostGenerationParamsIdentifier (which can be used to force specific outpost generation params to be used in a location type) only working in single player.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.5.8.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed crashing when killing a defense bot or a leucocyte.
- Fixed directional flak ammo box still being carried with 2 hands.
- Fixed set_auto_operate and toggle_auto_operate disappearing at the start of the round if AutoOperate is not enabled. Now there's a setting called "Allow Auto Operate With Wiring" which can be enabled in the sub editor to enable the connections. 

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.5.7.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed certain modules failing to spawn in colonies.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.5.6.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed "Junction Junkie"" talent giving an incorrect number of XP.
- Fixed "Machine Maniac" and "Quickfixer" talents not affecting fabricator and duct block repairs.
- Fixed "Better Than New" talent not affecting reactor repairs.
- Reverted the changes to colony module tags introduced in the previous build.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.5.5.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes and additions:
- Added a new, optional, permadeath mode in the multiplayer campaign. When your character dies, they stay dead, along with all their XP and talents. You will have to acquire a new character to respawn and continue playing. This can happen in two ways: you can wait to hire a new character for yourself from the next non-hostile outpost, or take control of a bot to resume playing right away.
- Added a new, optional, iron man mode in the multiplayer campaign for those looking for an insane extra challenge. Players who have died in Ironman mode can only spectate, and hope that the rest of the crew will make it.
- Added a new wreck mission: clear Thalamus.
- Added more beacon stations with bandits.
- Added giving items to others by dragging and dropping. It's always enabled when targeting pets and bots (on the same team), but can also be enabled in the server settings for targeting players.
- Added a slider at the bottom of the tab menu that allows you to set the salary of all crew members whose salary has not been manually set, and also determines new characters salary for late joiners.
- Added support for new outputs in item containers:
    - "contained_conditions" (sum of the conditions of contained items)
    - "contained_conditions_percentage" (sum of the condition percentages of contained items)
    - "contained_items" (total number of contained items)
- Turret auto operate settings now transfer to the other turrets that are swapped in place of the original.
- Turret auto operate functionality can now be enabled or disabled with signals.
- Reduced the minimum length of the outpost hallways. Should get rid of the horizontal hallways and reduce the length of some vertical hallways.
- Monsters can now hear when the players are using the text chat and in-game voice chat.
- Changes to carrying turret ammunition:
    - Can now be carried with one hand, instead of requiring two.
    - Each shell/box now slows the character by 20%.
    - Adjusted the hold positions.
- Made small and medium mudraptor eggs glow the same way as the large version. The small version can now spawn in mudraptor nest missions, and they're extremely difficult to find without the glow.
- Improved the hireable husks and clowns. Added titles, made the gear more appropriate, and added high-level versions of the NPCs.
- Optimization: Fixed medical clinic UI refreshing and the server sending updates to clients whenever the number of afflictions on a character changes (which can in extreme cases be several times per frame).
- Pumps and engines now deteriorate faster when being operated at full power for a while.
- Changes to the highlighting to make it easier to interact with items near pets.
- Made combat diving suits and slipsuits reduce visibility less than the other suits.
- Added support for hosting servers in a local network without a connection to Steam or EOS. You need to set requireauthentication="false" in the server config to allow clients to join without Steam/EOS authentication.
- Updated Crawler and Crawler Husk textures to a higher resolution.
- Changed the logic of assigning jobs for the bots in the multiplayer game mode. Previously the jobs were assigned based on the number of spawnpoints for that job in the sub, now the game instead tries to distribute jobs evenly to the bots.
- Changed the logic of generating hireable characters in the outposts:
    - All outposts now offer at least one hireable for a given job, if that job is missing from the crew.
    - Added medics, security and captains as hireables in mines.

Balance:
- HMG has less severance chance and always applies a slow to characters, rather than just when carried in hands.
- Assault Rifle magazine size is now 30, up from 20.
- Flamer and Prototype Steam Cannons are better as weapons when used with Incendium Fuel Tank.
- Lead and Uranium can now be launched with the Scrap Cannon too, increased the Scrap Cannon damage with some materials.
- Auto-Shotgun is now less accurate than the Riot Shotgun.
- Grenade Launcher can now hold 6 grenades, and fires faster.
- Bandolier is now held in the bag slot, replacing the Toolbelt/Backpack but only accepting munition-type items (includes grenades).
- Reduced bonuses given by money-related talents of the Captain's "Politician" tree. Stacking all bonuses was too effective.
- Adjusted Captain's "Politician" talent tree. 
- Fixed the talent "Your reputation..." not giving double money for cities.
- Minor speed buffs to Combat Diving Suit, PUCS, Slipsuit (only when swimming).
- Added a bit more level generation variation to later biomes.
- Changed the Great Sea a tiny bit in appearance (tweaking the chunks available).
- Fixed some XML oversights, some plants had 0 commonness in all biomes and thus never appeared (for seemingly no reason).
    
AI:
- Outpost NPCs now blame the character who equipped a diving mask with welding fuel inside it for the deaths caused by it.
- Security bots don't inspect characters for stolen items in the first 30 seconds of a round. Prevents "unfair" inspections you have no chance to react to if you happen to spawn right next to a security NPC with stolen items on you.
- Outpost guards will now hold fire for a while, give two warnings, and after that attack the target, unless it complies (e.g. by ragdolling). They still prefer stun weapons while trying to arrest, but can also use lethal weapons, unless the target is on the same team.
- Targets that have escaped, resisted being arrested, or acted aggressively, will now be considered as criminals. Criminals will be immediately arrested with no warnings, if they do something illegal. The criminal status persists only for one round.
- The outpost guards should now also always confiscate all weapons and stolen items when they arrest a target. Previously this happened inconsistently.
- Fixed outpost security guards only attacking thieves when they can stun the target.
- Fixed outpost guards not letting go of the target they’re inspecting for stolen items when their objective changes (e.g. when someone is attacked).
- Fixed inconsistent guard reactions on interacting with handcuffs. They are now always considered illegal items, unless equipped (handcuffed).
- Fixed/changed: guards can now follow the player to the player sub. They will now wait for a while, after which they'll return back to the outpost, if able to.
- Fixed bots sometimes yelling incorrectly that they can't find a path when following/holding a position.
- Human enemies and outpost guards can now react to noises (ai targets that have the tag "ProvocativeToHumanAI").
- Fixed automatically created hulls in the docking ports not being marked as wet rooms, allowing the bots to drop the suits there.
- Bots no longer automatically take diving suits off in shuttles.
- Bots no longer take off diving suits while climbing. They should now drop the suits in the next platform instead.
- Bots no longer cancel (looping) orders outside of the submarine. Some orders are still cancelled.
- Added a separate job for outpost managers. Fixes outpost managers trying to operate the navigation panels in the outposts.
- Fixed bots getting stuck in some outpost stairs.
- Fixed bots sometimes stopping in the stairs while idling around.
- Bots don't take items from magnetic suspension crates or the crates recovered from a wreck in the "lost cargo" missions.
- Fixed bots "cleaning up" items from magnetic suspension crates and crates salvaged from a wreck.

Submarine layers (previously "groups"):
- Added CheckDifficultyAction. Can be used to check the difficulty of the current level.
- Option to require a specific layer to be present for an event or event set to be triggered.
- Stop updating items that are in a hidden layer (previously e.g. reactors and other devices would work fine despite being hidden)
- Hide wires that are connected to a hidden item. These are still visible in the connection panel though (just locked).
- Added DamageBeaconStationAction. Can be used to disconnect wires and break devices and walls in beacon stations.
- Fixed the "layers visible by default" sometimes showing the layers incorrectly.
- Fixed entities getting hidden when loading a sub with some hidden-by-default layers in the sub editor.
- Disabling a layer with spawnpoints in it now also disables the spawnpoints.

Circuit box UX:
- Fixed selecting wires causing you to also select components if they overlapped.
- Added character count indicator to circuit box labels and turn the text red if it goes over.
- Show a prefab icon on the cursor of the wire that is being dragged when you start dragging a wire.
- Input and output connections can be renamed by right clicking.
- Labels can be renamed by double-clicking.

Tools:
- Fixed editing water or fires using the console commands not working while on the freecam mode.
- Water edit mode: you can now double click with the primary mouse button to set a room flooding with water instantly. Double click with the secondary mouse button to completely drain the room.
- Fire edit mode: you can now use the secondary mouse button to gradually extinguish the flames in a room. Double click with the secondary mouse button to put off the flames instantly.
- Copy-pasting multiple commands into the console executes all of them in order.
- Added a parameter for specifying a location in the "teleportcharacter" console command.
- The auto-completions in the console can now be browsed backward by holding left shift.
- Added some subcategories shown in the value inspector views. Not yet used extensively.
- Fixed turret rotation limits seemingly inverting when the angle wraps around at 360 or -360 degrees.

Modding:
- Fixed "holdpos" attribute no longer working on throwable item components.
- Added "PropulsionSpeed" StatValue and use it instead of "PropulsionSpeedMultiplier" in status effects. The latter doesn't stack, meaning if you wear multiple items that affect the propulsion speed, the last one would take priority.
- Added a new attribute "ShouldBeOpen" to doors. Can be used by status effects to tell the door to open/close.
- The game now prefers English texts when a localized text isn't found. This means that if your mod is only translated to English, e.g. mission and item names use the English text if someone is playing the game in another language, as opposed to displaying the text configured in the xml directly (e.g. missionname.mycustommission).
- Fixed "TransferAfflictions" setting of StatusEffect (which can be used to transfer afflictions from the character executing the effect to a new one spawned by the effect) not working correctly if the characters have a different amount of vitality.
- Changed how outpost modules are configured for abandoned outposts: Special outpost module types are now used: "AbandonedAirlock", "AbandonedAdminModule", etc. Previously these special modules used the same module types as normal outposts, but were restricted to only spawn in outposts of the appropriate type. That meant a mod could not add a new module that's used in all types of “normal” outposts by setting the location type to "Any", because it would also be used in abandoned outposts.
- Made vision obstruction effect adjustable: instead of being just on/off, there's a ObstructVisionAmount value that can be set to a value between 0 and 1. A value of 0.5 roughly corresponds to the old obstruction effect, and setting the obstruction using the old ObstructVision boolean sets it to that value. 
- Better support for including non-human characters in the crew: CharacterInfo (which defines a characters job, skills and such, and is required for characters in the crew) can be enabled on any type of character by adding HasCharacterInfo="true" to the character config.
- Fixed crashing when you try to spawn a character defined to use human AI but doesn't have CharacterInfo or a job.
- Added an option to supply "addtocrew" argument to the "spawncharacter" console command. Makes it easier to test the above changes, and allows spawning "nonhuman crewmates" using console commands.
- Added a new parameter for upscaling character textures: SourceRectScale. It's intentionally not exposed in the character editor, but can be used together with the existing TextureScale to adjust the scaling of the textures. E.g. TextureScale 0.5 and SourceRectScale 2.0 doubles the resolution without having to adjust the other values of the ragdoll.
- Fixed DamagedByRepairTools not working if the item doesn't also take damage from projectiles or melee weapons.
- Fixed artifact events causing a crash if the item the event is supposed to spawn can't be found.

Fixes:
- Fixed the game sometimes crashing on welding a leak.
- Fixed store stocks of most items increasing constantly, all the way up to 100.
- Fixed ID cards not getting assigned the appropriate tags when you choose to get them delivered immediately.
- Fixed antibiotics not applying "drunkweakness" as intended.
- Fixed characters holding throwables, like grenades, weirdly in an unintentional pose.
- Fixed "exhibitionism" event failing if clothes or a diving suit are held in the hand slots.
- Fixed outposts giving an endless supply of missions if you keep taking up the missions, and then saving the game and reloading it again.
- Fixed flipping of the item not being taken into account when launching a projectile (making left-facing projectiles launch backwards).
- Fixed inability to hire/fire/rename/heal "twin bots" (bots with the same name, appearance and job).
- Fixed characters moving faster on underwater scooters while wearing a backpack and an exosuit than when wearing other equipment or none at all. Also affected the movement speed of the characters while wearing/holding other items.
- Fixed some CJK characters, for example ㅎ and Ａ not drawing in the game properly.
- Fixed item container sorting behaving inconsistently when there's instances/stacks of the same item in multiple slots (randomly shuffling the items around).
- Fixed label tags sent via Wi-Fi components not using the localized text in the chat interface.
- Fixed "minleveldifficulty" and "maxleveldifficulty" attributes being ignored in the single mission mode.
- Fixed vertical gaps not emitting particles if the top of the gap is not above the top of the hull the water is flowing to.
- Fixed some draw order issues on alien hatches and doors.
- Fixed decorative items on held items glowing for no reason.
- Fixed a potential softlock if you accidentally start a round in a level that's too deep for the sub. The crush depth warnings on the campaign map now take the start/end position of the level into account, and the sub doesn't take depth damage in the first minute of the round, giving you a chance to return if you end up in a level that's too deep.
- Fixed BeaconStation and Wreck info (e.g. place on the ceiling and the difficulty settings) resetting when you enter the sub editor's test mode.
- Fixed skin tint (both the normal skin color and tints applied by afflictions) affecting the color of the damage overlay (i.e. darker-skinned characters seemed to have darker blood).
- Fixed melee weapons losing collision with platforms and level walls after being swung.
- Moved the alien terminals a bit farther from the guardian pods, so that the player operating the terminal won't get damaged by the exploding pod.
- Fixed inability to open some item interfaces in the sub editor (more specifically, items without an item container).
- Fixed attempting to flip items that cannot be flipped on the X axis, for example crate shelves, not doing anything and looking broken when the submarine is flipped on the X axis (for example in PvP).
- Fixed sprite bleeding on some structures and items.
- Fixed clients sometimes displaying missions as having failed even though they succeeded server-side.
- Fixed fabricating getting interrupted if you start fabricating an item whose recipe is unlocked by a talent on some bot, and then switch to that bot.
- Fixed items that are marked for "relocation" (automatically moved to the main sub) after a bot drops them in the outpost disappearing if you save and quit. Now we also handle the relocation when saving and quitting mid-round, not just when starting a new round.
- AutoInteractWithContained fixes:
    - Ignore AutoInteractWithContained in editors (e.g. don't force picking up an item from an artifact container when trying to rewire it in the editor).
    - Enabled AutoInteractWithContained on fire extinguisher brackets and weapon holders (interacting with one automatically picks up the item).
- Fixed all walls taking double damage.
- Fixed portable pump UI flickering on and off when picked up in MP.
- Adjusted Camel airlock layout: removed the inner horizontal wall and moved the wires and components.
- Fixed the oxygen generator not being wired on KopraKoht beacon station.
- Fixed respawn shuttle spawning when a respawn triggers, even if all the characters spawned directly in the main sub (e.g. because they had an existing character who was previously on the sub).
- Fixed docking ports and hatches being very difficult to interact with when they overlap with a door or a hatch.
- Fixed flak cannon shrapnel not damaging the character who fired the cannon.
- Fixed campaign map sometimes auto-opening at the beginning of the round (more specifically, when traversing backwards to certain kinds of levels).
- Fixed crashing when the game doesn't have access to certain folders or files (e.g. if the folder the saves are stored in is set to be read-only). Should now throw a console error instead.
- Fixed selected container staying open if you lose access to it by e.g. putting the ID card that's required for access into another item in your inventory.
- Fixed characters teleporting outside when they pass from hull to another, and there's a tiny sliver of "outside space" between the hulls.
- Fixed hanging end disappearing from a wire when you connect the other end.
- Fixed marking a stack for deconstruction only marking the first item for deconstruction server-side, even though the deconstruct icon is displayed on all client-side.
- Fixed an issue that caused duplicate characters in the HR manager menu. Happened when you moved a hire to the pending list, closed the menu and then reopened it.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.4.6.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed monsters sometimes spawning immediately after the round starts (often happened between levels, when there was no outpost between them).
- The 'Art of Submarine Warfare' book granted by the 'War Stories' talent is now a separate item and the original book has been reverted to its original state.
- Fixed Thalamus' fleshgun ropes not being able to stick to a submarine anymore.
- Fixed Thalamus' flesh spike crashing the game in the multiplayer game mode.
- Added a scrollbar to the submarine warning list. Fixes the list not fitting on the screen, when there were multiple, long errors.
- Fixed server list filters not saving properly.
- Fixed marking a stack of items to be ignored or deconstructed only taking into account the first item of the stack, instead applying to all items of the stack.
- Removed duplicate localization lines that caused old versions of text to show up in some places.
- Fixes to the Chinese localization.
- Fixed the inability to edit tags that contained the same word as one of the predefined tags.
- Fixed a crash on opening the contextual order menu for an item of another character's inventory while the health interface is open.
- Fixed a crash when editing and resizing the circuit box label texts.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.4.5.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed crew remaining dead, mission remaining completed/failed, etc when you return to the lobby an restart the round. The issue was that the server did not properly load the previous save when opting to continue the ongoing campaign.
- Added a button to the server lobby which opens the server description in a popup to make it easier for players to find. We are still thinking of the best way to handle the description/MOTD, this is more of a quick band-aid solution for the description being too easy to miss / difficult to find at the moment.
- Fixed descriptions being outdated on some of the modified XP talents. Currently only fixed in English, the descriptions in other languages are still outdated.
- Fixed "command not found" error when trying to use the new "converttowreck" console command.
- Fixed items in a container in the submarine not being counted in the "owned items" count in the store interface.
- Fixed bots being unable to properly clean up some items, just taking them into their inventory and leaving them there.
- Fixed drinkable items (such as ethanol) giving the full effect with just a tiny sip.
- Fixed effect from the "revenge squad" talent only lasting 60 seconds.
- Fixed combat diving suit being slower than intended when using an underwater scooter.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.4.4.1 (Blood in the Water)
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed welding objective completing automatically in the basic tutorial due to the reduced flooding rates.
- Small fixes to localization issues.
- Bots don't consider opiates valid treatments for burns, because the amount of burns they heal now is so low it just leads to wasting meds.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.4.4.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Updated localizations.
- "Lock default wiring" server setting locks components in circuit boxes too.
- Fixed circuit box labels being resizeable to a negative size, making them impossible to select afterwards.
- Fixed inability to remove circuit box labels in multiplayer.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.4.3.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes and additions:
- Added new lost cargo missions, in which you must recover cargo from a sunken sub.
- Added six new beacon stations, and updated existing beacon stations.
- Added seven new wrecks.
- Chat messages and NPC dialog is shown in speech bubbles above the character's head. Can be disabled in the game settings.
- Improved the particle effects when the sub hits a level wall, and when cutting/destroying level walls.
- Certain afflictions and talents change the character's walking/running animations (e.g. drunkenness, the "musical talents", vigor, hyperactivity, concussion).
- Removed the randomization of quality from fabricated stackable items. The randomization made them annoying to fabricate, because the items of different quality couldn't be stacked in the fabricator's output slot.
- Motion sensor ranges are visualized when wearing engineer's goggles.
- Made fabricators and deconstructors faster in outposts (it's not fun to force everyone to wait while someone is working a fabricator in an outpost).
- Fire no longer damages husk eggs, fruit and explosives over time. Allowing them to be partially damaged made them really difficult to handle when they happened to be in a stack. Now husk eggs are immune to fire, and the rest get destroyed completely after being in fire for a moment.
- Improvements to the visual effects of lava vents and hydrothermal vents.
- Pets leave behind a corpse when they die. Having them just "pop" often meant you couldn't be sure if the pet had gone missing or died.
- Added a hotkey for dropping the held item. Not bound to any key by default.
- Added a hotkey (by default Alt) that displays a label on all nearby interactable items. The label can be clicked on to interact with the item. Should make it easier to e.g. find loose items on the floor or pick up a specific item when there's many close to each other.
- Tons of changes and improvements to outpost events: the main goal has been to make the things described by the event popups "actually happen", as opposed to just describing them in text. There's now more visual and audio effects in the events, and the things described by the texts tend to actually exist in the game world. There's also been lots of changes to the outcomes of the events: the choices you make should now generally be more meaningful.
- Most outpost events can now be started by another player if the first player who encounters them chooses to ignore them.
- Made the bilge pump circuits non-interactable and the bilge pumps non-wireable in outposts. It was too easy to abuse them to drown the outpost.
- All the pathways from the location you start at in the campaign lead to an outpost. Choosing a new destination at an uninhabited location seems confusing to new players, who haven't yet seen how transitions between levels work.
- Improvements and fixes to harpoons and ropes: the user can now pull towards the target by pressing space (but only when diving), added sounds to reeling and the rope snapping, adjusted the forces and changed how the forces were applied to both the user and the target.
- Added ON_DOCK and ON_UNDOCK outputs to docking ports.
- New automatic docking hatch assembly (much simpler than the old one, now built using a circuit box with labels that explain how it works).
- Added an option to add labels inside circuit boxes (can be used to e.g. explain parts of the circuit).
- Added a menu to the submarine editor that lists all the container tags used in the submarine, explains which tags are available and how they're used, and allows adding them to containers more easily. There's also now a warning on saving if the submarine is missing any common/recommended tags.
- Clown crates now have pressure immunity, making them potentially useful for more than just fooling around.

Monsters:
- Added Viperling, a venomous variant of Spinelings.
- Reintroduced the legacy monster Mantis. Keep an eye out for anything unusual on the walls when exploring caves!
- Changes to make big monsters more of a threat to characters inside the sub, not just the submarine itself:
    - Charybdis can poke its head inside the sub, bite and pull characters out.
    - Made monsters better at targeting positions on the hull with a character on the other side (meaning they're more likely to be able to cause shrapnel damage).
    - Made the shrapnel particles more noticeable.
    - Endworm can poke its mandibles inside the sub and damage characters inside.
    - Heavy impacts can launch off very high-velocity shrapnel that can penetrate a couple of inner walls, similar to spineling spikes.
    - Added some weaknesses to abyss monsters: Endworm has a weak spot in its mouth, Charybdis flees for a moment if it takes heavy damage to the head or mouth (a feature that initially was there but had been bugged for a while).
- Updated husk's ragdoll, textures and animations.
- Husks can now go unconscious and eventually get back up if not "properly" killed, the same way as huskified humans.
- Adjustments to the loot dropped by Latcher and Charybdis.

Diving suit changes:
- Several changes to to make it less obvious choice to wear diving suits indoors all the time:
  - Hull breaches flood the sub more slowly now, giving you more time to find a suit.
  - Reduced walking speed when wearing a suit (with adjustments to the animation to make the suits feel more "tanky", as opposed to just making the character look like it's walking in slow-motion).
  - Reduced the damage protection of suits - it was previously so high it encouraged wearing the suits in all situations just for the damage protection they offer.
  - Wearing a suit obstructs your vision more now.
  - Reduced the crush depths of diving suits to make them match the maximum crush depth of a fully upgraded sub. Allowing players to survive below the sub's crush depth didn't make that much sense: it was practically impossible to recover the sub, so it's better to treat as a "game over" state and kill the players, as opposed to leaving the game in an unrecoverable "soft-locked" state.
- Decreased the armor ratings (damage modifiers) of the (early-game) diving suits.
- Added Explosion Damage resistance to diving suits and protective gear (and clown outfits, ka-honk).
- Made the exosuit more powerful by giving it more damage resistance, a chance to ignore stuns and increasing its speed

Balance:
- Minor adjustments to the turret balance (most noticeably, made explosive ammo less OP, armor piercing ammo more effective against structures).
- Removed threshers from Cold Caverns. Thresher bites can now cause infected wounds, which can be treated with antibiotic glue, broad-spectrum antibiotics or by applying ethanol or rum to the wound.
- Acid grenades have a slightly longer duration.
- Increased the amount of hyperactivity given by energy drinks. It's still pretty weak, but the previous effect was practically meaningless (making the item more harmful than useful due to the nausea it can cause).
- Dual-wielding ranged weapons reduces reload times and accuracy.

Medical system:
- Made opiates less of a "solution for everything": they have a much higher risk of causing addiction and overdoses, and morphine heals much more slowly, making it less viable for combat-heavy situations.
- Added "infection" affliction type to add some variety to afflictions. Thresher bites and, on high world hostility campaigns, bleeding wounds and untreated burns have a chance of becoming infected.
- Added "alcohol sensitivity" as a side-effect of antibiotics. This causes drunkenness to build up much faster, so avoid using antibiotics and alcohol together!
- Stabilozine's effects no longer stack: it stops the progress of poisons, but doesn't cure poisonings.
- Added "adrenaline rush" as an effect for adrenaline. "Adrenaline rush" keeps the patient conscious for its duration, removes all active stun when inflicted and applies short-term stun resistance.
- Husk infections can be treated with sufforin and cyanide (but you must be careful to have a cure at hand!).
- Antibiotic glue can be used multiple times.
- Ethanol and rum can be poured on limbs to treat infections and burns.
- Removed skill requirements from tonic liquid.
- Alien blood causes organ damage, making it less viable as a risk-free cheap alternative for blood packs.
- Saline can be used to treat infections.
- Resting in bunks heals injuries a little faster now.
- Europabrew can now act as a universal poison cure, but also speeds up husk infection in addition to vulnerability to acid burns.
- Rum can now also be made from pomegrenade.

Submarines:
- Fixed Azimuth's periscope being too high up, causing the characters to float when using it.
- Fixed hulls being set up strangely in Camel's humps (not extending all the way up to the ceiling, making it possible for there to be holes in the walls without water getting in). 
- Various fixes and improvements to the shuttles.
- Fixed too low oxygen output in Typhon's brig, causing characters inside to eventually suffocate without an additional oxygen supply.
- Fixed Azimuth's cargo and engine rooms not draining full due to the hulls extending below the floor and the bilge pumps.
- Fixed sloped wall piece making it difficult to move from Remora to its drone.
- Fixed grenades sometimes going through certain walls (one common spot was Camel's bow).
- Adjusted the hulls in Orca's lower airlock. The small in-between hull with the pump prevented the sub from flooding, because water couldn't flow out from that small hull fast enough to counter the rate of the pump.

Additional campaign difficulty settings:
- Oxygen tank duration.
- Reactor fuel duration.
- Crew vitality.
- Non-crew NPC vitality.
- Shop purchase prices.
- Shipyard purchase prices (buying new subs and upgrades).
- Severity of injuries from failed repairs.
- Mission income.
- Option to disable the husk infection warning messages.
- Renamed the generic "difficulty" setting as "world hostility", since it only affects things such as monster spawns and environmental hazards.

Wrecks:
- Added wrecked variants of chaingun, pulse laser, flak cannon, double coilgun and their loaders.
- New wrecks: Barsuk, Camel, Humpback, Typhon 2, Remora, R-29 and Venture.
- Fixes to the wreck spawning logic: linked submarines and non-hulled spaces are taken into account in the placement, preventing them from ending up inside walls.
- Various improvements and fixes to the existing wrecks.
- Added new, higher-res wrecked versions of the shuttle sprites. Marked the old ones as legacy structures.
- Fixed wrecked hatches' broken sprite rendering in front of characters.
- Added console command ‘converttowreck’ to convert submarines to wrecks more easily.

AI:
- Bots can now be ordered to deconstruct items. There's a separate contextual order for marking items to be deconstructed and a regular order that makes the bots start deconstructing those marked items.
- Improvements to medic AI: they're now better at taking the negative effects of drugs into account, meaning they should be less eager to cause opiate overdoses.
- Made bots better at choosing suits adequate for the current depth.
- Fixed escaped prisoners being unable to seek for weapons in the prisoner transport missions.
- Fixed inability to order bots to turrets that are connected to the periscope via wifi components inside circuit boxes.
- Fixed bots cleaning up active glow sticks and flares.
- Fixed bots sometimes deciding to idle inside docking ports.
- Fixed bots being unable to put two-handed items on their back when trying to use an underwater scooter.
- Fixed medic bots sometimes taking meds from inside their autoinjector headset even if they have suitable meds in a toolbelt or some other container in their inventory.
- Fixed escorted characters (e.g. separatists) attacking you if you steal items from bandits.

Multiplayer:
- Added player-specific voice chat volume sliders (i.e. if a specific player is very loud in the voice chat, you can reduce their volume or vice versa).
- Fixed inability to remove invisible symbols (= special symbols not included in the fonts the game uses) from your name using the name text box in the server lobby. This seemed to be the cause for the mysterious "name contains symbols disallowed by the server host" errors: if your Steam name contained special symbols the game can't render, you couldn't remove them by editing the name in the server lobby.
- Fixed an exploit that allowed getting free items from stores.
- Replaced Reaper's Tax with optional extra skill loss when respawning mid-round.
- Fixed clients' wallets appearing empty when spawning mid-round.
- Reworked the server lobby layout. The goal was to reorganize the UI to group things in a more logical way and to make things easier to find.
- Adjusted the local voice chat range significantly shorter (comparable to the range of the local text chat now).
- Fixed VOIP breaking after changing the resolution.
- Fixed characters sometimes getting assigned different personality traits between clients and the server.
- Fixed inability to hire more crew if you've reached the maximum crew size, and then fire some to make room for more characters.
- Fixed clients not getting notified in any way when a server has disabled downloading mods directly from the server, causing them to just get stuck in the mod download screen.
- Fixed servers without an active host or anyone else managing the rounds getting stuck if the settings were configured in a specific way: if the respawn transport time was set to infinite (shuttle will spawn once, but will never leave the level and allow a 2nd respawn), the shuttle had spawned and all the players left, and someone new joined the server, they wouldn't be able to end the round because they've never spawned, and could also never respawn.

Talents:
- Reworked most of the XP-giving talents to make them more meaningful and balanced.
- Fixed "Fireman's Carry" talent not working on stunned characters.
- Fixed tinkerer talent (which allows repairing items above 100%) causing some oddities with repair thresholds: the item would show up as repairable when the condition percentage (relative to the above-normal maximum condition) was below the threshold, but the repair UI wouldn't show up until it was "actually" below the condition where it should become repairable.
- Fixed talent options displaying as locked (gray frame and a lock icon in the corner) even if you've unlocked them if another sub tree is incomplete.
- “Residual Waste" can no longer be exploited for duplicating FPGA circuits.

Improvements to sub editor's grouping:
- Groups are now called "layers", which reflects their common uses better than "groups".
- Layer options are more easily available in the right-click context menus.
- When a layer is selected, all new entities you place are automatically placed into that layer, so you don't need to manually move every new item you place.
- Added LayerAction as a way for ScriptedEvents to enable or disable layers, useful for modders.

Fixes:
- Fixed some items sometimes falling through holes on the submarine's floor (and sometimes also getting stuck partially inside the floor).
- Fixed campaign saves getting bricked if you save the game during the brief moment when your crew has died, but the "game over" popup hasn't appeared yet.
- Fixed campaign saves getting bricked if you save the game after you've fired some of your crewmates through the HR manager and the remaining characters have died (or vice versa).
- Fixed (traitor) events that require you to fabricate a specific item complete regardless of what you fabricated.
- Fixed being able to fabricate items from just one ingredient, when the one ingredient matches multiple 'variable' ingredients (ingredients where multiple materials are valid, such as assault rifle magazines which require a munition tip, core and jacket). 
- Fixed thalamus organs sometimes spawning in dry hulls, making them die without the player having to do anything.
- Fixed diving suits emitting light when placed in cabinets in the sub editor.
- Fixed waytoascension2 event getting stuck if you choose the "I'll need to think about this" dialog option, end the round, and start a new one.
- Fixed being able to switch submarines using the submarine switch terminals in abandoned outposts or the "dummy outposts" inside normal levels.
- Fixed piezo crystals sometimes spawning close enough to wrecks and beacon stations to zap them.
- Fixed character hover texts (e.g. "[G] grab") not refreshing when you change keybinds.
- Fixed CPR pump animation often causing impact damage to the patient.
- Fixed sonar sometimes not showing parts of the mountain on the ocean floor.
- Fixed beacon stations you've restored during the round not displaying as active on the campaign map until you start a new round.
- Fixed inability to pick up dropped stun batons.
- Wire nodes are placed at the center of the grid cells instead of the corners to get them to align with signal components placed on walls.
- Fixed being able to quickly swap the suit you are currently wearing with a broken suit, by just clicking the broken suit.
- Fixed status effects on certain monster's limbs not working: Charybdis had one that should've made it retreat when it takes heavy damage to the head or mouth, and Fractal Guardian, Moloch and Latcher should've emitted special particles when hit on the weak spots.
- Fixed genetic materials not getting destroyed when a gene splicer gets moved to a duffel bag when a character despawns.
- Fixed language of the units (km/h, m) not changing on the nav terminal when you change the language mid-round.
- Fixed crosshair being mispositioned for a split-second when the character turns around while aiming.
- Fixed leaks sometimes being impossible to repair on "Tail Fin E P2".
- Fixed freezing when you press tab in the sub editor's wiring mode. 
- Fixed duct blocks sometimes casting shadows strangely (leaving a see-through gap between the duct block and the adjacent walls).
- Fixed deconstructing a nuclear depth decoy fabricated with the cheap recipe outputting incendium (even though it's not included in the recipe).
- Characters that have thresher genes or who don't need oxygen for some reason (husk infection/symbiosis) don't consume oxygen from tanks.
- Fixed a rare level generation issue that sometimes prevented certain levels from loading, kicking the game back to the main menu or server lobby with the error message "maximum amount of entities exceeded".
- Fixed door's sound muffling effect behaving inconsistently in MP (sometimes muffling sounds even though the door open).
- Fixed certain keys on an AZERTY keyboard not being recognized as keybinds.
- Fixed steep but short wall pieces launching characters downwards too aggressively.
- Fixed buoyancy still affecting docked subs differently than other subs. A sub with docked subs/shuttles would ascend and descend slightly slower than one where the hulls are all part of the same sub. 
- Fixed gaps' and waypoints' groups resetting in the sub editor when saving and loading.
- Fixed monsters in the idle (or observing) state moving at too slow speed and changing the direction in which they were heading too rapidly when they wander around.
- Fixed enemy subs' and respawn shuttle's crush depths not being set correctly, sometimes causing them to get crushed in late-campaign levels.
- Fixed items in a character's inventory, who's in the main sub, being counted twice in the "owned item" count displayed in the store interface.
- Fixed purchased items spawning attached to a wall if there's no room in your inventory.
- Fixed characters spawned using console commands not getting ID card tags for the sub they spawn in.

Modding:
- Fixed inability to publish mods when the language is set to Japanese.
- Added support for defining the ragdoll by a content path, instead of having to define it by a folder. Allows decoupling a ragdoll from a character.
- Added support for (temporarily) overriding character animations using status effects. Allows, for example, wearable items and afflictions to change the character's walking and running animations (see divinggear.xml and afflictions.xml for usage examples). Note that the vanilla animations are configured using the file name, which makes the game search for the animation file from the folder the rest of the character's animations are in. If you want to make your mod add a custom animation to a vanilla character, you need to configure the animation using a file path instead (e.g. path="%ModDir%/CustomWalkAnimation.xml").
- Fixed variants of character variants not working.
- Added an option to force location types to be owned by a specific faction by adding faction="somefaction" or secondaryfaction="somefaction" to the location type config.
- Fixed inability to drag and drop items into hidden inventories. That can't be done with any vanilla items, but turns out some mods had functionality that relied on this behavior, and we broke it in the latest update.
- Sub editor now warns about rooms with insufficient oxygen output (= if the vents output too little oxygen to support one character).
- Made the joint limit widgets in the character editor (hopefully) a bit more intuitive and easy to use. There's now a gray line that indicates the angle of the limb, and that gray line is what gets clamped between the joint limits.
- Fixed widgets and indicators jittering in the character editor when the character moves.
- The "pitch slide" of turret and ranged weapon charge sounds (used in the vanilla chaingun and rapid fissile accelerator) is now editable using the “ChargeSoundWindupPitchSlide” attribute.
- The deattach speed of repair tools can be edited ("DeattachSpeed" attribute).
- Fixed events that are not allowed at start not triggering if you're in the abyss (or somewhere else a long way away from the destination). 
- Fixed PerCave/PerRuin/PerWreck event settings not working correctly in event child sets (the game created the correct number of events, e.g. 3 if there's 3 caves, but each event happened in a random cave).
- Added an option to make TagAction require the target to be in a module with specific tags
- Fixed NPCOperateItemAction being hard-coded to select Controller components, meaning you could only use it to make the character interact with an item that has a Controller component.
- EventManager now works also in the editor test modes.
- Fixed the “interval” attribute of status effects not working when the effect was defined in limbs.
- Added an option to select a specific wreck and a beacon station in the level editor (simplifying testing when you want to test a specific one).
- Fixed room name selection (accessible in the sub editor when editing a hull) being empty if any text file in a mod includes overrides.
- Fixed reputation bars always showing -100 and 100 as the minimum and maximum, even if a custom faction has a different min/max value.
- Fixed crashing when spawning a humanoid character that doesn't have any head sprite configured for it.
- Fixed crashing when placing a door item that's set to be open by default.
- Fixed OnOpen and OnClose action types only working for playing sounds when a door opens or closes, but not for actual status effects.
- Fixed "custom skills" the character's gained during the round (skills levels the character/job originally doesn't have) disappearing between rounds, and only reappearing when the character gains some skill level.
- Fixed MissionActions that are set to choose from a pool of missions always choosing the same mission.
- Fixed inability to take specific kinds of items from a container that requires holding some item. For example, if you needed to hold a crowbar to access a cabinet, and took an item from the cabinet in a way that forces that crowbar item to be unequipped.
- Fixed WeldedSprites not appearing in the sprite editor.
- Fixed connection panel interface's borders overlapping with the connector sprites on certain resolutions if the panel is very tall.
- Fixed OnImpact effects not working on broken items even if AllowWhenBroken is set true.
- Fixed TriggerComponents no longer applying forces or other effects to characters when they ragdoll.
- Made OnSuccess and OnUse effects usable in Repairables (previously only OnFailure effects worked).
- Fixed event editor crashing if you tried to load an event that had action with attributes set to incorrect types of values (e.g. with a CheckMoneyAction with amount set to a string).
- Fixed "Collider" spawn rotation type when spawning items via a status effect not taking the flipping of the parent item into account, causing e.g. projectiles to launch to the right when aiming to the left.
- Fixed tracer particles not showing up when a projectile is spawned using a status effect indoors.
- Fixed crash if a non-attachable item is made attachable mid-round (e.g. via status effects or console commands) and the submarine then saved.
- Fixed monsters always aiming ranged attacks at the position of the target character regardless of which limb they're targeting. Was not noticeable in the vanilla game, because none of the vanilla enemies tried to aim at a specific limb.
- RequireAimToUse is no longer forcibly enabled on ranged weapons (i.e. it's possible to create a ranged weapon you can fire just by left clicking).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.3.0.4
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed another exploit that allowed crashing servers by sending them specifically crafted malformed data.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.3.0.3
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed an exploit that allowed crashing servers by sending them specifically crafted malformed data.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.3.0.2
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed inability to download missing mods from the Steam Workshop when you're joining a server.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.3.0.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed character face selection not working in the singleplayer campaign setup menu.
- Made the "connection lost" error messages when connecting to a server fails more descriptive.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.3.0.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Epic Games Store release.
- Steam players have the option to enable crossplay between Steam and the Epic Store. When you launch Barotrauma for the first time following our EGS release, you will see a prompt asking whether you want to enable crossplay. If you do not wish to do so, you can decline, and that will be all. You can also update your preferences at any time in the game settings.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.2.8.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Changes:
- Allow scaling most items below 0.1 in the submarine editor again. We set 0.1 as a hard limit because smaller scales caused issues with tiling items (such as labels), without realizing some sub builders have found some creative uses for heavily downscaled items (such as tiny turrets used as "dials").

Fixes:
- Fixed escorted characters trying to leave the sub if they can't find a safe hull to get to (e.g. when the sub is flooded).
- Fixed rotated structures not appearing rotated on the status monitor.
- Fixed wires getting misaligned when saving them in an item assembly.
- Fixed security NPCs being unable to swap batteries in stun batons. 
- Fixed inability to edit the false output of a switch in multiplayer.
- (Finally) fixed texture offsets on tiled sprites such as background walls behaving erratically on non-default texture scales and mirrored entities.

Modding:
- Fixed crashing if an affliction prefab contains stat values with a duplicate type, or multiple stat values whose type can't be parsed.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.2.7.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed an issue that sometimes caused the game to crash without generating a crash report (which would lead to a "pipe was broken" error if the issue happened server-side). The issue had to do with a stack overflow when throwing specific kinds of console errors: one common case was when the game failed to connect to our server to check the GameAnalytics consent, which lead to a crash on startup.
- Fixed piezo crystals sometimes spawning right at the start of the level.
- Fixed assistants not being able to pick all tier 1 and 2 talents.
- Fixed location names disappearing when locations change their type in saves started in pre-1.2 versions. 
- Fixed selection rectangle disappearing from items when zoomed in by more than x2 in the sub editor.
- Fixed "killcrawlerswarmlarge2" mission not having a description.
- Fixed bots sometimes choosing to wear broken diving suits.
- Fixed currently visible particles freezing when lowering the particle limit. 
- Fixed dragged characters always colliding with stairs, making it impossible to drag them past the stairs.
- Fixed "drunken sailor" talent not nullifying the negative effects of drunkenness.
- Fixed stun from the "lightning wizard" talent activating if you cause damage to yourself (e.g. by breaking a wall and taking damage from the shrapnel).
- Fixed escorted security officers sometimes inspecting the crew for stolen items during escort missions.
- Fixed basics tutorial sometimes getting stuck in the "weld leak" objective.
- Fixed ancient weapon not flipping horizontally when aiming it to the left.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.2.6.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Added some more logging to diagnose the mysterious "pipe was broken" crashes. These seem to happen when the server crashes in some way that prevents it from generating a crash report or communicating the reason of the crash to the clients. Now the "pipe is broken" crash report should include the exit code of the server process, giving us more clues for diagnosing the issue, and the server should create simplified crash report if there's some kind of an issue with creating the normal crash report.

Changes:
- Structures can now be rotated in the sub editor!
- Outpost security is now better at catching thieves: they can do random inspections to check for stolen items (more frequently if your reputation is low or if they've caught someone in your crew stealing), and notice if you're visibly carrying or wearing any stolen items.
- Option to get the items you're buying from an outpost store in your inventory immediately, as opposed to them being delivered to the sub at the start of the round. There's also now an anti-griefing setting for disabling this, in case you want to make sure a griefer can't easily gain access to dangerous items in the outposts. Players with campaign management permissions aren't affected by the setting.
- Added new variants of the Monsters Nearby and Submarine Flooded tracks.
- Minor adjustments to level layouts: all the levels now slope down a bit to give the impression you're actually heading deeper.
- Clicking on a door that's set to not toggle when clicked (= door that just send out an activate_out signal when clicked) doesn't activate the door's "toggle cooldown".
- Bots operating turrets can now lead targets (i.e. aim ahead of a moving target). Bots with a higher weapon skill are better at estimating the future position of the target.
- Minor balance change to sub vs sub combat. AI-controlled subs get at least 2 security instead of 1, so more turrets will be manned.
- Bots can see through windowed walls (also making it easier for them to spot stealing).
- Added bilge pumps and duct blocks throughout outposts. Otherwise the outposts can never drain if the player causes a flood.
- Removed karma restrictions from jobs. This feature wasn't communicated anywhere, and it often just seemed like a bug when someone didn't get assign the job they wanted due to their karma being too low.
- Added bullet casing particles to firearms.
- Adjusted default throwing pose a bit: characters don't extend their arm as high up, because it could cause the throwable item to hit the ceiling in roughly door-height rooms. 
- Most message boxes can be closed by pressing enter (more specifically, all boxes that are created with just the "ok" button).
- ID cards left in a duffel bag are automatically removed at the end of the round.
- Added a light to handheld sonar to indicate when it's on + made the ping a bit higher in pitch to differentiate it from the sub's sonar.
- Reduced the forces applied on characters by fractal guardian's melee attacks. The previous values were so high they often lead to characters getting stunlocked when the attacks threw them against the walls of the ruin.

Traitors:
- Three new Danger Level 1 traitor events: Exhibitionism, Firing Blanks, The Original Honkero.
- Five new multi-traitor events: Gnawing Cold, The Clobbery Robbery, Husk Roulette, Duck Side of the Moon, Powered by Faith.
- Fixed "Insurgency" achievement not unlocking when completing a traitor event.
- Fixed traitor-specific items sometimes being requested by stores.
- Fixed visibility checks in some traitor events having infinite range.
- Don't allow the victim's body to despawn in the "dead or alive" event because it'd interfere with completing the event (others finding the body).

Optimization:
- Significant optimization to situations where a bot is idling and has trouble finding a path to another hull. Caused performance issues in colonies in particular.
- Fixed a memory leak that caused the memory usage to increase every round.
- Fixed firing turrets (or doing any other action that spawns lots of new entities) causing an enormous performance drop in some situations. Had to do with specific scripted events re-checking their targets whenever a new entity spawned, which was needlessly heavy and was done unnecessarily often.
- Miscellaneous small optimizations.
- Optimized labels (large labels with a scaled down texture in particular were unnecessarily heavy).
- Optimized Watcher's status effects.

Multiplayer:
- Option to hide servers from the server list.
- Option to report inappropriate servers on the server list.
- Added "MinimumMidRoundSyncTimeout" server setting. Determines how long the server waits for a mid-round joining client to get in sync before disconnecting them.
- Fixed workshop item downloads sometimes getting stuck when opting to install server mods from the workshop. Happened if the mod had already been installed, was in the process of being installed, or if it couldn't be installed for some reason.
- Fixed dedicated servers with lots of mods enabled not showing up in the server browser.
- Fixed Text and NPCConversation files being required to be in sync between clients and the server, meaning if you were using a mod that changes the game to a different language, it'd get disabled when you joined a server that's not using the mod.
- Fixed lack of unban option in the "manage client" menu and the client context menu.

Talents:
- Five new assistant talents: Starter Quest, Mule, Jenga Master, Indentured Servitude, Tasty Target.
- Fixed "junction junkie" not working on sonar monitors.
- Fixed a couple of inaccurate talent and mission descriptions in Russian.

Skill gain balancing:
- Now takes longer to reach max skill level, the Helm skill especially was leveling way too fast.
- Helm skill levels up based on the submarine's speed.
- Added an exponent factor to the skill increases for diminishing returns at higher skill level.
- Increased skill gains at lower levels to compensate.
- Welding gives more skill.
- Fabricating items gives less skill.

Fixes:
- Fixed "camera zoom effect" taking a very long time to appear when pressure is increasing inside the sub, giving you very little time to react when the pressure gets to a lethal level.
- Fixed turret lights always being forced on at the start of the round.
- Fixed lighting artifacts that looked like thin slivers of light and strange jagged lighting that sometimes occurred in corners of rooms or places where multiple walls meet.
- Fixed lights shining through obstacles in some very specific situations (one common spot was the windowed door at the left side of Dugong's command room).
- Fixed turret lights sometimes disappearing from view when you're far from the turret (but still close enough to see the light).
- Fixed "bad vibrations 2" event getting stuck if you choose the option to sleep.
- Fixed components disappearing from a circuit box if you delete one in the sub editor and undo the deletion.
- Fixed a rare crash when you'd selected text in a textbox and changed the language of the game to one where the word in the textbox is shorter than in the previous language.
- Fixed handcuffs appearing to continuously drop from characters in certain situations in multiplayer (more specifically, if the character has been disabled and re-enabled during the round).
- Workaround to a rare mystery issue that seems to sometimes cause save files to get corrupted. It seems in some situations the submarine doesn't get included in the save: now the game checks whether the submarine is included before attempting to save the file, and refuses to save if it isn't. This does not solve the underlying issue, but should make it easier for us to diagnose why the submarine gets left out, and prevent corrupting the save when it occurs.
- Fixed "operate turret" orders showing the order marker on the turret instead of the periscope.
- Fixed respawn shuttle lights shining through the top of the level.
- Fixed flares (or other "provocative" items) not attracting monsters when you're wearing a diving suit, because the diving suit was also considered a "provocative" item.
- Fixed ability to put items into circuit boxes by dragging and dropping and with the inventory hotkeys. This caused the components to end up in an invalid state, leading to errors when loading the next round.
- Fixed custom ID card tags not getting applied to ID cards when switching subs. 
- Fixed subinventories constantly opening and closing when you're hovering the cursor over the inventory slot with 2 different containers equipped (e.g. 2 storage containers).
- Fixed bots being able to take ammo out from non-interactable items or items whose inventory is set to be inaccessible.
- Fixed progress bars being visible through walls when someone uses a repair tool, damages an item with a projectile or a melee weapon, or crowbars a door open.
- Fixed crashing if you're in an outpost level with no outpost. Should normally never happen, but can occur with e.g. outdated save files or mods.
- Fixed ballast flora spores (or any other level object with no actual sprite) not being visible.
- Fixed bots "cleaning up" items from inside artifact transport cases.
- Fixed ability to sell components from inside circuit boxes in outposts.
- Fixed outpost NPCs not caring about the players starting fires.
- Fixed purchased items sometimes spawning in the cargo crates when you've got a cargo mission active, making them potentially very hard to find.
- Fixed inability to select a component you've just placed in the circuit box until you move the component for the first time.
- Fixed health scanner HUD texts overlapping on high resolutions.
- Fixed "maintain position" marker being misplaced on the navigation terminal on some resolutions.
- Fixed chance of tainting the genetic material when refining sometimes being displayed incorrectly on research stations.
- Disable the health interface of the patient in the "good samaritan" event. Prevents being able to heal the opiate overdose "normally" before triggering the event.
- Fixed item hover texts (e.g. "[E] Repair") not refreshing when changing keybinds.
- Fixed fabricator listbox scroll always resetting to the top when someone selects the fabricator.
- Fixed bandoliers not affecting pulse laser fire rate.

Modding: 
- When running an outdated executable (i.e. a mod that overrides the game executable, but hasn't been updated yet after a new vanilla update has been released), there's a notification in the main menu and the "host server" menu warning you about the potential issues caused by running an outdated executable with the other up-to-date vanilla files.
- Console errors and warnings caused by modded content include the name of the mod to make it easier to diagnose which mod is causing some issue or whether it's an issue in the vanilla game.
- Support for overriding texts. Works using <override> elements, the same way as overriding any other content.
- Fixed decorative sprites not being visible on items placed in a container. Did not affect any vanilla content (there were no decorative sprites on any item that can be visible in a container).
- Fixed characters with no AI defined causing crashes.
- Fixed inability to make StatusEffectAction modify the properties of an ItemComponent (only worked on the actual Item).
- Option to have multiple conditionals in CheckConditionalAction.
- Option to limit how many times a GoTo action can be executed (i.e. to create loops that only repeat a given number of times).
- TutorialHighlightAction can now be used in multiplayer too, renamed it as HighlightAction.
- Fixed first matching Containable definition of an ItemContainer determining the hiding, position and rotation of a contained item, disregarding which subcontainer the item is actually in. E.g. if a weapon had 2 subcontainers for magazines, both with a different ItemPos, the ItemPos defined in the first subcontainer would be used for both magazines.
- Fixed stun batons not accepting modded batteries because the RequiredItem s were configured using identifiers instead of tags.
- Fixed Character.CameraShake setting the camera shake regardless if the character the effect is being applied on is the controlled one or not.
- Location names can now be translated. In the vanilla game the names are only translated if you're playing in Chinese.
- Fixed some ConversationAction options going outside the bounds of the dialog if there's a very large number of them.
- Fixed inability to use %ModDir% in LevelGenerationParams.ForceBeaconStation.
- Fixed status effects configured to spawn an item in ContainedInventory not spawning the item if it can't go inside the first item in the contained inventory.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.19.3
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed shrapnel from flak cannon ammo always launching upwards.
- Fixed wall damage shrapnel going through walls and being a little excessive overall.
- Fixes to pressure distribution logic: fixes pressure sometimes being lethal in breached rooms that weren't full of water.
- Fixed clients not regaining control of their braindead character after rejoining if the character's taken any amount of damage while braindead. 
- Fixes to inconsistent stack sizes (e.g. certain ammo types stacking up to 12 in character inventories, but only 8 holdable/wearable items like backpacks and toolbelts.
- Fixed console errors when switching subs with circuit boxes on board.
- Fixed items that are inside a container that doesn't get transferred getting duplicated during item transfer when switching subs.
- Fixed bots not cleaning up circuit boxes from the floor.
- Fixed stack size being displayed incorrectly in the tooltip when dragging a stack of items to an already-occupied slot.
- Fixed nav terminal's docking button not working if the signal is routed from the terminal to the docking port through a circuit box.
- Fixed double-clicking a component while a circuit box is equipped making the component vanish inside the circuit box.
- Fixed chat messages sent when accusing someone as a traitor not triggering the spam filter.
- Fixed connection names not being translated in circuit boxes (always showed up in English).
- Fixed right-side crew panel overlapping with the mission panel in the PvP mode round summary.
- Fixed depleted and fulgurium fuel rods stacking up to 32 (should be 8 like all other fuel rods).

Modding:
- Added "UseHumanAI" property to characters (can be used to enable the human AI on characters other than humans). While using the human AI on non-humans isn't a fully supported or tested feature, it was previously possible to do that by creating a human prefab using a different species than human, but that no longer worked as of the Treacherous Tides update.
- Attachable holdable items don't count as "HoldableOrWearableInventories". Fixes e.g. tanks only stacking up to 1 in things like movable cabinets and shelves. Does not affect any vanilla content.
- Fixed fabricator reducing the condition of all the available ingredients if the crafting recipe reduces condition instead of consuming the whole item.
- Fixed TagAction continuing in some situations when it can't find targets, even if it's been configured not to with the "ContinueIfNoTargetsFound" attribute. 

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.18.1
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed opening the "load game" menu crashing the game if you have any corrupted/unloadable saves in the save folder. In multiplayer, this would just prevent opening the campaign setup menu without any error messages.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.18.0 (Treacherous Tides)
-------------------------------------------------------------------------------------------------------------------------------------------------

- Updated translations.
- Modding: Added ContinueIfNoTargetsFound property to TagAction. Can be used to allow the event to continue even if the TagAction can't find any valid targets (by default the event wont continue until at least one target is found).

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.17.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Changed traitor event selection logic a bit: most of the more dangerous events can trigger as long as a less dangerous event has been selected previously, even if that event wasn't completed successfully. Previously many of the dangerous events were extremely rare, because they required 1. completing an easier event first 2. a specific mission to be selected on the following round.
- Adjusted traitor event probabilities a bit to make some of the rarer ones more common.
- Fixes to some oddities and inconsistencies in containers: backpacks can't go in crates, duffel bags or outpost cabinets, fixed storage containers going in outpost cabinets.
- Fixed searchlights appearing as turrets in the "operate weapon" order (and the bots would complain about not being able to load ammo into them if you ordered them to operate one).
- Fixed security fleeing from the player during jailbreak missions.
- Fixed security not spawning in jailbreak missions in the mission mode.
- Fixed morphine not being shown as a suitable treatment for the concussion in the medic tutorial.
- Fixed abandoned outpost you're supposed to rescue Jacov Subra from sometimes turning into a normal outpost and cancelling the mission.
- Fixed some scripted events throwing unnecessary "no conditionals defined" console errors.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.16.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed several issues when editing traitor events in the event editor (console errors, some actions not loading properly, inability to set a new event as a traitor event).
- Backpacks can't be put in cargo scooters.
- Fixed some traitor events being impossible to complete (harbringer of honks, faulty robes, handcuff shortage).

- Fixed latcher's tongue failing to attach to submarines.
- Fixed crashing when deleting a circuit box in the submarine editor. Undoing the deletion still does not work unfortunately, but we are looking into fixing that.
- Fixed errors when modifying any properties of an ItemLabel or Turret component in multiplayer.
- Fixed flashlights in guns (or other contained items) not getting flipped in the same direction as the container when put inside the container. 
- Monsters don't get damaged by the hull shrapnel when they break a wall themselves.
- Fixed "can't create an entity event" error when ending a multiplayer round when there's dropped stacks around. 

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.15.0
-------------------------------------------------------------------------------------------------------------------------------------------------

- Fixed console errors when there are swarm feeders (or other monsters that immediately despawn when killed) in an irradiated level.
- Fixed occasional crashes when firing a turret makes a supercapacitor drop to 0% charge.
- Fixed circuit box only outputting to one pin when wired directly from input to multiple output pins.
- Fixed tutorial reactor starting already powered up, making the first engineer tutorial objectives complete immediately.
- Miscellaneous tutorial fixes.

-------------------------------------------------------------------------------------------------------------------------------------------------
v1.1.14.0
-------------------------------------------------------------------------------------------------------------------------------------------------

Traitor overhaul:
- Completely redesigned traitor system, which also now works in the campaign mode.
- The traitor missions (now called "events") have been implemented using the scripted event system, and can be created in the event editor. We unfortunately had to drop support for the old system; even though we aim to not do any backwards-compatibility breaking changes now that we're past 1.0, after evaluating the number of mods that include custom traitor missions and seeing how few there are, we felt that it's better to depreciate the old system instead of maintaining two separate systems. We're sorry for the inconvenience, but we're hopeful the move to the scripted event system will allow modders to create more complex traitor events much more easily!
- A total of 27 completely new traitor events.
- Multi-traitor events and code words are back!
- Instead of the yes/no/maybe traitor setting, you can choose the probability of a traitor event per round (e.g. 50% = a traitor event happens on half the rounds on average).
- Each event has a "danger level" that describes how destructive/dangerous the event is. You can choose how dangerous events can get chosen in the server lobby, for example if you don't want very destructive traitor objectives in the campaign mode.
- If a traitor completes their objective successfully, they may get assigned a more dangerous objective on future rounds (up until the maximum defined danger level is reached).
- Players who haven't been traitors before/recently have a higher chance of getting selected as traitors.
- In the campaign mode, completing a traitor objective gives the traitors rewards such as getting to "steal" a portion of the mission experience.
- The players can vote which player they suspect as the traitor. At the end of the round, if at least half of the players have voted for the same player, that player will be accused as a traitor. If the accusation is correct, the traitor's objective will fail and they will receive no rewards. If the accusation is incorrect, the crew will receive a monetary penalty.
- Added various new traitor items, perhaps most notably the Radio Jammer, a handheld battery-powered device that temporarily disables radio communications (both text and voice chat).

Stacking and storage changes:
- Added Backpack, essentially a larger variant of the toolbelt with a small speed debuff. Can be obtained through the new assistant talent "Bag It Up", and purchased in stores around mid-way through the campaign.
- Oxygen and fuel tanks no longer stack in player inventories, but their capacity has been increased to compensate. A stack of oxygen tanks would last nearly 45 minutes (and that's not even accounting for high-quality tanks), which meant you could easily carry so much oxygen that running out is practically never a risk.
- Increased stack sizes of most items (such as materials, ammo, meds) to 32.
- Increased cabinet capacities.
- Storage containers can no longer be put in normal cabinet slots. The intention is to prevent being able to use storage containers as a way to significantly increase cabinet capacity (all the way up to 2880!). The larger stack sizes and increased cabinet capacities still allow storing a very large number of items, without having to resort to storage containers which make managing the items in the cabinet more inconvenient.
- Cabinets now have a handful of special "extra slots" specifically for storage containers. Storage containers have other uses besides just increasing storage capacity, and these extra slots are intended to keep them a viable option for those other uses.
- Added buttons for merging stacks and alphabetical sorting to all cabinets.
- Dropped stacks of items behave as one physical object and can be picked up by clicking once, instead of the stack becoming a bunch of individual items that need to be picked up one-by-one.
- Restricted the maximum stack sizes of character inventories and holdable/wearable containers to 8. Meaning you can carry 8 items per slot, but cabinets and crates can fit the "full" x32 stacks.

Talents:
- Fixed "By the Book" giving you the bonuses regardless if you complete a mission or not.
- Changed how Scavenger talent works: previously it had a chance of doubling the loot in a container, which often led to excessive amounts of loot (and other times, no extra loot at all). Now the chance works per-item instead.
- Fixed nuclear shells and depth charges fabricated with the "Nuclear Option" talent providing incendium when deconstructed, even though it's not used in the fabrication recipe.
- Fixed having one captain with the "Leading by Example" talent and another with "Family" messing up the afflictions applied by them (one trying to apply "Excellent Morale" and the other trying to remove it).

Misc changes and additions:
- Added Circuit Box, an item that allows creating circuits without having to fabricate and place each component individually on the sub's walls.
- Added lights that indicate the ammo status to turret loaders.
- Characters "grab" the device/item they're interacting with, making it easier to see e.g. whether a character is taking something from a cabinet or just standing next to it.
- Allowed any type of ammo box to be used in the turret ammo box recycling recipes.
- Improved explosion particle effects.
- Added a new abandoned outpost mission variant (relating to one of the shadier factions).
- Pets become unhappy faster. Previously the happiness decrease rate was so low the pets were more likely to starve to death than to become unhappy.
- Pets no longer regenerate health when they're well-fed. This was a leftover from the 1st implementation of the pets, and is no longer necessary, because they now regenerate health while eating.
- Repositioned item interfaces retain their positions between rounds.
- Killing/handcuffing the terrorists during escort missions is no longer required to complete the mission. Fixes other means of detaining them (such as brigging, stunning or paralyzing) not being considered valid before.
- It's now possible to access the gene splicer slot of dead/incapacitated characters.
- Increased fruits' impact tolerances to prevent them from breaking when falling.
- Tweaks to the sound effects when under high pressure.
- Underwater scooter's light turns on when aiming (not just when actually using the scooter).
- Captain's pipe and cigar are used by holding RMB (not LMB+RMB) to make their usage consistent with other "consumables".
- Added broken state sprites for Thalamus' fleshspike and fleshgun. Adjusted the fleshgun particle effect.
- Made characters only flip from one side of a ladder to another when aiming. Makes it easier to interact with things next to the ladder, when the character doesn't automatically flip to the "wrong side" when you try to highlight something.
- Beacon station and cave markers are removed from the sonar once the beacon/cave mission is completed.
- The Output and FalseOutput of switches and periscopes are editable.
- Added a "disable_output" pin to supercapacitors and batteries. Particularly useful for auto-operated turrets, as it can be used to power them down.
- Made auto-operated turrets much better at using pulse lasers, chainguns and other turrets that need to wind up before firing. Previously the AI was too eager to switch between targets, as opposed to waiting for the turret to wind up and actually fire.
- Added "activate_out" output to doors (outputs a signal when someone toggles the door) + an option to make the door NOT open/close when someone tries to toggle it. Can be used to run a signal through some external circuit when someone tries to open a door with integrated buttons.

Balance:
- Adjusted ammo fabrication recipes to fix lead being too scarce (considering it's needed for almost all ammo types). Now ammunition can be fabricated from different materials, not just lead.
- Revisited the contents, the difficulty, and the rewards of monster missions.
- Balanced reputation gains from missions: it should now be less easy to maintain a positive reputation with all factions.
- Slightly increased character impact damage (i.e. damage taken when you fall or get thrown against something).
- Being under high pressure causes organ damage. Without this, it's possible to basically ignore high pressure as long as you're quick (e.g. you can briefly go outside or to a breached ballast to fix walls).
- Made gravity sphere, guardiansteamcannon and guardianbeamweapon cause a bit of radiation sickness. Afflictions that can't be treated with morphine + bandages should be more common, so here's some!
- Piezo crystals cause a bit of stun and burns on characters.
- Nerfed fractalguardian_emp a bit: longer attack cooldown, shorted EMP range. The previous values made it too easy to get softlocked.
- Added 50% flow resistance to makeshift armor to make it more effective in indoors combat.
- Revisited the effects of liquid oxygenite and the oxygen related effects of deusizine to keep them balanced. Reduced the required skill for applying liquid oxygenite to compensate for the failure effects.
- Reduced Mudraptor's priority of eating dead bodies with the intention of making it not as easy to distract them killing one in a pack.
- Improved the monster nest mission progression by introducing harder variants of all the missions. Adjusted the existing nest missions a bit.
- Buffed the ancient weapon: increase the burn damage from 40 to 50, make them ignore 50% of armor protection, allow them to cut off limbs and break (some) armor. Add stun for stopping power.
- Defined fire damage (on ballast flora) and AI combat priority for the ancient weapon.
- Set the treatmentthreshold for oxygen loss to 100, so that the bots won't try to treat patients so eagerly. Now they should react only slightly before the target faints. Note that this also affects when the suitable treatments are shown in the health interface.

Optimization:
- Optimizations to situations when there's lots of NPCs nearby. Particularly noticeable in very crowded outposts.
- Optimized the Load Game menu in both singleplayer and multiplayer, dramatically reducing the time the game freezes when opening it.
- Optimized flashlights and other directional lights.
- Loading optimizations (loading screens should now be noticeably quicker).
- Thalamus: spawn the initial cells when the AI is loaded (at the round start) instead of doing that when the player is close by. Gets rid of the notable lag spike when approaching a Thalamus infested wreck.
- Miscellaneous smaller optimizations.

Submarines:
- Reworked Berilia.
- Reworked R-29.
- Linked fabricators to the cabinets next to them in all vanilla subs.
- Various fixes and improvements to Orca.
- Fixed waypoints outside the submarine not being disabled as obstructed when the connection doesn't overlap a wall.
- Waypoint fixes to most player subs.
- Fixes to transferring items between subs: some items that didn't fit into cabinets weren't put into crates even if they could've been, and some items spawned unnecessary crates because they were configured to spawn in a crate despite being too big to put in one.
- Fixed incorrect "low on fuel" warning when switching to a new sub with no fuel, even if you have fuel in your current sub and opted to transfer them to the new one.

Multiplayer:
- The skill loss on death can be adjusted in the server settings. Defaults to 50% (previously 75%).
- Fixed characters keeping all the injuries they've received while being "braindead" (killed due to disconnecting), meaning if you for example hack the character to pieces while braindead, and the character respawns next round, they'll spawn dead.
- If a client joins when their character is "braindead" (killed due to disconnection), the character is now revived and the client immediately regains control of it. But only if the character's vitality is above 0 - if they have received other lethal injuries or despawned, they'll have to wait for a "normal" respawn.
- Fixed icon in server details panel in the server list saying that every server is modded.
- Fixed clients spawning as characters even if they've opted to spectate if the game mode is switched from campaign to some other mode and back.
- Fixed fabricator sometimes starting to fabricate an incorrect amount if you click the "start" button quickly after adjusting the amount.
- Fixed occasional "received invalid SetAttackTarget message" errors in multiplayer. Happened when some attack caused the target to be killed and despawned immediately (e.g. when a pet was instakilled by a monster).
- Fixed inability to attach items to walls outside the sub in MP.
- The outpost manager is always killable in the Tormsdale report event even if the killing outpost NPCs is disallowed on the server.
- Fixed certain kinds of network messages being sent using an unreliable delivery method (potentially causing occasional issues with file transfers and traitor messages).
- Fixed inability to choose or vote for a sub if you don't have all the content packages required for the sub.
- Fixed clients not seeing the votes of anyone who voted before them on the ready check.
- Fixed dropping off ladders when you open your own health interface in multiplayer.
- Fixed changing character appearance triggering the "wait X seconds until you can rename again" warning.
- Fixed replaced shuttles not getting repaired client-side when you purchase the replacement, making it look like you can't repair them (because they're already repaired server-side). 
- Fixed handheld sonar beacon's textbox becoming empty when you enter something in it in multiplayer.
- Fixed "Attempted to create a network event for an item That hasn't been fully initialized yet" console error when spawning a sonar beacon mid-round.
- Fixed characters getting removed at the end of the round if they've died and then been revived with the "revive" console command.

AI:
- Fixed bots "cleaning up" (or stealing) batteries from portable pumps.
- Fixed bots never cleaning up detached wires.
- Fixed bots sometimes ignoring the leaks right next to doors/hatches.
- Fixed bots cleaning up items that are being eaten by a pet.
- Monsters not ignore provocative items in the inventories of characters they're configured to ignore (with the targeting state "Idle"). Fixes husks attacking characters that are wearing cultist robes with a diving suit.
- Autopilot now avoids the floating ice chunks using the same logic it uses to avoid ice spires.
- Defined AI combat priority for the alien pistol.
- Adjusted the combat priorities of flamer and steam prototype gun.
- Fixed bots sometimes drowning in the ballast because they didn't think they'd need diving gear if the ballast is not full (but still has enough water to drown).
- Fixed bots sometimes preferring to get a new weapon instead of reloading their current one, even if they had easy access to more ammo.
- Fixed bots accepting orders but not doing anything while handcuffed. The bots will now refuse to do things that they need hands when they are handcuffed. 
- Fixed bots still sometimes getting stuck on corners around staircases.
- Bots don't attempt to repair or fix leaks in non-friendly subs (e.g. wrecks or ruins).
- Bots don't attempt to clean items in the main sub in outpost levels.
- Fixed bots sometimes just swimming around when they should be able to get back to the sub.
- Fixed orders persisting even if the target no longer exists after a sub switch (e.g. a bot might attempt to operate a turret that doesn't exist, resulting in them doing nothing).
- Fixed "follow" order not always persisting between rounds.
- Bots don't try to use stabilozine to treat deliriumine poisoning. It only slows down the progress of the poisoning, which is kind of pointless in the case of the non-lethal deliriumine poisoning.

Alien ruins and artifacts:
- The ruins now start smaller and grow bigger gradually, depending on the difficulty level.
- Ruins start to appear a little later in the campaign (in the second biome).
- Initially only "scan ruin" missions are given, "ruin salvage" and "clear ruin" missions don't appear until later.
- Adjusted the loot distribution in the ruins.
- Fixed guardians and defensebot(?) spawning the blood decal when they get dismembered.
- Fixed guardian pod damage sounds sometimes being inaudible.
- Artifact transport cases require batteries to nullify the effects of the artifacts. The batteries last a little over 8 minutes. Also added some animations and lights to the case when powered.
- Made Faraday Artifact's EMP effect a little stronger, and added a discharge coil effect out of water.
- Thermal Artifact now emits steam in water that burns and damages walls.
- Nasonov Artifact now also disrupts the sonar. Added particle effects.
- Psychosis Artifact now generates watcher's gaze periodically, causing psychosis/nausea and strengthening nearby monsters.
- Sky Artifact now drains water on top of draining oxygen, making them a little more tricky to deal with.
- Doubled the price of all artifacts.
- Fixed artifacts never spawning as random loot in ruins.

Fixes:
- Fixed 2nd end level being impossible to complete if you've already completed the campaign once, because the logbooks didn't respawn on the 2nd loop.
- Fixed inability to equip one-handed items when you're holding a one-handed container that item can go inside (e.g. trying to equip a revolver while holding a storage container would just put it in the container).
- Fixed an exploit that allowed giving your ID card access to places it shouldn't have access to (by placing it in the inventory of e.g. a bot captain and saving and reloading).
- Fixed mollusk and skitter genes giving much less vigor/hyperactivity than intended, making them practically useless.
- Fixed crashing if you change the language when there's scrolling texts (such as "your skills might be insufficient...") visible on the screen.
- Fixed an exploit that allowed using beds/chairs and crouching to trigger a sort of "noclip".
- Fixed particle "z-fighting" (particles flickering in front of each other). Was particularly noticeable with smoke particles.
- Fixed lighting and LOS behaving strangely on very long walls (not extruding far enough to cover the whole screen, allowing you to see through the wall). 
- Fixed rifle reload sounds sometimes not playing if you fire in very rapid succession.
- Fixed files listed in file dialogs (such as when choosing a thumbnail for a mod) being in an inconsistent order on Linux.
- Fixed gaps generating strangely on "Shuttle Shell A Glass A".
- Fixed autoturrets being unable to fire inside hulls.
- Fixed “badvibrations3” event (last part of the event chain where you're assigned to salvage a psychosis artifact) never triggering.
- Fixed "sleight of hand" event not giving you the trinket if you choose the 1st dialog option.
- Fixed husk symbiosis getting removed from characters after finishing the campaign.
- Fixed heavy wrench not stunning unskilled users like it should.
- Fixed Jovian radiation no longer causing any noticeable radiation sickness, because it healed faster than the Jovian radiation causes it.
- Fixed chaingun's "winding up" sound not following the sub.
- Only allow putting syringes in autoinjectors (autoinjecting bandages doesn't make much sense, and doesn't work properly).
- Fixed submarines getting stopped by the collider of the acid mist emitted by acid grenades.
- Fixed connection panel layout not working properly on very large resolutions (pins being excessively large and/or going below the borders of the panel's frame).
- Fixed an issue in the "toy hammer" task given by the Jestmaster. The event would never complete, and instead just endlessly increase your reputation when hitting the monster with the hammer.
- Fixed occasional "no suitable return target found" console errors when leaving a location.
- Fixed explosive slugs exploding in the barrel when shot into the void in the sub editor's test mode.
- Fixed attaching items in-game not aligning them with the grid the same way as in the sub editor (offsetting them by half the size of the grid).
- Fixed event trigger icon (the yellow exclamation mark) hiding the conversation icon when an event targets the outpost manager.
- Fixed husks sometimes moving at an unintendedly slow speed on land, making the walking animation look strange (sort of sliding while barely moving their feet).
- Fixed text display's light turning off when copying one in the sub editor.
- Fixed 40mm grenades not exploding in nuclear shells.
- Fixed bringing the cursor over the inventory interrupting using tools and weapons.
- Minerals can't be grabbed before they've been detached with a plasma cutter (it was confusing to be able to grab the item and have the "detaching" progress bar appear, despite it doing nothing).
- Fixed sonar not displaying markers for other subs in the sub editor test mode.
- Fixed fabricator UI not refreshing the skill/time requirements when selecting a linked cabinet instead of the fabricator itself.
- Fixed fabricator not being able to pull materials from the user's inventory if the user selected a linked cabinet instead of the fabricator itself.
- Fixed submarine preview highlighting hulls that have the same name even if they're not linked or near each other.
- Fixed rope pull force originating from the item's origin instead of the barrel.
- Improved how electrical discharge coils determine which walls are outer walls: use the actual position of the structure's body, and check if there's hulls at either side of it.
- Fixed submarine wall "shell a combo 1 1" being incorrectly configured as a horizontal wall. Caused EDC to behave strangely on these walls.
- Fixed monsters sometimes spawning within the player's sight in wrecks (or ruins).
- Fixed corpses carried to the sub from a wreck just disappearing at the end of the round along with the items in their inventory.
- Fixed infinite loop in Character.CanInteractWith if the target item is in a container it's linked to, and has been configured to be displayed side-by-side. For example, if you place a cabinet linked to a fabricator inside the fabricator.
- Fixed incorrect type of airlock module being sometimes used in levels between outposts (e.g. a colony airlock module even though the outpost is a normal one).
- Fixed 40mm acid grenades sometimes appearing to explode in the grenade launcher client-side.
- Fixed nuclear reactor's explosion effects sometimes not being visible client-side.
- Fixed holdable item's sprite origin not getting mirrored on the x-axis. There was a previous attempt at fixing this, but it didn't work correctly: it adjusted the position where the item is held, in a way that made the sprite appear at the correct position. The sprite origin shouldn't affect the position of the item's body though, just where the sprite is drawn relative to the body. The previous fix also didn't take flipping into account, causing the body to be "the wrong way around" when facing left.
- Turn the reactor auto temp on at round end, if the reactor is actively managed by a bot. Fixes reactor sometimes generating too much power at the beginning of the rounds. Only happens later in the game when the bot operating the reactor is skilled enough to manually manage the reactor.
- Fixed thalamus being allowed to load the cheap nuclear shells (talent item) when it loads the railgun.
- Fixed a rounding error making some hairs/attachments in mods impossible to select.
- Fixed some properties of wearable InheritLimbDepth, InheritScale, InheritSourceRect, InheritOrigin being forced to true, and ObscureOtherWearables being forced to None on all wearable sprites except items regardless of what's set in XML.
- Fixed repair tools hitting severed (or hidden) limbs, which sometimes caused the target to not take damage.
- Fixed ancient weapons not being able to cut minerals.
- Fixed "hidden in game" entities + propeller's damage area indicator being visible in images generated with "wikiimage_sub".
- Fixed gaps that aren't linked to anything (e.g. gaps fully inside a hull) counting as hull breaches on the status monitor.
- Fixed contained items in a held item (e.g. flashlight in a rifle, harpoons in a harpoon gun) rotating "choppily".
- Fixed particle "z-fighting" (flickering in front of each other). Was particularly noticeable with alpha-blended particles like smoke.
- Fixed damage from structure damage "shrapnel explosions" being very inconsistent. The explosion didn't ignore obstacles, meaning any structures between the explosion and the character (including the wall the shrapnel comes from) would drastically reduce the damage. This meant the damage was usually very low, but with specific kinds of wall configurations could be enough to instakill a character.
- Fixed characters letting go of the character they're dragging when moving out from or into a sub.
- Changed the formula that converts the rectangular steering vector on the nav terminal to circular. The previous formula caused the "steering arrow" to point at a slightly different direction than where the submarine was actually trying to head to. Most noticeable when controlling turrets using the nav terminal.
- Fixed diving masks reducing movement speed.
- Fixed water in docked shuttles/drones not affecting the buoyancy of the main submarine as much as it should.
- Fixed sub editor sometimes deleting previously selected entities when deleting something using the right-click context menu.
- Fixed monsters sometimes spawning inside the sub after you restore a beacon station.
- Fixed trying to return back from a "deadend location" with no outpost sometimes not working.
- Fixed fractal guardians damaging themselves with their steam cannons.
- Fixed a rare crash caused by an exception in Explosion.RangedStructureDamage. Happened when structure damage triggered an explosion, and said explosion caused another explosion that caused more structure damage. Could happen e.g. when the shrapnel from a breach kills a terminal cell, which explodes and causes more structure damage.
- Fixed auto-operated turrets being able to function without power.
- Fixed it being possible for the last location before the end levels to turn into an outpost if you manage to spread habitation all the way there.
- Changed sonar flora sprite depths to prevent them from being obscured by the edge chunk objects.
- Fixed some headgear (such as separatist captain hats) clipping through PUCS's helmet.
- Fixed lights shining through items characters are holding.
- Fixed ability to clip your turrets through enemy subs' hulls and launch projectiles inside the sub.
- Fixed "heal [H]" hint being visible when focusing on other characters while climbing ladders, and the health interface opening for one frame if you attempt to heal.
- Fixed inability to damage doors with melee weapons from outside the sub.
- Fixed riot shield rotating in a really strange way when swimming (in the wrong direction relative to the character's rotation).
- Fixed Electrical Discharge Coil behaving strangely (drawing huge amounts of power, but never discharging) when there's not enough power and power flowback through EDCs.
- Fixed "show hidden afflictions" button not scaling correctly when switching the resolution.
- Fixed the abandoned outpost you rescue Subra from never turning to a normal outpost.
- Fixed flashlight not being turned off when swapping the item to the belt slot, if there's something else in the slot (like a toolbelt).
- Fixed incorrect draw order of the diving suit's arms (the "shoulder pad" rendered behing the upper arm).
- Fixed "chem withdrawal" and "drunknodebuffs" (variant of drunkenness if you have a talent that nullifies the negative effects) not healing by itself, meaning it was impossible for them to fully heal except by using the medical clinic.
- Fixed captains spawning without tobacco in the pipe (literally unplayable).

Modding:
- Added "AllowAsBiomeGate" property to location types to make it possible to prevent specific location types from being used as the biome gate locations. Previously this was hard-coded: any location with an outpost was allowed, excluding the vanilla "abandoned" location type.
- The equipment slot icons are now defined in the style xml, making them moddable.
- Fixed crashing when the particle a particle emitter is configured to emit can't be found.
- Fixed bots trying to sit in chairs someone is carrying (not possible in the vanilla game).
- Fixed crashing if a mod contains a wearable that alphaclips other wearables (e.g. diving helmet) and its texture can't be found.
- Fixed linked shuttles getting disconnected from ruins and beacon stations when moving them into place.
- Fixed shuttles attached to ruins, beacon stations and outposts having default crush depth. Now it's forced to at least the depth at the bottom of the level + 1000 m.
- Fabricators can now be made equippable without crashing the game.
- Added "TargetItemComponent" property to statuseffects. Can be used to restrict which components of an item the effect targets.
- Fixed inheriting ragdoll texture not working correctly if you have monster A which is a variant of monster B, and monster B is overridden by a mod (e.g. large crawler when the base crawler is overridden by a mod).
- Fixed StatusEffects that target the parent (= the container an item is inside) not being able to access the properties of the container's components, just the properties of the Item class.
- Fixed crashing if a bot tries to repair with a repair tool that doesn't need any kind of fuel. 
- Fixed outpost generator being too eager to use modules meant for a different type of outpost (e.g. abandoned outpost modules in normal outposts) if it can't fit the correct kind of module in the current outpost layout. Now the generator instead tries to change the layout to accommodate for the correct kind of module.
- Fixed MatchOnEmpty and RequireEmpty requiring the whole inventory to be empty even if targeting a specific slot.
- Fixed contained items in contained items being positioned incorrectly when the "middle" container has been flipped from right to left (e.g. railgun shell whose tip is a separate contained item).
- Added IsFlipped property to limbs and characters.
- Conditionals that target limbs can check the character's SpeciesName/SpeciesGroup.
- Always and OnActive effects can be used on limbs.
- Fixed items that are set to display the state of a contained item on the inventory slot (like a gun showing how full the magazine is) always displaying the condition of the contained item, not how full it is. This wasn't a problem in the vanilla game because all vanilla magazines use the condition to simulate the amount of ammo left, but made it impossible to display the state of a magazine that actually contains the bullets as individual items.
- Throwable components can be used in conjunction with Projectile components to create throwable items that can hit and damage characters.
- Fixed bots detaching repairable items from walls when they're trying to repair. Doesn't affect any vanilla content because there's no detachable repairable items.
- Fixed projectiles not sticking to level walls in multiplayer. Does not affect any vanilla content, because there are no projectiles that stick to level walls.
- Fixed ParticleEmitter's DrawOnTop attribute being ignored, causing the DrawOnTop attribute of the particle prefab to always take priority.
- Fixed items deactivating themselves if they have OnContained/OnNotContained effects but nothing else that needs to update (i.e. OnContained/OnNotContained effects not working on items that don't do anything except executing those effects).
- Fixed "packet size exceeded" errors when there's a very large number of items in an inventory (previously only possible in mods, but with the larger stack sizes, also affected the vanilla game).
- Hidden files and directories (ones starting with a dot, e.g. source control folders) aren't uploaded when publishing a mod on the Workshop.
- Fixed penetration defined in RangedWeapon not doing anything.
- Improvements to decorative level object culling. Fixes level objects disappearing from the screen too eagerly when there's lots of objects visible. Rarely occurred in the vanilla game, but was a common problem with mods that significantly increase the amount of level objects.
- Motion sensors set to detect monsters ignore creatures in the "human" group (i.e. you can have friendly non-human characters that are technically monsters, but not have them trigger motion sensors set to only detect monsters).
- Fixed bots ignoring ItemContainer's ContainableRestrictions when reloading ammo (e.g. if you'd set only certain types of ammo to be contained in a loader, bots wouldn't care).
- Fixed only properties that are editable in the editor getting copied to cloned entities in the sub editor. E.g. if you'd edited something like a door's welding state in an item assembly, copypasting the door would make it unwelded.
- New actions for scripted events: CheckVisibilityAction, CountTargetsAction, WaitForItemUsedAction, WaitForItemFabricatedAction, OnRoundEndAction, EventLogAction.
- Made the tutorial objective list non-tutorial-specific and usable in multiplayer, and renamed TutorialSegmentAction as EventObjectiveAction.

---------------------------------------------------------------------------------------------------------
v1.0.21.0
---------------------------------------------------------------------------------------------------------

Fixes:
- Fixed LOS effect sometimes "lagging behind" when the sub is moving fast.
- Fixed some minor visual issues (occasional jitter/flickering) on the LOS effect.
- Fixed some issues in the bot AI that we're causing a large performance hit particularly in situations when there's lots of bots in a sub with leaks.
- Fixed bots abandoning their orders (such as operating a turret) if the room is unsafe (e.g. flooded).
- Fixed an issue in character syncing that occasionally caused disconnects with the error message "Exception thrown while reading segment EntityPosition, tried to read too much data from segment".
- Fixed wires set to be hidden in-game (e.g. invisible circuits built outside the sub) being visible on the Electrician's Goggles.
- Fixed an issue with level resources that caused crashes with certain mods (e.g. ones that include subs with piezo crystals).
- Fixed NPCs waiting on some outpost modules never reaching their targets, causing peculiar behavior.
- Fixed waypoints sometimes not getting connected between outpost modules if there's a very short hallway between them. Addresses some cities missing connections between waypoints, causing AI to be unable to navigate through the modules.
- Fixed some UI layout issues (most noticeably, ultra-wide crew list) on certain resolutions like 3440x1440.
- Fixed campaign saves occasionally failing to load with the error "an item with the same key has already been added". Seemed to only occur when using certain mods.
- Fixed crashing when you e.g. use a pet from some mod in the campaign, disable the mod and reload the save.
- Waypoint adjustments to most submarines, outposts, wrecks, and beacons. Especially on ladders. Should take care of the remaining AI issues on ladders (the old subs in the saves don't get updated, but the fixes apply to new subs that you don't yet own. And ofc all the subs in a new game!)

---------------------------------------------------------------------------------------------------------
v1.0.20.1
---------------------------------------------------------------------------------------------------------

Fixes:
- Fixed hidden structures not colliding anymore.
- Wiring debugger: Fixed tooltip rendering under the outer frame of the connection panel.
- Wiring debugger: Fixed the glow sprite on connections having an inconsistent size in different resolutions.
- Fixed jailbreak_sootman event getting stuck at the 1st SpawnAction, preventing most of the event from working at all.

---------------------------------------------------------------------------------------------------------
v1.0.20.0
---------------------------------------------------------------------------------------------------------

Optimization:
- Major optimizations to situations where there's lots of items in the submarine (especially water-reactant items and minerals).
- Significantly reduced loading times when loading subs with lots of items in cabinets.
- Partially multithreaded lighting: FindRaycastHits (the heaviest individual part of the lighting algorithm) is now handled in a separate thread.

Line of sight rework:
- Improved the LOS effect to get rid of weird, jagged geometry in spots with intersecting walls.
- Improved the wall damage effect to make leaks easier to see.
- Added a command called "debugdrawlos" which visualizes the LOS geometry, making it easier to adjust the walls if you want to tweak the LOS in the sub editor.
- Note that some submarines may require small manual adjustments to get the LOS to work perfectly with the new algorithm (especially if the sub includes “unnecessary” structures that were used to work around issues in the previous algorithm). You can also disable the “cast shadows” setting on a wall to make it see-through.

Changes:
- Added "electrician's goggles", an item that visualizes power and signals on wires. It also makes connections on the connection panel flash when they're sending/receiving something, and allows you to see what exactly is going through (amount of power, signal values) by hovering the cursor over the connection.
- Added "debugwiring" console command which enables the same visualization as the electrician's goggles.
- Oxygenite tanks can be recycled.
- Shutting down the reactor doesn't automatically turn off automatic control.
- Allow monsters to damage flares and glowsticks.
- Jacov Subra needs to be escorted to the next location after he's rescued (it was weird to have him just disappear after the mission).
- Taking items from trash cans is no longer considered stealing.
- Sulphurite shards explode when thrown (causes an acid cloud that inflicts mild burns).
- Adjusted music intensity ranges: now the "intensity tracks" kick in later (i.e. they require a higher-intensity situation) meaning the "actual songs" play a little more often.
- Upgrades that require materials can be purchased with materials from the sub instead of having to carry the materials on you.
- Made clown and husk events and missions more common.
- Added category buttons to the fabricator interface to make it easier to find items.
- Changed fabricator's "skills required" texts to make it clearer insufficient skills don't prevent you from fabricating the items.
- Hospital beds heal injuries faster than normal beds.

Fixes:
- Fixed "hash mismatch" errors when publishing an update to a mod after you've given it a different name in the Steam Workshop in the language your Steam UI is set to.
- Fixed publishing an update to a mod always overriding the English description, instead of the language your Steam UI is set to.
- Fixed nav terminal's sonar control panel disappearing when switching resolution or display mode if the terminal has a mineral scanner.
- Fixed secure steel cabinet in abandoned outposts being openable with a randomly selected bandit's ID card, not the bandit leader's card as intended.
- Workaround to Sootman potentially getting stuck in the jailbreak mission if it can't find a way to the sub (e.g. due to broken waypoints in a custom sub or outpost module): if he can't find a way to the sub in 2 minutes, he'll start following the player instead.
- Fixed some z-fighting issues in various outpost modules.
- Fixed flak cannon shells exploding in loaders if there's a monster near the loader.
- Fixed oxygenite tanks not being set to 0 condition when they explode in a welding tool or flamer.
- Fixed/changed welding a door shut not protecting the door from damage. Modding: Added a new tag "weldable" to define targets that can be welded. 
- Fixed flamer damaging duct blocks, unlike intended.
- Fixed Harpoons only reeling in when facing the target.
- Fixed wires that aren't connected to anything not getting copied (with Ctrl+Z or by dragging and dropping with Ctrl) in the sub editor.
- Fixed Hognose event being possible to get multiple times, potentially allowing you to hire multiple Captain Hognoses.
- Fixed lights ignoring constant set_color signals after the color is changed manually.
- Fixed both biome gate locations sometimes belonging to the same faction (and in general, random locations getting changed into Coalition outposts across the map).
- Fixed server log stopping to update after there's 800 messages in it.
- Fixed missions that take place in a location further away on the map sometimes not unlocking when there was no suitable location available.
- Fixed 3rd part of the Honkmotherian Scriptures not being available anywhere.
- Fixed tutorials reappearing after finishing the campaign.
- Fixed progressive stun's visual effect and speed multiplier abruptly resetting when passing affliction strength 9.
- Fixed certain special symbols (the BlockElements unicode range) not showing up on text displays.
- Fixed characters with husk symbiosis transforming to an AI-controlled husk when the host dies.
- Fixed rewards not being shown in the round summary unless the mission was completed successfully (i.e. you couldn't see what the reward is when you start the mission).
- Fixed advanced gene splicer deconstruction output.
- Fixed weird behavior when selecting a periscope a bot is controlling (UI disappearing as if you were operating the turret).
- Fixed waypoint visibility checkbox not being selected when you generate waypoints in the sub editor, even though generating the waypoints toggles their visibility on. 
- Fixed water moving erratically in rooms with lots of connected hulls (with weird spikes and water level jumping up and down).
- Fixes anaparalyzant not reducing paralysis.
- Fixed some Chinese characters not displaying correctly when the language is set to something else than Chinese.
- Adjusted fire particles to make them clip through walls less.
- Fixed characters not falling through holes appearing in the floor below them until they move.
- Fixed characters twisting to a weird pose if you grab them while they're lying in bed.
- Miscellaneous tutorial fixes: don't allow the player to access the areas of the other jobs in the roles tutorial, fixed getting stuck if you enter the rightmost room (where the role tutorials start) as an assistant, fixed bots sometimes wandering outside the initial room.
- Fixed a rare crash caused by a null reference exception in Rope.Update.
- Fixed characters being allowed to aim with weapons in single player when incapacitated/ragdolled. They couldn't actually move the aim position, but the crosshairs appeared and harpoon ropes could be kept from snapping, even though they're set to snap when not aiming.
- Fixes to some of the UI layout issues on ultrawide resolutions. The UI is still not optimal on ultrawide resolutions, but the most severe issues (such as the non-functional crew list) should be fixed now.
- Fixed negative treatment suitability definitions not working correctly, which has had some effect on the bots’ decisions and the suitable treatment listing on the health interface.
- Fixed the min and max strength thresholds of periodic effects not working. Of the vanilla afflictions, affects paralysis, sufforine poisoning, and morbusine poisoning, causing them to trigger stun effects earlier than intended.
- Fixed hanging end of the wire sometimes being "at the wrong end" of the wire after copying entities or saving/reloading.
- Added an option to disable the "remote content" (update notifications, changelogs) in the main menu by adding RemoteContentUrl="" to the player config file. We're suspecting the freezes some players are experiencing when they open the main menu are related to the content in the main menu being fetched from our server, and testing if disabling it makes the issue go away would give us more clues for diagnosing the issue.

Talents:
- Fixed "Medical Expertise" not increasing bandage effectiveness.
- Fixed "Mudraptor Wrestler" not affecting unarmored or veteran Mudraptors.
- Fixed monsters not properly ignoring characters with the "Non-Threatening" talent.
- Fixed Moloch, Black Moloch, Crawler Broodmother and Giant Spineling not having enough inventory space for extra loot given by "Bloody Business" and "Gene Harvester" talents.
- Fixed "Rifleman" talent damage bonus not applying to Assault Rifles.

Multiplayer fixes:
- Increased the default packet limits. It seems the previous defaults were so low it was possible to get kicked due to "sending too many network messages" in some situations even if you weren't actually trying to spam the server using a modified version of the game.
- Fixed rate limiter kicking in too eagerly when the server is configured to use a higher-than normal tickrate.
- Fixed an exploit that allowed getting new subs for free.
- Fixed submarine store displaying the client's subs instead of the server's.
- Fixed Hangul (Korean symbols) not being included in the default allowed client name characters.
- Fixed headset/radio channel resetting between multiplayer rounds.
- Fixed clients hearing radio static when someone talks in a different channel near them.
- Fixed tainted genetic materials in someone's inventory appearing to become untainted when a new round starts.
- Fixed local voice chat icon switching to radio icon (from yellow to gray) at the end of conversations when you release the push-to-talk key.
- Fixed server description getting cut off after 22 lines.
- Fixed changing the name of a dedicated server using the textbox in the server lobby not changing it in the server list.
- Fixed clients not getting positional info for remotely controlled turrets if the character controlling them is far away (> 250 m), meaning you wouldn't see a turret move if you're watching some e.g. operate a remotely controlled turret on a drone.
- Fixed mission minerals spawning with an incorrect rotation (always facing up) in multiplayer.
- Fixed inability to unlock some achievements (such as "Nuclear blast survivor") in multiplayer.
- Fixed cursor positions sometimes "desyncing" when the cursor is very far from the character (e.g. when operating a far-away drone).
- Fixed characters sometimes getting stuck on the wrong side of a door client-side, and not getting corrected until the client moves in the opposite direction or opens the door. 

Bot and AI fixes:
- Improved how the bots navigate on ladders.
- Fixed bots sometimes not being able to release the ladders when there's two ladders close to each other.
- ClownDistrict_Colony_01: Fix a ladder waypoint not being linked to the ladder, causing bots to get stuck.
- Adjusted the waypoint generation logic on ladders. Fixes bots sometimes not being able to open the hatches, because they couldn't get close enough to the waypoints just below/above them.
- Improvements to medic bot AI: they should now be better at determining which injuries are minor enough to ignore, making them waste less medicine.
- Fixed outpost NPCs who should stay in a specific room (e.g. outpost manager) never returning to the room if they leave it e.g. due to a fire, flood or someone attacking them.
- Fixed bots picking up non-pickable items (items that have CanBePicked disabled in the Pickable component settings).
- Fixed bots saying "Cannot reach [name]!", when they can't reach a wait target.
- Fixed bots removing diving suits when they shouldn't, if they are ordered to wait using the contextual wait order. Should behave the same as when told to wait without using the contextual order.
- Fixed bots having issues with doors that are both broken and welded (which is another bug that shouldn’t happen anymore).
- Fixed NPCs running towards doors if they somehow get on another sub, because they didn't detect the access restrictions correctly.
- Set Remora's and Kastrull's drones, outpost jail rooms and (automatically generated) hulls in docking ports as AvoidStaying zones, which makes the bots to try not to idle there.
- Waypoint fixes to Typhon, R-29, and Camel.
- Fixed bots never leaving the drones (or other connected subs) and returning back to the main submarine in the idle state (i.e. without giving them an order or reacting to an emergency situation etc.)
- Addressed bots and NPCs sometimes twitching between two waypoints after reaching their target position.
- Fixed bots not always being able to open the doors in beacons or wrecks while attempting to return back to the main sub.
- Fixed the start and the end node of the vertical hallways in the outposts being incorrectly linked, causing some pathing issues for the bots.
- Fixed bots operating turrets shooting at handcuffed enemies.
- Fixed defense bots attacking husk containers.
- Fixed monsters never ignoring targets that they fail to damage. They should leave those be after a while (depending on the initial priority).
- Fixed pets becoming hostile to all humans (except the owner) when attacked by a hostile human (a bandit in an abandoned outpost for example).
- Potential fix for (hard to repro) issues where a bot runs towards a door without being able to open it, because they happen to skip the nodes past the door when it closes.
- Fixed NPCs and bots sometimes not being able to open the hatch, because they couldn't get close enough to skip the last node before the node connected to the hatch.
- Fixed incorrect linking of the start and the end waypoints in the vertical hallway modules. Caused the bots to open the hatches too early.

Modding:
- Fixed "hair with hat sprite" (the short hair the characters switch to when wearing a hat) being visible even if the whole head should be hidden by another wearable. Not noticeable in the vanilla game, but can affect some mods.
- Fixed crashing when trying to create a character that doesn't have any health parameters.
- Fixed submarine spawning docked to a random docking port of the outpost even if one of them is marked as a main docking port. Doesn't affect vanilla content, since there's only ever one docking port per outpost.
- Fixed round not ending when you dock with an outpost if the outpost module contains any linked subs (lifts, drones, etc).
- Fixed items with absurd amounts of health (more than 38 digits) causing the item to have infinite health, which would lead to various issues and crashes. Now an item's health can't be set above a million. If you want to have an item whose condition never goes down, use the property "Indestructible" instead.
- Autoinjecting can be enabled on specific subcontainers (as opposed to having to make the item autoinject anything inside it).
- Fixed bots being unable to use diving gear that goes in the InnerClothes slot. Doesn't affect any vanilla content, because all diving gear goes in the OuterClothes slot.
- Items' FireProof and WaterProof properties can be changed using status effects.
- Fixed monsters' SimplePhysicsEnabled staying enabled when a client takes control of it.

---------------------------------------------------------------------------------------------------------
v1.0.13.2
---------------------------------------------------------------------------------------------------------

- Fixed "hash mismatch" errors when trying to enable a mod that's been updated in the most recent patch.
- Fixed "the submarine contains entities with duplicate IDs" error message when loading a submarine that contains multiple shuttles/drones.

---------------------------------------------------------------------------------------------------------
v1.0.13.1
---------------------------------------------------------------------------------------------------------

- Updated localizations.
- Fixes to Japanese and Russian translations.
- Fixed Azimuth not going up in Silent Running mode.

---------------------------------------------------------------------------------------------------------
v1.0.13.0
---------------------------------------------------------------------------------------------------------

Misc changes and improvements:
- NPCs who offer services don't get turned hostile regardless of your reputation. If you've got money, they'll be happy to serve!
- Attacking outpost NPCs can't decrease your reputation by more than 20 points per round. Works as a safeguard against enormous reputation losses e.g. in the case of a trigger-happy griefer or a nuclear mishap.
- Destroying outpost walls can't decrease your reputation by more than 10 points per round.
- Outpost NPCs don't allow players to grab them for longer than 10 seconds to prevent being able to drag them around the outpost.
- Minor visual improvements to biomes: biome-specific outpost levels (instead of all outpost levels looking like Cold Caverns), more level objects in Hydrothermal Wastes and the Great Sea.
- Spawn abyss and combat suits in enemy subs and wrecks instead of normal ones in later biomes.
- Fixed minerals still sometimes spawning on the wrong side of cave walls (when the other side of the wall is outside the boundaries of the level).
- Fixed pressure stabilizer only affecting the player for 100 seconds, instead of the intended 1000 seconds (16 mins).
- Fixed clients not getting assigned the "None" permission preset when using a language other than English (meaning it wasn't possible to customize what permissions clients have by default).
- Fixed enabling cheats not actually disabling Steam achievements for the rest of the campaign (it was possible to re-enable unlocking achievements by saving and reloading).
- Fixed Tormsdale mission not completing unless you bring the item to the sub. Now retrieving the item counts as "bringing it to the sub" in friendly outposts. 
- Optimized/simplified exosuit and FB3000 status effects.
- Made huskified humans' items move to a duffel bag on death.
- Increased the priority of turret lights to prevent them from getting hidden when using a low light limit.
- Reduced the minimum mass required for a character to be visible with thermal goggles, always show at least the main limb regardless of the mass. Fixes thresher hatchlings being invisible to the goggles.
- Alien power cells can be deconstructed.

Bots:
- Fixed bots targeting crawler eggs when they are inside an inventory (also in the Broodmother's inventory).
- Fixed bots being allowed to shoot items from very long distances.
- Fixed bots wasting ammunition on crawler eggs that are not dangerously close to the sub.
- Fixed bots using an unintentionally long delay before shooting.
- Fixed bots targeting (but not shooting) enemies inside abandoned outposts.
- Adjusted the delays and the targeting ranges. Remove the "grace" distance modifier. Improves the bots' general usage of turrets.
- Fixed "fight intruders" order causing bots to attack enemies in abandoned outposts again.
- Bots are allowed to use meds from an unconscious patient's inventory.
- Fixed bots falling off the ledge in DockingModule_02_Colony (again).
- Fixed bots not prioritizing the leaks as they should when multiple bots are fixing leaks simultaneously.
- Fixed bots not preferring the items that lie on the ground.
- Fixed bots often not being able to reach small items like battery cells or rifle rounds that lie on the ground.
- Fixed bots sometimes holding the flashlight in their mouth.
- Fixed bots acting weird when picking up items and having their inventory full.
- Fixed bots not being able to find an alternative container for the items they are cleaning up, when the path to the preferred container is blocked. Didn't affect bots getting a specific item, like a diving suit when they need it.
- Bots are no longer allowed to wear the items (other than in hands) when they are cleaning them up.
- Improved bots' abilities to find items. They should be much quicker at it than previously.
- Possibly fixed bots sometimes ignoring targets that they shouldn't ignore.
- Fixed bots not being able to change the oxygen tanks when they are in a safe room with no enemies.
- Fixed bots using both diving mask and the suit simultaneously.
- Fixed bots holding to old paths that shouldn't be valid anymore (= not complying when you order them to follow outside of the submarine).
- Fixed bots not being able to use pathing when the player has just controlled them, leaving them in a ruin, wreck, or a beacon. Only happened when the bot hadn't been AI controlled before during the round.
- Fixed bots using the waypoints not linked to any sub when they should use the waypoints linked to a sub and vice versa.
- Fixed bots trying to use the gaps when they could just use a path to get to the target.
- Fixed missing links between doors and waypoints in Alien_Entrance3.
- Fixed bots sometimes not being able to release from the ladders when they were trying to exit a wreck or beacon to get back to their own submarine.
- Fixed bots sometimes still idling on ladders, which they shouldn't do (There are some unaddressed cases where it might seem like they'd do this, but actually don't. They just can't reach the buttons linked to the door.)
- Fixed bots sometimes failing to climb up the ladder all the way up and falling down just before reaching next floor. Happened only in the idle state.
- Fixed bots sometimes getting stuck on the long ladder in EngineeringModule_02_Colony.
- Fixed waypoints on ladders leading to a hatch on many subs (using old waypoints), which caused the bots to fail to reach the hatch while trying to fix it.
- Fixed bots not being able to operate properly in high pressure levels when they don't have a suit that protects from the pressure (e.g. a regular diving suit later in the campaign).
- Bots now prioritize suits that give a better pressure protection (there's a separate attribute for it in the item definition: called "botpriority", which can and should be taken into account with the modified items).
- Fixed bots not healing theirselves while swimming outside of the submarine (they only do that when the wounds are relatively severe).
- Fixed bots treating theirselves when there's a medic onboard, which is currently unable to treat them (if the medic is able to treat the bot, they should not try to heal theirselves).
- Fixed bots ignoring targets that are currently fixing leaks (which was intentional, but seems to have been a bad decision).
- Added new dialogue for the bots about the lethal pressure levels and insufficient protection for it.
- Fixed some minor buts regarding the dialogue.
- Fixed bots not being able to use harpoon coil rifles properly.
- Fixed bots accepting random items as weapons when they can't find any weapon. Note that many tools, like welding tools and wrenches, can intentionally be used as weapons.
- Fixed prepare for expedition order and another order, like clean items, possibly resulting in looping behavior where the bot can't decide which one to follow.
- Adjustments to how the bots prioritize combat targets under fight intruders objective.
- Fixed bots not reacting when they are non-intentionally damaged by friendly NPCs (e.g. security smashing a player character).

Multiplayer fixes:
- Changes to make starting a round more robust: fixes various equality check errors ("submarine/mission doesn't match") if starting a multiplayer round takes a long time.
- Fixed dedicated servers' content package info getting truncated to 255 bytes, causing the content package list to just display "unknown" if the server has lots of mods enabled.
- Fixed "input contains duplicate packages" error when trying to join a server that has certain types of mods enabled (more specifically, mods that only contain client-side content, identical content or files of the type "Other", which could result in the MD5 hashes of the mods to be identical).
- Fixed projectile spread not being as random as it should be in multiplayer (successive hitscan rounds usually launched in the same direction).
- Fixed spectators not hearing others if their character is dead before the character despawns.
- Campaign rounds aren't forced to end if there's only one client on the server using freecam.
- Fixed crashing when a traitor missions starts when the host isn't controlling a character.
- Fixed sonar beacon tickbox sometimes flickering on and off in multiplayer.
- Fixed clients not seeing wall damage in outposts if the server has made outpost walls damageable, and the client doesn't have permissions to manage server settings.
- Fixed arc emitter briefly stunning the user client-side.
- Unconscious players can't end the round.

Countermeasures against multiplayer exploits:
- Fixed an exploit that allowed you to equip 2-handed weapons in only one hand.
- Added protection against deliberately lagging the server.
	- Added an option to enable "DoS Protection" in the server settings under "Anti-Griefing".
		- Enabled by default.
		- When enabled, the server will automatically kick players who are causing the server to perform poorly.
	- Added a new "Max Packet Auto-Kick" in the server settings under "Anti-Griefing".
		- Enabled and set to 3000 by default.
		- Can be disabled by setting the limit to 1200 or below.
		- When enabled, the server will automatically kick players who are sending a certain amount of network packets in a minute.
- Added "Spam Immunity" server permission.
	- Gives immunity to getting kicked from DoS protection, chat spam and from sending too many packets.
- Added a rate limit to console commands in multiplayer.
- Added a rate limit to creating new characters in multiplayer.

Balance:
- Buffed Harpoon Coil Rifle a bit (shorter charge time).
- Reduced Focused Flak Shell penetration slightly.

Talents:
- Engine Engineer, Helmsman and Affiliation talents no longer stack (allowed gaining insane engine speed boosts and bonuses by having large numbers of crew with the same talent).
- Fixed makeshift shelves no longer being placeable in pre-1.0 saves.
- Fixed some incorrect talent icons.
- Fixed Networking talent only giving a discount for faction-specific items.
- Fixed Machine Maniac requiring 5 repaired items instead 3 like the description says.
- Gene harvester doesn't spawn genetic materials on pets.
- Dying due to a disconnect doesn't trigger talents (like "Revenge Squad") or get recorded as a kill.

Submarines:
- Reworked Typhon (kudos to uberpendragon): replaced legacy items and structures, got rid of double walls, layout adjustments, visual improvements, improvements to the power grid and many smaller changes.
- Fixed waypoint in Herja's airlock not being linked to the door.
- Fixed fabricators not being linked to the cabinet next to them in Azimuth, Berilia, Kastrull, Orca2, Typhon, Typhon2, Winterhalter.
- Fixed some unhulled spaces inside Kastrull, Azimuth and Berilia.
- Fixed improperly wired smoke detectors in Typhon 2.
- Replaced the wall between gunnery and engineering (that every sane person cuts a hole in) with a door in Kastrull.
- Fixed medic not being given proper ID card tags in R-29, preventing them from accessing the toxin cabinet.
- Fixed Venture's exterior airlock door being repairable with a welding tool instead of a wrench.
- Fixed water detector in Dugong's oxygen generator room not being connected to the flood alarm circuit.
- Added "Silent Running" to Azimuth, as well as 1 diving suit and exterior cameras to make it more worthy of tier 2 (despite a lack of guns)

Fixes:
- Fixed all shadow-casting lights going through the outpost walls when docked to one.
- Oxygen generator sprite and animation fixes.
- Fixed escorted characters being hostile to you if they belong to a hostile faction.
- Safeguard against getting pinned under flooded enemy subs. The sub can now be pushed off as long as the enemies inside it are dead/incapacitated.
- Fixed enemy subs not affecting monster spawns (meaning monsters could spawn very close to enemy subs, and fighting an enemy sub didn't decrease the probability of monster spawns as it should've).
- Fixed submarines sometimes getting stuck when trying to squeeze through a tight passage in the level.
- Fixed pets being considered hostile in hostile outposts (causing AI crew to report them as intruders).
- Fixed monsters sometimes spawning inside walls during nest missions.
- Fixed paths between biomes sometimes being unlocked from the start on certain map seeds.
- Fixed launching an alien turret (or any modded turret that spawns it's own ammo inside itself) causing a crash.
- Fixed crashing when you exit Steam while the Workshop menu is open.
- Fixed some of the fonts not working properly in Japanese (but using roughly similar Chinese symbols instead).
- Fixed campaign's end boss moving away from you if you attack it with melee weapons.
- Fixed enemy crews not being able to switch between turrets and being very reluctant to operate multiple turrets at the same time.
- Fixed reputation reward text sometimes overflowing in the round summary (e.g. when the mission modifies both the husk cult and clown rep).
- Fixed characters holding and eating bananas weirdly.
- Fixed all friendly characters using the "hostage" dialog and all hostile characters the "bandit" dialog in abandoned outposts.
- Fixed characters sometimes becoming briefly immobilized (as if stunned) when the surface of the water rises up to the character's chest.
- Fixed cultist hood overlapping with the exosuit.
- Fixed exosuit and FB3000 not being tagged as "provocative" (meaning enemies didn't care about the sounds they make or the lights on them).
- Adjusted FB3000 fabrication recipe (the previous required so many materials they don't fit in the fabricator's input slots).
- Fixed PUCS not having an AI target unlike all other diving suits.
- Fixed sonar monitor's "sonar circle" overlapping with the control panel on some resolutions / HUD scales.
- Fixed occasional invisible barriers around alien ruins.
- Fixed protein bars only healing 1/60 of the intended amount.
- Fixed "Engineers_are_special" event no longer appearing.
- Fixed characters sometimes being able pass through level walls by swimming down through the broken floor of a wreck.
- Fixed "acquire a wrench" popup appearing multiple times in the mechanic tutorial.
- Fixed black squares on docking ports and hatches.
- Fixed crashing when trying to increment the version number of a mod whose version number consists of only numbers (i.e. no periods) or is empty.
- Fixed hireable cultists and clowns being the wrong way around (i.e. high clown rep allowed you to hire cultists and vice versa).
- Fixed wikiimage_sub and wikiimage_character crashing the game if the file is being used by another process.
- Fixed wikiimage_sub not sorting the entities the same way as the sub editor and game screen.
- Fixed status monitor displaying very small amounts of water in linked hulls as 1%.
- Faction reputation is reset after finishing the campaign.
- Fixed colony docking modules spawning with a bit of water in them.
- Fixed minerals sometimes spawning in normal caves in abyss mining missions. Happened if no abyss islands with caves happened to generate - now we always generate a cave in at least one of the islands.
- Fixed lights on the items the character is wearing being visible when inside a clown crate.
- Fixed mudraptor eggs (or other items set to be damaged by repair tools) not being damaged by flamers.
- Fixed handheld sonars not working in the end levels.
- Fixed rebinding the Use key not working in the sub editor.
- Fixed Ctrl+A not selecting connected wires in the sub editor.
- Fixed ability to climb ladders while lying in bed.
- Fabricator input slot tooltips don't show duplicate item names when the item can be crafted from multiple different items with the same name (e.g. petraptor egg can be crafted from 3 different egg items, all called "mudraptor egg").
- Fixed attacking others with the husk appendage not healing the user.
- Fixed pet name tag getting stuck mid-air when equipped.
- Fixed next round's missions not being displayed in the round summary when leaving a location that has missions (e.g. outpost with a jailbreak mission).
- Fixed inability to hire Jacov Subra if you miss/ignore the event the first time you get it. 
- Outpost generator only takes walls with a collider into account when determining the bounds of the modules. Fixes husk modules being placed unnecessarily far from the outpost due to the decorative structures outside the door, leaving a very short hallway between the modules.
- Fixed characters sometimes dying from barotrauma despite the pressure icon not being visible. Happened when the pressure was just above the lethal threshold, but not as high as outside the sub.
- Fixed character interact texts (like "[H] Heal") not changing when you change the language.
- Fixed treatment suggestion for husk infection being shown when wearing zealot robes.
- Fixed inability to fabricate high-quality nuclear depth charges.
- Fixed exosuits getting autofilled with batteries.
- Fixed exosuits' lights not turning off when the wearer dies.
- Fixed 0% grenades (stun grenade and fixfoam) detonating if a player has one in their inventory when a mission starts.
- Fixed pre-unlocked talents not being visible client-side on the special faction NPCs hired during the round.
- Fixed escort and cargo missions sometimes leading to an abandoned outpost even if there's an inhabited one available.
- Fixed characters (ragdolls) sometimes getting stuck to the corners near platforms.

Modding:
- Fixed thalamus items fading from the prefab color to a darker tint, disregarding the actual sprite color of the item.
- Fixed LevelTrigger statuseffects not doing anything when triggered by a submarine. 
- Added a scrollbar to the campaign setup's crew tab to make it work properly when there's more than 3 initial crew members.
- Support for using OnWearing in Containable StatusEffects.
- Fixed ability to "relaunch" a projectile that has already been launched or that's stuck to some target using status effects, which lead to various strange results.
- Fixed ItemContainer StatusEffects working in a different way than other effects, applying the effect separately to each target. Prevents e.g. having an effect that does something to an item if a condition is met on the character wearing it.

---------------------------------------------------------------------------------------------------------
v1.0.9.0
---------------------------------------------------------------------------------------------------------

- Fixed crashing when you move from one textbox to another using tab and go past the last available textbox.
- Fixed inability to enter the final levels on some subs that include shuttles/drones. 
- Fixed autoinjectors (PUCS, autoinjector headset) wasting the syringe without any effects on the character.
- Fixed bots failing to operate turrets in Typhon 1 due to them being partially inside the ceiling.
- Fixed lights going through walls in outposts.
- Fixed language selection prompt not showing up when launching the game for the first time.
- Fixed bots doing objectives during the roles tutorial, e.g. repairing the leaks for you.

---------------------------------------------------------------------------------------------------------
v1.0.8.0
---------------------------------------------------------------------------------------------------------

- Fixed loading screens sometimes getting stuck when playing in Chinese, Japanese or Korean.
- Fixed certain mods that override outpost generation parameters causing crashes due to missing outpost NPC prefabs.
- Fixed outpost NPCs never attacking you (just aiming their guns at you) if you attack them, but your reputation is not low enough to turn the outpost hostile. 
- Fixed broken dialog line in the waytoascension1 event.
- Fixed healing your crewmates causing your karma to decrease.

---------------------------------------------------------------------------------------------------------
v1.0.7.0 
---------------------------------------------------------------------------------------------------------

- Fixed mechanic tutorial getting stuck at the point where you need to weld a leak.
- Fixed treatment suggestions not showing up in the naloxone part of the medic tutorial.
- Fixed patient spawning dead in the CPR part of the medic tutorial.
- Fixed bots being unable to move through Herja's airlock due to an unlinked waypoint.
- Fixed tutorial Dugong spawning with empty ammo boxes.

---------------------------------------------------------------------------------------------------------
v1.0.6.0
---------------------------------------------------------------------------------------------------------

- Fixed some new Steam achievements not unlocking.

---------------------------------------------------------------------------------------------------------
v1.0.5.0
---------------------------------------------------------------------------------------------------------

- Fixes to Japanese translations.
- Implemented support for some upcoming Steam achievements.
- Improved backwards compatibility: fixed outpost managers no longer spawning in mods that override outpost generation parameters due to the generic non-faction-specific outpost manager prefab being removed.

---------------------------------------------------------------------------------------------------------
v1.0.4.0
---------------------------------------------------------------------------------------------------------

- Fixed outpost NPCs getting randomized every time you re-enter an outpost.
- Fixed inability to gain more than 15 talent points in the multiplayer campaign.

---------------------------------------------------------------------------------------------------------
v1.0.3.0
---------------------------------------------------------------------------------------------------------

- Adjusted plant spawn rates in caves.
- Made lead more common in stores.
- Fixed mission listing shown on the top of the screen spoiling enemy faction ambushes. 
- Fixed enemy faction ambushes being possible everywhere on the map (they should only happen within 3 steps of outposts belonging to an enemy faction).
- Fixes bots sometimes running towards doors that are closed by something else (another person or an automatic logic).
- Fixes bots ordered to wait outside of the submarine not being able to switch their oxygen tanks.
- Added a couple of endgame-foreshadowing lore bits.

---------------------------------------------------------------------------------------------------------
v1.0.2.0
---------------------------------------------------------------------------------------------------------

- Exosuits are powered by fuel rods instead of batteries.
- Fixed affliction probabilities being evaluated twice, meaning that e.g. 50% probability of getting some affliction from an attack was actually a 25% probability. 
- Fixed item highlights from the previous round remaining visible the next round.
- Fixed swapping items in a container sometimes causing too many items to be visible in it.
- Fix the vitality modifiers on husk not working properly, because health indices on the limbs were not defined. Effectively husks always took 2x damage.
- Fixed characters still spawning inside outposts that have turned hostile due to low reputation.
- Fixed all special faction hire events getting stuck if you say you need to "think about it", return, and say you still need to think about it.
- Fixed missing "place in ceiling" text in beacon station save dialog.
- Fixed basic depth charges being cheaper than intended (only 30 mk).
- Fixed inability to make lights blink at a high frequency by rapidly turning them on and off with e.g. oscillators.
- Fixed ranged weapons emitting particles in the wrong direction. There haven't been any changes to this code in years, so it must've been an issue for a long time, I guess we just never noticed because no gun before the scrap cannon emitted particles with a noticeable velocity?
- Fixed a pathfinding issue that often made bots swim against cave walls.
- Fixed inability to join servers with a submarine switch/purchase vote running.
- Fixed votes passing if the client who initiated them disconnects before anyone else votes.
- Fixed follow orders not being persistent between singleplayer rounds.

---------------------------------------------------------------------------------------------------------
v1.0.1.0
---------------------------------------------------------------------------------------------------------

- Fixed Mailman talent giving you the 150 mk bonus every time you open the campaign map or mission menu and there's a cargo mission visible.
- Fixed missions available from the destination location to some other location being listed as "outpost missions" in the campaign map's mission selection.
- Fixed outposts that faction missions take place in being allowed to turn into abandoned outposts when next to hunting grounds, making the missions impossible to complete.
- Fixed hidden items (e.g. Separatist deco that's disabled in Coalition outposts) sometimes getting chosen as targets for scripted events, resulting in non-interactable, glowing "ghost items".
- Fixed mysterious floating status monitor in AdminModule_02_Colony.
- Miscellaneous optimizations.
- Fixed Separatist jailbreak mission causing a crash.
- Fixed ranged weapons (most noticeably, scrap cannon) emitting particles in the wrong direction.
- Fixed acid burns not having a cause of death text.
- Fixed "skedaddle" not giving a 10% movement boost like the description says.
- Fixed odd fabrication list sorting: the items that require a recipe to fabricate were split into ones you have the skills to fabricate and ones you don't, even though that isn't visible in the UI, making the list just seem out of order.
- Fixed red glow around the light switch's green button.
- Fixed banana being held weirdly.
- Fixed inability to hold a captain's pipe or cigar in your left hand.
- Fixed ready checks not working.

---------------------------------------------------------------------------------------------------------
v1.0.0.0 (Full Release)
---------------------------------------------------------------------------------------------------------

Faction overhaul:
- Outposts are controlled by the Europa Coalition or Jovian Separatists, and some of them include a module belonging to the Church of Husk or Children of the Honkmother.
- Got rid of location-specific reputation. Now all the events/missions give faction reputation instead (excluding missions that aren't related to or given by a faction, e.g. abandoned outpost missions).
- Lots of new outpost events, and a longer "event chain" for the secondary factions.
- Lots of new faction-specific missions: some variants of existing missions, some new.
- Faction-specific hires: "generic" high-level characters with more experience points and better gear than normal hireable NPCs. Available for hiring when Coalition or Separatist reputation is high enough.
- Special, named characters who can be hired via scripted events after reaching a high enough reputation.
- Faction-specific vendors (separatists, husks, clowns) who sell special items (many of which are completely new) if your reputation is high enough.
- If your Coalition/Separatist reputation is low enough, you may get attacked by their vessel during missions.
- There's now always two paths from biome to another, one controlled by the Coalition and one by the Separatists.
- Improvements to the campaign map.
- Added a 3rd talent tree, "Politician", for the Captain. Focused around faction relations and reputation.

Endgame:
- Completely remade the ending of the campaign. Now you'll get to see what's beyond the Eye of Europa and perhaps uncover the cause for the increasing levels of radiation.
- New types of enemies/bosses.
- Some new events to foreshadow the ending during the course of the campaign.

Misc changes:
- New loading screen / location portraits.
- Two new music tracks.
- Items' skill requirements are shown in their tooltips (the same way as damage resistances).
- Tweaks to poisons.
- Adjusted Europan Handshake to work better with the overhauled morbusine poisoning.
- Acid Grenades and 40mm Acid Grenades are now properly affected by talents
- Acid Grenades and 40mm Acid Grenades deal more damage and slow enemies down, making them more viable against fast monsters.
- Made regular 40mm grenades penetrate armor more efficiently.
- Made Diving Suits resist Acid Burns a bit more.
- Europa Brew's Acid Vulnerability is now double as effective (200% damage taken instead of 100%).
- Adjustment to throwable items (shorter throw distance and reduced speed in water).
- Made flares float in place to make them more useful.
- Made high-quality stun guns more effective (stunning the target faster).
- The health scanner always shows poisons and paralysis on monsters to make it easier to determine whether the poisoning is progressing or wearing off.
- A pass on sound ranges: the ranges should now be more consistent and sensible.
- Made moloch shell fragment and riot shield medium items instead of small to fix them going inside e.g. toolbelts.
- Made husk eggs consumable.
- Made it more difficult to repeatedly enter an abandoned outpost and re-loot the bandits: now the bandits immediately attack you if you re-enter the outpost.
- Monsters you haven't encountered yet are now hidden by default in the character editor. Can be enabled using the command "showmonsters" and re-hidden using "hidemonsters". The value is saved in creaturemetrics.xml. Doesn't affect custom creatures.
- Fixed character crush depths behaving inconsistently (varying between levels, e.g. sometimes crushing the character at the depth of 2000 meters, sometimes 3000).
- Improvements to submarine crush depth effects: previously the breaches were easy to deal with because pressure did small amounts of damage to all walls, now it instead does heavier damage to some walls (and the amount of damage and walls to damage increases with depth).
- Added a round light component variant.
- Increased the hard-coded max mission count back from 3 to 10. It'd be preferable to not change the value above 3 in the vanilla game, but since campaign settings are not moddable, we shouldn't be too strict about it (because it can be useful for a mod that this value can be adjusted).
- Miscellaneous optimizations.
- New slot indicator icons (= the icons that show what can go inside some items, like tanks/ammo).
- Made outpost hull repair service cheaper.
- Doors can now be damaged by melee weapons and ranged (handheld) weapons. (They were already destructible by submarine mounted weapons and explosives)
- Adjusted and rebalanced item damage for most items, to take into account doors being destructible.
- Reduced time needed for a crowbar to open doors, 7.5s for regular doors, 6s for wrecked doors (down from 10 s).
- Boosted Plasma Cutter damage against doors and items (walls not touched).
- Made galena more common in order to make lead easier to get.
- Added Auto Operate option for all turrets. Can be enabled in the submarine editor. Not currently used on vanilla submarines. Auto operated turrets don't require a person to operate them, but they still require power and ammunition (-> someone needs to reload them).

Multiplayer:
- Added a language filter to the server browser.
- Fixed reports given by dragging and dropping them on the status monitor always targeting the room the character is inside.
- Improvements to medical clinic syncing (should fix some of the afflictions a character has sometimes not being visible on the list).
- Fixed crashing if you close a server when mod downloads are disabled.
- Improved projectile syncing: spread now behaves the same client-side as it does server-side (as opposed to being completely random).
- Improvements/fixes to dialogs that are shown to multiple clients: disable the option buttons when another client chooses an option, and highlight the option that was chosen.
- Fixed server randomizing the game mode at the end of the round when playing a campaign with the game mode selection set to Random.

AI:
- Fixed bots considering certain multi-hull rooms flooded when they are not.
- Fixed bots deciding prematurely that they can't fix an item when it's deteriorating (e.g. when it's submerged).
- Fixed bots removing battery cells from exosuits when ordered to charge batteries.
- Fixed bots sometimes getting stuck in automatic doors and/or double doors, because they didn't wait for the door to open entirely before pressing the button again.
- Improved bot ‘extinguish fires’ behavior. Fixes bots sometimes not being able to extinguish larger fires, because they stopped too far and didn't keep advancing towards the target.
- Fixed bots claiming that they can't return back to the sub and then following the order anyway.
- Improved the ‘find safety’ calculations so that the bots give more preference to the distance of the room.
- Fixed some remaining issues and edge cases in the logic over when the bot needs diving gear and when it can be taken off.
- Fixed captains (and some NPCs) idling in the airlock if they equip a diving suit.
- Bot can now target items (like projectiles) with turrets and have different targeting priorities on different monsters.
- Fixed bots being allowed to reach items that are too far to be interacted with.

Fixes:
- Fixes and improvements to translations (Japanese and Chinese in particular).
- Fixed light components with a range of 0 and a hidden sprite being invisible against dark backgrounds.
- Various fixes to Typhon 1: most notably, adjusting the hulls to prevent some rooms from being impossible to drain fully.
- Fixed "kill" command not killing characters under the influence of "Miracle Worker".
- Fixed some lights becoming invisible when their range is set to 0 and they're against a dark background.
- Fixed lights turning on without power when they receive a toggle or set_color input.
- Fixed changing the amount of items to fabricate inadvertently starting(or activating) fabrication in MP if you've previously started fabricating something
- Fixed campaign settings resetting in the campaign setup menu every time you relaunch the game (meaning you'd always need to e.g. remember to toggle the tutorial off if you want to play without it).
- Fixed inverted mouse buttons not working properly since the last update: the left mouse button was considered the primary mouse button regardless of your OS settings.
- Fixed status monitor not properly displaying condition on tinkered items.
- Fixed machines smoking when above 100% condition with tinkering.
- Fixed inventory overlapping with the chatbox on low aspect ratios (small width, large height).
- Fixed some layering issues in abandoned outposts.
- Fixed water-sensitive items sometimes spawning as loot in wrecks.
- Fixed radio static still playing even if you don't have a headset.
- Fixed rifle grenade sounds not working.
- Fixed crashing on startup if the MD5 hash cache file is empty.
- Fixed research stations and loaders not being visible on the status monitor's electrical view. 
- Fixed artifact missions sometimes choosing the same artifact as a target if you happen to have multiple missions active at a time, which would lead to console errors when the round ends.
- Fixed exosuit playing the warning beep if there's empty or almost empty tanks in any of its slots.
- Fixed oxygen generators deteriorating in some of the outpost modules.
- Fixed reputation loss when a character other than the player (e.g. crawlers in the 'crawleroutbreak' event) damages the outpost walls.
- Fixed outpost modules sometimes being placed in a way that makes them overlap with the sub.
- Fixed characters trying to walk in flooded spaces that are too low to stand in (like some of the tight passages in alien ruins).
- Genetic material backwards compatibility to fix old unidentified genetic materials disappearing from saves prior to v0.21.6.0.
- Fixed genetic materials being too rare in outposts now.
- Fixed hunting grounds affecting outposts 2 steps away, not just ones in adjacent locations.
- Fixed "residual waste" talent duplicating genetic materials.
- Fixed monsters sometimes spawning inside destructible ice chunks in caves.
- Fixed respawn shuttle sometimes spawning inside floating ice chunks.
- Fixed equipping a ranged weapon setting its reload timer to 1, making it possible to reduce some weapons' loading times by unequipping and equipping them. 
- Fixed partially consumed items not staying on top of the stack they're in.
- Fixed submarine tier and class affecting the prices of the submarine upgrades: e.g. a tier 2 upgrade would cost more on a submarine where tier 2 is the maximum than on a submarine with a higher maximum.
- Fixed reputation loss when you steal items from bandits in a beacon station.
- Fixed equipped flares igniting when you click on the inventory.
- Fixed "Quickdraw" talent not affecting Alien Pistols.
- Fixed toolbelts and other items worn on the torso getting hidden when wearing a safety harness.
- Fixed advanced syringe gun and slipsuit fabrication recipes.
- Fixed floating pumps and ladder layering issues in Herja.
- Limited the number of makeshift shelves per sub to 3 (similar to portable pumps). Otherwise you can use them to expand the sub's cargo capacity indefinitely.
- Fixed dementonite and hardened crowbars spawning in respawn containers (= respawn shuttle cabinets).
- Fixed alien blood no longer causing psychosis, + made it slightly less effective to make fabricating blood packs more worthwhile
- Fixed fire extinguisher spray getting blocked by characters.
- Venture: Fixed the battery room not flooding properly (again), fixed the two hulls in the airlock not being linked, adjusted the waypoints a bit.
- Selkie: Disconnect the outer nodes from the ladder/door nodes, because the docking ports can't be opened manually.
- Fixed Thalamus AI not running properly when there's no player characters or submarines around (e.g. when all the players are in the freecam mode).
- Fixed the ammo indicator not showing correctly on the advanced syringe gun.
- Fixed bots sometimes getting confused by outside waypoints while being inside an outpost.
- Fixed item relocation logic running also on NPCs that are not in the player team, which could cause diving suits dropped by NPCs to get spawned in the player sub.

Modding:
- Fixed crashing if a StatusEffect is configured to SpawnItemRandomly but doesn't configure anything to spawn.
- Improved the error handling of item/character variants. Previously if the parent prefab wasn't found, there was no error message, but the variant was still created, causing crashes in various situations.
- Added AITurretPriority and AISlowTurretPriority on items and characters. Setting the priority to 0 can be used for telling the bots to ignore the target entirely. Items also need to have IsAITurretTarget="True" enabled to make them a valid target.
- Added ItemDamageMultiplier on items. Can be used for increasing the damage caused by other items, like weapons. Works like the existing ExplosionDamageMultiplier.

---------------------------------------------------------------------------------------------------------
v0.21.6.0
---------------------------------------------------------------------------------------------------------

- Minor localization fixes.
- Fixed some occasional crashes in the character editor.

---------------------------------------------------------------------------------------------------------
v0.21.5.0
---------------------------------------------------------------------------------------------------------

- Fixed delete save button not working in the singleplayer "load game" menu.
- Fixed depleted fuel revolver round recipe requiring too many materials.
- Reduced medical item cooldown to 0.5 seconds.
- Minor fixes to Chinese localization.
- Fix bugged sufforing poisoning when it reaches the full strength.
- Fixed crashing when you save a sub that contains item variants with decorative sprites (most wrecks) as a new content package.

---------------------------------------------------------------------------------------------------------
v0.21.4.0
---------------------------------------------------------------------------------------------------------

Unstable only:
- Fixed crashing when an item spawns after upgrades with material requirements have been purchased in the multiplayer campaign.
- Fixed crashing if the submarine preview is closed before generating the preview finishes.

Changes:
- Some submarine upgrades cost materials in addition to money.
- Crush depths are displayed on the submarine switch terminal.
- Miscellaneous fixes to all translations.
- The "max missions" campaign setting is restricted to a maximum of 3.
- Minor improvements to ragdoll animation when falling prone due to stun/unconsciousness/ragdolling.
- Revisited the skill requirements and the OnFailure conditions on welding tool, plasma cutter, flamer, and steam gun. Flamer and steam gun now apply burns on the user only when they don't have enough skills to use the item. All these items are now less efficient when used with low skills.
- Changed Alarm Buzzer sound to differentiate it from the diving suit warning beep.
- Depth charge tweaks: require UEX, increase non-contained item explosion radius and damage, allow quality to affect explosion, increase pricing.
- Reduced Flak Cannon effectiveness (in particular Spreader Ammo and Explosive Ammo), against large enemies in particular.
- Lights flicker when hit by EMP.
- Large monsters no longer drop the loot when they die. This was implemented as a workaround to it being difficult to grab large monsters, but now they're much easier to grab - you can grab them anywhere near their main limb, instead of having to find the "origin" somewhere at the center of the monster.
- Bots now prefer PUCS over the other diving suits and the other diving suits over exosuit.
- Made drinks and other consumables work more consistently.
- Adjusted the aim poses used while holding certain melee weapons.
- Harpoons: Adjusted the damage on walls and the projectile launch forces. Spears can now stick to the walls. Inversed the reeling logic: ragdoll key = reel in.

Poison overhaul:
- Reworked most poison afflictions with the goal that a medic can now use them offensively on monsters and humans alike.
- Sufforin, Morbusine, Cyanide, Paralyzant now work on most monsters. Bigger monsters are generally more resistant than the smaller.
- Sufforin poisoning: Slowly makes the target fall sick. Eventually leads to death. Stronger monsters may recover.
- Morbusine poisoning: Kills the target relatively quickly from gradual oxygen deprivation/organ damage. Stronger monsters may recover.
- Cyanide poisoning: Doesn't do much at first, but progresses rapidly and kills the target suddenly. Lethal even to the strongest monsters.
- Paralysis: Advances more quickly than previously. Effective even on larger monsters. (Leucocytes don't always apply enough paralysis for it to progress. They also use a version of the affliction that progresses using the old, slower speed.)
- Poisons (and paralysis) now wear off when the affliction level is low.
- Made medic AI react sooner to treat poisons.
- Attempts to poison the target can now fail when the user has a low medical skill.
- Added a short cooldown to applying medical items. Prevents being able to spam medicine (or poisons) at a nearly unlimited rate.
- Adjusted the syringe and stun gun dart trajectories.
- Reworked the weapons and the medical skill gains: instead of always increasing the weapons skill when a target takes damage, afflictions like poisons now increase the medical skill. Also applying the buffs now increases the medical skill. The skill increases are defined per affliction.
- Fixed the skill gains on low levels (0-15) being ridiculously high.

Talents:
- Fixed "Down With the Ship" sometimes having an incorrect description.
- Fixed "Bounty Hunter" and "Logistics Expert" not giving 15% experience bonus.
- Pet raptor eggs can be fabricated from raptor eggs of any size.
- Fixed Flamer being craftable by anyone, even though it should only be possible with the "Pyromaniac" talent.
- Fixed ability to move in an unpowered exosuit when you've got any speed buff.
- Fixed "True Potential" and "Chonky Honks" not requiring clown power to work.
- Reduced the chance of finding genetic materials with the "Gene Harvester" talent, fixed genetic materials sometimes being found on defense bots.
- Fixed "Spec Ops" not working properly with shotguns and other weapons that fire multiple projectiles per shot. Only the first projectile that hit did double damage.
- Fixed some parts of Hemulen and Venture not flooding properly.
- "Mass production" talent only applies to items in the "material" category. Fixes e.g. recycle recipes sometimes allowing you to keep the original item. 
- Fixed "Lone Wolf" not giving any damage/stun resistance.
- Fixed "Scrap Savant" having a 80% chance of finding scrap instead of 20%.
- Fixed "Steady Tune" not doing what the description says (giving a constantly diminishing 7.5% resistance instead of 60%), made the talent give 100% immunity instead.
- Fixed "Multifunctional" talent not giving a boost to crowbar damage.
- Fixed inaccurate "Unstoppable Curiosity" and "Ph.D in Nuclear Physics" descriptions.
- Fixed skill boost from "Journeyman" not matching the value in the description.
- Fixed "Quickdraw" damage bonus.
- Fixed inaccurate "Journeyman" description.
- Fixed "Oiled Machinery" not increasing fabrication speed.
- Fixed tinkered doors requiring a higher condition percentage to become repaired.
- Fixed "Drunken Sailor" not protecting entirely from the negative effects of drunkness.

Multiplayer:
- Better support for playing the MP campaign without a host or someone with campaign management permissions on the server: 
	- You can vote to end the round in the campaign as well.
	- Automatic restart works in the campaign mode as well.
	- Anyone can manage salaries if there's no-one allowed to do it.
	- If there's no host or anyone with permissions in the server, anyone is able to setup a new campaign.
	- Campaign can be voted for when game mode voting is enabled.
- Made ragdoll syncing more robust: reduces cases of teleportation/desync when manually ragdolling the character in multiplayer. 
- Fixed rejoining clients not regaining control of their character even if the character is still alive, if the client's IP address has changed. A respawn would also not trigger. 
- Fixed "failed to write a network message, too much data is being stored in SegmentTable" errors that could occur in various situations: for example when the host has a large ban list, lots of submarines, and when rewiring a device with lots of connections.
- Fixed "Create new character" button not appearing in the tab menu when dead or spectating.
- Fixed clients not entering the server lobby if they accept a server invite during a single player round or tutorial.
- Fixed inability to join IPv4 servers when IPv6 is disabled.
- Fixed hidden submarine list sometimes desyncing if you have specific custom submarines.
- Fixed characters spawning with their inventory, skills, etc intact if they die during a round and the round ends when the client is no longer in the server. Or, to put it another way, spawning as if they hadn't died at all.
- Fixed an issue that prevented some dedicated servers from appearing in the server list.
- Fixed chat-linked wifi components not receiving order and report messages.
- Save the server settings after starting up the server to create the default settings file if it doesn't exist, instead of only when the server is shut down or the settings changed.
- Fixed list of hidden submarines sometimes desyncing.
- Fixed inability to start Linux dedicated server using LinuxGSM due to an incorrect EOL character in DedicatedServer.exe.

Bugfixes:
- Fixed high-quality items spawning earlier in the campaign when playing with a higher campaign difficulty setting. 
- Fixed multiple issues in the tutorials: missing text, events not progressing when not following tutorial's steps, infographics usability issues.
- Fixed attacking with a melee weapon making you unable to turn (flip) for a while.
- Fixed ragdolling affecting the character's velocity, allowing it to be used as a way to avoid fall damage.
- Hull fixes to vanilla subs and wrecks.
- Fixed alien flares practically never spawning in ruins.
- Fixed status effects defined inside an attack definition still using the old OnUse/OnFailure logic instead of OnSuccess/OnFailure.
- Fixed "save as item assembly" and "snap to grid" buttons taking cursor focus in the sub editor even when they're not visible.
- Fixed inability to launch custom dedicated server executables from the main menu on mac and linux.
- Fixed inability to drag and drop items from the entity list to small containers (such as battery charging docks) in the sub editor.
- Fixed item condition not decreasing client-side if the condition decreases very slowly: for example when using a thorium rod with the "Cruisin'" talent.
- Fixed flares still emitting light after running out.
- Fixed Electrical Discharge Coil preview not working in the sub editor.
- Fixed alien flares not activating when clicking LMB.
- Fixed crawler's arms getting broken when the character flips (turns) in water.
- Fixed the recycle recipe of flak explosive ammo.
- Fixed misaligned shells in wrecked railgun shell rack.
- Fixed misaligned light component light sprite.
- Fixed crashing if the select audio device is disconnected while in the initial loading screen.
- Fixed inability to sell genetic materials that aren't 100% refined.
- Fixed liquid oxygenite exploding too easily.
- Fixed Hemulen's bottom airlock never fully draining.
- Fixed incorrect damage values in "Genetic Material (Hunter)" tooltip.
- Fixed exosuit not playing the warning beep when low or out of oxygen.
- Fixed "taste test" event showing for everyone and not progressing past the 1st prompt.
- Fixed "special training required" and "too many of this item" messages being shown to everyone when someone tries to place a portable pump.
- Added a pump to RemoraDrone's engine room, otherwise it's impossible to drain.
- Fixed some lighting sprites appearing dimmer than they should (most notably, junction boxes and supercapacitors).
- Fixed submarine's crush depth being displayed incorrectly on the campaign map when a submarine switch is pending: the hull upgrades of the current sub weren't taken into account, even though they carry over to the new sub.
- Fixed item assembly descriptions not showing up in the sub editor unless they're configured in a text file.
- Fixed rapid fissile accelerator ammo causing an explosion when launched, instead of when it hits something.
- Fixed bots sometimes trying to contain multiple ammo boxes when reloading turrets (also affected other items).
- Fixed "Manually Outfitted" not doing anything when starting a campaign.
- Fixed guardians trying to heal themselves in inactive pods (not destroyed pods, but ones deactivated via wiring).
- Fixed bots having trouble with fixing Barsuk's top hatch and leaks around it.
- Fixed sprite bleed in turret icons.
- Fixed radio channel presets resetting between rounds.
- Fixed some lines in the "shockjock" event being shown to everyone.
- Fixed radio noise playing even if you don't have a headset.
- Fixed hitscan projectiles going through subs when you're firing from inside another sub.
- Fixed lights set to flicker/pulse eventually getting out of sync even if they're set to the same frequency.
- Fixes to submarine preview: wires are now visible, scaled doors work correctly, camera is now correctly centered on the sub when opening the preview.
- Fixed the affliction type of some afflictions (like drunk) being "poison", causing them to be treated as poisons. They are now "debuffs" instead.
- Fixed defense bots not attacking pirates or bandits. Also fixed them not protecting the owner when attacked by the outpost guards.
- Fixed bots not knowing how to handle diving suits that don't have an oxygen tank inside them. Now they should be able to use them and refill them with an oxygen tank.

Modding:
- Added a button for updating core mods into the Mods menu.
- Addressed various inconsistencies, issues and limitations in how status effects are used in certain cases:
	- Status effects defined for attacks with the type "UseTarget" now correctly target the use target, instead of the attacker like they used to.
	- Changed the status effects of type "Character" to "UseTarget" for MeleeWeapon and Projectile components. The motivation behind this change is that previously we couldn't target the attacker at all within these item components, which might be desirable for some melee weapons.
	- MODDERS, PLEASE NOTE: Effects that target "Character" in the previously mentioned components now affect the user - if that's not the intention, the target should be changed to "UseTarget".
	- The use target can now be a character, an item, or a structure, depending on the context. This allows effects that weren't previously possible, but due to it we'll now need to introduce some restrictions in the definitions in some cases. For example, we might want to use a conditional to check whether the target is of the right type, before triggering the status effect (<Conditional entitytype="eq Character"/>).
	- Added a new attribute for the MeleeWeapon component, "HitOnlyCharacters", which can be used for ignoring the hits to walls and items entirely.
	- Due to the changes, some status effects that previously worked, might now need the "AllowWhenBroken" set to true in the definition to keep them working as they used to. So e.g. the "OnImpact" doesn't work anymore on your custom explosive, try that.
- Fixed crashing when trying to place a wreck with no hulls in a level.
- Fixed mod descriptions getting truncated to 255 characters when selecting an already-published item in the Mods menu.
- Fixed HMG's requiring hmgmagazine instead of any item with the type "hmgammo", making the use of modded ammo impossible without overriding the gun too.
- Fixed crashing when an upgrade tries to increase an integer value.
- Changed the affliction type of some afflictions, which might have implications on mods if they targeted them by type.
- Added AimAngle on Holdable item components. Can be used for defining a different hold angle for the aim and the rest poses. Note that on Holdables, the angles are mutually exclusive (defined separately), but on MeleeWeapons they are cumulative (added together). Therefore, no need to change the existing items!
- Fixed <Use/> definitions not triggering the status effects that have the target type "UseTarget".

---------------------------------------------------------------------------------------------------------
v0.20.16.1
---------------------------------------------------------------------------------------------------------

- Fixed console errors when firing a Flak Cannon using spreader ammo in multiplayer.

---------------------------------------------------------------------------------------------------------
v0.20.16.0
---------------------------------------------------------------------------------------------------------

- Fixed non-hitscan projectiles going through doors.
- Fixed electrical discharge coils hitting characters very unreliably, unless the character happens to be right next to a wall.
- Fixed makeshift shelves being containable in crates and cabinets, allowing for infinite recursive storage space.
- Fixed the effects of the "Grid Maintainer" and "Egghead" talents.
- Fixed incorrect "I Am That Guy" description (it gives a flat 20 skill bonus, not 20%).
- Fixed "Cruisin'" talent increasing fuel consumption by 10% instead of decreasing it by 20%. 
- Optimized Steam Workshop queries done by the game (less bandwidth usage and stress on Steam's servers).

---------------------------------------------------------------------------------------------------------
v0.20.15.0
---------------------------------------------------------------------------------------------------------

- Fixed Revenge Squad talent doing nothing.
- Fixed Quickdraw talent's 8 second cooldown not working.
- Fixed flamer being fabricable without the appropriate talent.
- Fixed incorrect Aggressive Engineering talent description.

---------------------------------------------------------------------------------------------------------
v0.20.14.0
---------------------------------------------------------------------------------------------------------

- Fixed missing Rifle fabrication recipe.
- Fixed command devices (nav terminals, status monitors) not being in the electrical category, preventing "Better Than New" talent from having an effect on them. 
- Fixed Graduation Ceremony still unlocking double the talents in multiplayer.
- Spawn husk eggs instead of husk syringes as creature loot.
- Cultist events require husk eggs instead of syringes.
- Adjusted shotgun fabrication recipe.

---------------------------------------------------------------------------------------------------------
v0.20.13.0
---------------------------------------------------------------------------------------------------------

- Fixed incorrect admin module sometimes being used in colonies, making it impossible to get to.
- Fixed a performance issue (character vitality logic being unnecessarily heavy) caused by some of the recent talent changes.
- Fixed inability to fabricate Rifle Bullets.
- Fixed contained items that have been configured to be hidden not being positioned correctly (meaning any positional effects done by the contained item would not work correctly).

---------------------------------------------------------------------------------------------------------
v0.20.12.0
---------------------------------------------------------------------------------------------------------

Talent overhaul:
- Redesigned and rebalanced talents: lots of new talents, changes and balancing to existing ones and replacing some of the more broken ones with new ones.
- Redesigned talent tree structure: there's now a selection of "generic" talents, and after you've unlocked 4 of them, you can choose a specialization talent tree. After completing a specialization tree, you can choose another one.
- Lots of new talent-related items and 2 new pets.
- Players can select talents for bots in multiplayer.
- Anyone can fabricate the items bots have unlocked using talents.

Balance:
- Slightly adjusted values of handheld weapons.
	- Damage values of weapons have been adjusted to be more in line with their cost
	- Damage to structures has been revised (f.e. knives shouldn't be so efficient at cutting through walls).
	- Improved ammo availability for basic weapons.
	- Usage of a minimum difficulty level to have some weapons appear in stores only later in the game. Even some previously talent-only items can appear in stores now in very late biomes.
- Made some weapons available later in the game to increase the feeling of progression.
- Slightly adjusted values of apparel (armor, clothing, diving suits) to better highlight strengths and weaknesses.
	- Combat Diving Suit is now actually better for combat than the regular diving suit, due to higher damage resistances.
	- PUCS no longer gives a bonus to speed when using Underwater Scooter, as it has plenty of other strengths.
	- Mechanic's apparel now has higher laceration protection than Engineer's apparel, as that's typically the damage they'd get from failing to repair.
	- All starter clothing gives less protection now, while some shop/npc clothing now gives some benefit.
- Chance of finding good/excellent/masterwork quality items in higher-difficulty levels.
- Plasma cutter is now much better at cutting.
- Rebalanced damage dealt by tools. Damage should be a bit higher overall. (don't actually try to fight mudraptors with a wrench though)

Tutorial improvements:
- A new campaign-integrated tutorial that teaches the basics of the campaign mode in the first outpost.
- Various fixes and improvements to the Basic and Role tutorials.
- Added popups when completing tutorial chapters that allow you to restart or continue and to return back to the menu.
- Added a reactor infographic designed to help new players better understand the reactor interface. It's accessible through a help button on the top right corner of the interface.
- Added in-game hints for the genetic system.

Changes and additions:
- New weapons: Rifle, Heavy Machine Gun, Machine Pistol, Harpoon Coil-Rifle.
- Flashlight can now be attached to all ranged weapons held with two hands.
- Limit which submarines are available in each outpost: high-tier subs become available as you get further in the campaign, and the submarine class selection depends on the type of the outpost.
- Two new music tracks.
- Added a slider to the fabricator that can be used to select how many items to fabricate.
- Added an option to hide enemy health bars.
- Items' damage modifiers are shown in store tooltips.
- Added a button for treating all characters in one go in the medical clinic.
- Breaches through the submarine's outer hull throws shrapnels that can cause minor damage to nearby characters, making monsters that can't get inside more of a threat to the crew (as opposed to just the submarine itself).
- Added a new honking scary random event to beacon stations.
- Water-sensitive materials now explode when they've been in water for 3 seconds, not immediately. Added particle, sound and light effects.
- Affliction descriptions change depending on the strength of the affliction, and whether you're treating someone else or yourself.
- Added a button for opening the Steam Workshop to all tabs of the workshop menu.
- Added tooltips that explain how the bot spawn modes work to the server lobby.
- Added various new loot items to different creatures.
- Large monsters (Abyss monsters, Moloch, Watcher) now also drop items upon death.
- Husk eggs now come in two forms: Husk eggs with actual egg-like appearance and the syringe version. Typically syringes are crafted, so finding a syringe on creatures felt a bit out of place. The eggs look as yucky as you’d expect.
- Made saline significantly less effective as a treatment for bloodloss to make blood packs more useful.
- Nerfed flak cannon's explosive ammo.
- Emp damage now stuns and damages electrical characters (Fractalguardian and Defensebot). Modders note: it’s implemented as an affliction, so it's not tied to the "empstrength" attribute defined for explosions.
- Allow putting medium items (e.g. storage container) in medical and toxic cabinets.
- Some changes to wrecked item sprites (replacing the old low-res pictures with modified versions of the normal items' sprites).
- Optimized the server lobby: there was an issue in the logic that updates the microphone icon that caused the game to check available audio devices every frame.
- Optimized status monitors: previously some parts of their UI were always updated regardless if anyone is viewing the UI.

Multiplayer:
- Quality of the radio voice chat diminishes with distance (gradually fading into radio static), similar to the way as the quality of the text chat.
- Voice chat range also affects spectators (= spectators can't hear players talking at the other side of the level).
- Fixed speech impediments only affecting the text chat, not the voice chat.
- Fixed radio voice chat not working properly if the range of the radio is larger than 250 meters. Happened because characters' positions aren't synced if they're further away than 250 meters from the client. In practice, the quality/volume of the chat would stop diminishing after 250 meters, and then immediately cut off when outside the radio range.
- Fixed inability to connect to IPv4 servers when IPv6 is disabled.
- Fixed occasional crashes when shutting down a server (for example with the error messages "pipe is broken" or "ChildServerRelay readTask did not run to completion").
- Fixed "no core packages in the list of mods the server has enabled" error when trying to join a server that's using a different version of the core package you have enabled.
- Fixed "Input contains duplicate packages" error still occurring if you try to join a server that has empty content packages when you don't have those packages yourself.
- Fixed networking errors when the connection to the server is momentarily lost and then re-established.
- Added a cooldown to client name changes to prevent using it for spamming.
- Fixed bans issued with the "banaddress" command using a client's Steam ID not working.
- Server visibility can be adjusted in the server lobby (instead of having to restart the server).
- The "respawnnow" console command forces a respawn even if there's less than the minimum amount of players waiting for a respawn.

Bugfixes:
- Fixed candidate box not being visible when using the Chinese input method.
- Fixed switching characters interrupting outpost events (even if there's currently no dialog active).
- Fixed certain events preventing other events from triggering when half-finished (e.g. preventing you from unlocking missions when an event is still running and for example waiting for you to talk to some other NPC).
- Fixed bots sometimes firing in a random direction when they equip a weapon. Happened because the aim and shoot inputs could already be active when the bot switches from another item to the weapon (e.g. from underwater scooter to some gun).
- Fixed pirates sometimes being unable to operate multiple turrets at the same time (even if there's enough crew to operate multiple), and attempting to operate hardpoints.
- Fabricator chooses the available ingredient that's in the worst condition when there's multiple suitable ingredients available.
- Fixed Esc not closing the campaign interfaces (map, store, shipyard, etc) but opening the pause menu instead.
- Fixed piezo crystals no longer spawning in the Great Sea.
- Fixed characters falling off ladders when using aimable tools.
- Fixed currently selected mission being included in the mission count displayed on the campaign map (i.e. showing "1/2" when you're choosing a new destination at an empty location).
- Fixed inability to sit in cafeteria chairs.
- Fixed projectile impacts getting triggered by gravity spheres and other TriggerComponents (meaning you couldn't hit monsters near a gravity sphere).
- Fixed blood pack fabrication recipe outputting only one item.
- Fixed tutorial not progressing when inserting a welding fuel tank inside the welding tool straight away, rather than inventory first.
- Fixed PUCS not beeping when you're underwater without a tank if you're inside a hull that has oxygen in it.
- Fixed some issues in sonar AITargets which made monsters hear the sonar when they shouldn't: switching to passive would immediately make the current directional ping cover 360 degrees, and whether the ping was directional or not would actually depend on whether the previous ping was directional, not what the mode is now.
- Fixed items getting autofilled into non-interactable containers in wrecks and outposts.
- Fixed ID cards looted from the corpses of a wreck not giving access to the secure containers in the wreck.
- Fixed verifying file integrity on Steam resetting the server settings file.
- Fixed crashing if you try to open an access-restricted directory in the file selection dialog.
- Fixed a typo in physicorium shell's damage config, causing it to not do bleeding damage.
- Fixed money gain/lose popups no longer showing in the campaign.
- Fixed bloodloss and drunkenness never fully healing, just dropping below the threshold at which the icon appears. As a result e.g. drunkenness and bloodloss never fully went away, which caused issues with some talent effects.
- Fixed bots always opening the door/hatch they're trying to repair.
- Fixed power indicator not rotating with batteries.
- Fixed lights on welding tools and plasma cutters emitting light the next round if the round ends while using them.
- Fixed Camel's airlock not draining fully.
- Fixed Berilia's bottom EDC not being wired to a supercapacitor and a loose wire between the flak cannon and the right supercapacitor.
- Fixed status effects targeting "NearbyCharacters" or "NearbyItems" being applied twice. Modders: if you used this, double the effects (e.g. damage) to get the same results as previously.
- Fixed a rounding error that caused Health Scanner HUD to display every level of bleeding below 100% as "minor".
- Fixed speech impediment from the husk infection making the bots unable to register any new targets on their own (= without being ordered).
- Fixed bots having unintentionally long reaction times on reporting the issues, causing them to ignore new enemies for a while when they first encounter them, unless being attacked.
- Fixed the default aim assist being 50% instead of 5%. Fixed aim assist not resetting when the reset button is pressed on the settings window.
- Fixed other players not seeing the spray particles when someone uses a sprayer in multiplayer.
- Fixed ability to "fire" (just dropping the projectile) hardpoints that are connected to a periscope and loader.
- When throwing an item (such as a grenade), the whole throw animation is played before the item is actually launched. Prevents being able to throw items at a ridiculous rate by spamming the hotkeys and LMB.
- Fixed portable pump's per-sub limit not working if you attach them at a spot with no background wall.
- Fixed oxygenlow resistance not affecting the time it takes to die in an unconscious state.
- Fixed bloodloss resistance not affecting how fast bleeding causes bloodloss.
- Fixed numpad keys toggling the chat when the Chat key is bind to nothing.
- Fixed main menu sometimes appearing half obstructed when starting the game on Mac.
- Fixed husk appendage breaking if the character already has extra limbs from e.g. genes.
- Fixed blocked doorways in Alien_Entrance3.
- Fixed Cyrillic symbols not being visible in the server list's server info panel when playing in a language other than Russian.
- Fixed certain genetic effects (such as regeneration from Hammerhead Matriarch genes) not working properly when multiple characters have the same effect.
- Adjusted railgun, coilgun and double coilgun firing offsets to make the projectile spawn closer to the end of the barrel.
- Fixed loot sometimes spawning in vending machines' output slots.
- Fixed water level sometimes "flickering" up and down when water is leaking to a room from the left or right.
- Fixed resetting the UI position doing nothing to equipped items' UIs (e.g. handheld status monitor).
- Fixed items equipped in the health interface slot being sellable.
- Fixed inconsistent view ranges of large turrets.
- Fixed SMG magazine shape being inconsistent with the shape of the mag well on the SMG sprite.
- Fixed character portrait and health bar buttons being clickable (despite being hidden) when the health interface is open.
- Fixed occasional crashes due to location store being null when teleporting from location to another with console commands.
- Fixes to impact-sensitive items exploding at the start of the round (e.g. at the start of explosive transport missions or when purchasing explosives).
- Fixed bots occasionally being unable to operate turrets when starting a new round until they're re-ordered to man the turret.
- Fixed focus staying on the highlighted item/character indefinitely if you keep holding LMB, even if you're outside interaction range.
- Fixed some creatures not having enough space in their inventory for the genetic materials to spawn into.
- Fixed minerals still sometimes being placed outside the level in mineral missions.
- Fixed cave tunnels sometimes being too narrow to pass through.
- Fixed "man and his raptor" outpost event giving 1000 marks in an incorrect branch of the dialog (the one where you immediately accept the NPC on board, instead of the one where the NPC says they'll pay you 1000 mk).
- Fixed cases of interaction texts for focused item (most notoriously, the planter) not being updated correctly.
- Fixed "snap to grid" causing door gaps to get misaligned.
- Fixed weird equipping behavior on fruit and paints, causing them to be equipped in both hands when trying to unequip.
- Fixed junction boxes not getting damaged by water.
- Fixed opiate withdrawal only reducing down to 20%, but never fully healing by itself.
- Fixed engines reverting back to the non-damaged sprite when they're damaged badly enough that the sprite starts shaking.
- Fixed walls being set up incorrectly in vertical abandoned outpost hallway modules, causing them to stick out into the connected modules.
- Fixed bots being unable to fix Typhon 2's top docking hatch or the wall right next to it.
- Fixed crashing when applying upgrades to linked subs, and there's more than one linked sub.
- Fixed Research Station being in the "Outpost" subcategory in the sub editor.
- Fixed bots dropping medicine from PUCS when changing its oxygen tank.

Modding:
- Added a button to the main menu that can be used to update all installed mods when there's updates available.
- Mods with errors can no longer be enabled. This change should encourage modders to fix errors in their mods and report bugs, as well as discourage players from ignoring errors.
- Removed most of the debug console error spam seen when launching the game or opening the settings menu when faulty mods are installed.
- Fixed mods failing to show up in the mods list at all when they have certain kinds of errors.
- Implemented the status effect type "OnSuccess" where "OnUse" was used instead. Changed "OnUse" to be neutral, meaning it always triggers, regardless of the (skill) requirements. You may need to switch using "OnSuccess" instead of "OnUse", if it's intended for the status effect to trigger only when the (skill) requirements are matched.
- Fixed increasing an item's HealthMultiplier making the items appear damaged in existing subs/saves (e.g. if you doubled an item's maximum condition, the items would remain in the old maximum condition and appear 50% damaged).
- Fixed crashing if a talent is triggered when the character receives some affliction, and that talent applies the same affliction on the character.
- Fixed crashing if the ingredient of a fabrication recipe can't be found.
- Fixed inability to sync properties of ItemComponents that the item has multiple of (meaning that it was only possible to e.g. edit the light color of the item's first LightComponent if it has multiple).
- Added 'launchimpulse' on RangedWeapon to affect projectile's speed (sum of launch impulses).
- Added 'penetration' on RangedWeapon to affect projectile's penetration (sum of penetration).
- Added 'DontApplyToHands' property to Propulsion, preventing extra force applying to hands when the item is held in hands (instead applying only to the character's whole body).
- Added a skill requirement conditional for StatusEffect, example: <Conditional skillrequirement="true" weapons="lt 35" /> to make a status effect occur only if the target has less than 35 weapon skill.
- Added ReloadSkillRequirement and ReloadNoSkill to RangedWeapon. E.g. a weapon with reload=2s, ReloadSkillRequirement=40, ReloadNoSkill=5s will have a character with 20 weapons skill reload at 3.5 s.
- Fixed sound's frequency multiplier not working in many cases (status effects, specific item sounds like turret movement sounds).
- Made it possible to check if some value is null or not with PropertyConditionals (e.g. CurrentHull="eq null").
- Added UseEnvironment.None to Propulsion component.
- Fixed the debug console command "head" causing the character to disappear. The command can be used for changing the appearance of the character at runtime.
- Status effects of type "OnUse" on projectiles now trigger when the projectile is launched. Previously it launched when the projectile hit the target. Use OnImpact (or OnSuccess/OnFailure) when you want something to happen when the projectile hits the target.
- Added an option to multiply the damage by max vitality (relative damage) per affliction definition, in addition to the "multiplyAfflictionsByMaxVitality" attribute defined for the status effects. If you want to define it for an affliction separately, leave the status effect level definition undefined, because it'd override the affliction specific value.
- Fixed item's OnSpawn effects being applied twice.
- Fixed item components that inherit the status effects from another item component (e.g. the medical syringes) triggering the status effects twice when the effect is triggered via the item and not via the item component. Didn’t cause issues with the vanilla items, but might affect some mods. If your item e.g. suddenly does only half of the damage after the update, it’s possible that it was affected by the bug. Just double the effect to fix it.

---------------------------------------------------------------------------------------------------------
v0.19.14.0
---------------------------------------------------------------------------------------------------------

- Fixed submarine upgrades getting clamped to the maximum of that upgrade between rounds, disregarding class/tier bonuses.

---------------------------------------------------------------------------------------------------------
v0.19.13.0
---------------------------------------------------------------------------------------------------------

- Fixed "failed to find the end of the bit field after 100 reads" error when trying to join a server that has a large number of mods enabled.
- Fixed "Tandem Fire" talent causing a crash due to the changes in the previous version.

---------------------------------------------------------------------------------------------------------
v0.19.12.0
---------------------------------------------------------------------------------------------------------

- Fixed submarine upgrades getting lost if you switch to a lower-tier sub that can't have as many levels of upgrades as the current sub, and then back again.
- Fixed some monster events not being as common/uncommon as intended. In more technical terms (which may be of interest to modders): the commonness defined as an attribute of an EventSet did nothing, making the event default to a commonness of 1. The commonnesses defined for specific level types worked correctly.
- Fixed clients getting stuck in a non-functional lobby if they happen to disconnect or get kicked back to the lobby at a specific point when loading a new round.
- Fixed large turret hardpoint origin being off, causing turrets installed on a large hardpoint to be misaligned.
- Attempt to fix crashing when disconnecting from the server you're hosting.
- Fixed Ctrl+Shift+S shortcut (quicksave) not working in the sub editor.
- Fixed toolbelts and storage containers in old subs going inside toolbelts.
- Fixed submarine tier resetting to default when reopening the sub editor's save dialog.
- Fixed sub editor not taking filename case into account when saving an existing sub: if you'd try to save the file with a different filename case, it'd ask about overwriting the existing sub, but save it as a new file even if you opt to overwrite.
- Fixes to Herja room names (use Engineering, Gunnery compartment, etc. labels), add camera to the front, with a periscope for the captain.
- Fixed non-purchaseable talent items not being available as extra cargo.
- Sorted extra cargo alphabetically + added a filter box.
- Fixed taking items that spawned inside another item (e.g. tanks in a diving mask) from NPCs spawned by an event not counting as stealing.
- Fixed characters falling off ladders when using aimable tools.
- Fixed money gain/lose popups no longer showing in the campaign.
- Fixed inability to manage the campaign if there's no-one with permissions alive. Previously we allowed anyone to manage the campaign if there's no-one with permissions present in the server, but that's not enough, because the players with permissions can't end the round if they're dead. Now if there's no-one with permissions alive, anyone is allowed to manage the campaign.
- If Select and Deselect have been bound to the same key, the deselect input is ignored when interacting with another item than the selected one. Prevents e.g. falling off ladders when trying to open a hatch when both Select and Deselect have been bound to E. 
- Made it possible to enter a hostname (e.g. someserver.com) in the direct join prompt.
- Adjusted the size of the submarine list elements in the server lobby to reduce the amount of empty space on large resolutions.
- Fixed event texts for the "scan ruin" mission being in an incorrect language.
- Attachable items cannot be attached inside walls.
- Fixed distance at which you can attach items being slightly longer than the interact distance, making it possible to attach items out of reach.
- Fixed inability to turn when you're dual wielding melee weapons and attacking continuously.
- Fixed inability to cancel deconstruction if there's non-deconstructible items in the queue.
- Fixed local copy of a mod you're publishing not using the version number you've entered in the publish menu.
- Fixed crashing when trying to open the tab menu's character tab with a character who has no personality trait (may happen e.g. if you use a mod that adds custom personality traits and try to play that save without the mod).
- Fixed sourcerect issue in alien generator + decorative sprite not disappearing when the fuel rod is taken out.
- Fixed corrupted mods causing a nullref exception when autodetecting required mods in the sub editor.
- Fixed minerals not disappearing from mineral scanner if they get detached by something else than a character picking them up (e.g. by the destructible ice wall they're on breaking).
- Fixed event-specific metal crate deconstructing to steel.
- Fixed inability to join servers that have enabled multiple mods with identical content.
- Fixed tandem fire not working if there's a character between you and the other character on a periscope.

---------------------------------------------------------------------------------------------------------
v0.19.11.0
---------------------------------------------------------------------------------------------------------

- Fixed some old campaign saves being impossible to continue due to the new submarine upgrade restricions.
- Fixed "update all mods" button doing nothing in the Workshop menu.
- Fixed inability to create mod lists that include Workshop mods.

---------------------------------------------------------------------------------------------------------
v0.19.10.0
---------------------------------------------------------------------------------------------------------

- Updated translations. Includes various fixes to existing translations. The Japanese translations in particular has been significantly improved.
- Fixes to Camel waypoints.
- Fixed pump in Camel's airlock not pumping out by default.
- Fixed high-quality fuel rods and other high-quality consumable items resetting to 100% between rounds.

---------------------------------------------------------------------------------------------------------
v0.19.9.0
---------------------------------------------------------------------------------------------------------

Fixes to new issues in the previous build:
- Fixed missions always giving rewards even if you fail them!
- Fixed clients sometimes failing to reconnect to the server if the connection is momentarily lost.
- Fixed item conditions resetting to 100% between rounds.
- Fixed mineral missions always causing a crash.

---------------------------------------------------------------------------------------------------------
v0.19.8.0
---------------------------------------------------------------------------------------------------------

- Minor improvements and fixes to the tutorials (e.g. safeguards to prevent dying or getting stuck).
- Fixed Typhon 2's chaingun being placed inside solid walls.
- Fixed Tandem Fire talent causing a crash if there's no allies alive.
- Fixed bots being unable to shoot at ice spires with pulse laser or chaingun.
- Removed outdated Deep Diver loading screen tip.
- Fixed misaligned connection panel interface when repairing a status monitor.
- Fixed Winterhalter battery recharge speed being limited by the relay that supplies power to them, making recharge speed upgrades useless.
- Fixed a networking issue that caused afflictions' periodic effects (e.g. nausea-induced vomiting) to happen too frequently client-side.
- Fixed none of the contextual orders except "wait here" showing the name of the order in the tooltip.
- Fixed inconsistencies in some crawler swarm mission names (large swarms not being described as large).
- Fixed mineral mission resources sometimes spawning in separate caves.
- Fixed minerals mission resources sometimes spawning outside the level.
- Moved handheld sonar's drag icon to a more appropriate position.
- Fixed buoyancy making locked subs slowly move vertically.
- Reactors don't explode if they reach 0 condition without fuel.
- Fixed motion sensor not detecting pets.
- Fixed cargo capacity displayed in the mission selection screen including the cargo containers in the outpost the sub is docked.
- Fixed clients being unable to select the respawn shuttle if they have to download it from the server. 
- Fixed duplicate banlist entires when a client gets banned due to an incorrect password.
- Some wire and waypoint cleanup to R-29 and Remora. 
- Removed a wall in Remora to allow for better movement inside.
- Changed one railgun shelf to boxes shelf on Remora.
- Added a coilgun and a couple more diving suit cabinets to R-29.
- Fixed "completed initialization before receiving content package order" error when trying to reconnect to a SteamP2P server.

---------------------------------------------------------------------------------------------------------
v0.19.7.0 (Hoist the Sails)
---------------------------------------------------------------------------------------------------------

Changes and additions: 
- Completely remade tutorials. There is now a Basics Tutorial to cover basics like moving, inventory and repairs. More specific tasks are explained in the Roles Tutorial, where every job has their own tutorial to go through, explaining what it means to be e.g. an Engineer or a Captain.
- Added new mining missions, including some in the abyss.
- Reintroduced separate local/radio voice chat keys as a legacy option. Now it's again possible to speak with voice activation by default and use a push-to-talk button for radio, the same way as before, by setting the chat mode to Local and using the new radio voice chat hotkey.
- Device/item UIs can be moved around by dragging.
- Allow using devices while on a ladder or sitting on a chair.
- Changed reactor temperature bar colors (from blue to red).
- Higher quality stun batons cause heavier stun.
- Changed unit load device capacity to 12 (because the sprite has space for 12) and made them waterproof.
- Changed fabricator skill calculations: the most inadequate of the required skills determines the fabrication time (instead of the average).
- Made dying drop a characters' skills towards the maximum initial skill instead of minimum.
- Added a new keybind for opening and closing the chat box. The default bind is B.
- Added a warning if a new keybind overlaps with any of the player's existing binds.
- Overvoltage makes devices perform better, increasing the output of engines, making fabricators, deconstructors and pumps operate faster, electrical discharge coils do more damage, batteries recharge faster and oxygen generators generate more oxygen. Encourages operating the reactor manually and hopefully makes it a little more engaging.
- Added more randomness to junction box overvoltage damage, and made partially damaged boxes take more damage from overvoltage. Prevents all boxes from breaking at the same time, making overvoltage less of a pain to deal with and intentionally overvolting devices more worthwhile.
- Added manual temperature adjustment buttons which immediately increase/decrease the temperature of the reactor for a brief amount of time on manual control (bumps the gauge up/down by a fifth, and the boost fades out in 20 seconds). Allows reacting to load fluctuations very quickly, and conserving fuel by operating the reactor at a lower fission rate � a new benefit to operating reactors manually.
- Signals no longer set the fission and turbine rates of the reactor instantaneously, making automated reactor circuits less overpowered. They are still viable, but especially now with the addition of the extra incentives for operating the reactor manually, they're no longer as clearly the best and most efficient way to operate the reactor, making manual operation more worthwhile.
- Made the "distort" camera effect a little less obtrusive and glitchy-looking (smoother texture + less heavy effect).
- Made water-sensitive materials (lithium, potassium, sodium) spawn in waterproof chemical crates.
- Made crates deconstruct much faster to make them easier to get rid of.
- Sonar disruptions now hide minerals.
- Grayed out ranged weapons' crosshair when reloading (similar to turret crosshairs).
- Disabled the autodocking prompt (which verifies whether you actually want to dock when docking is initiated by an automated circuit) in single player.
- Improved the way drag is applied on submerged items. Fixes heavy items dropping at unnaturally high speeds in water.
- Added a splash effect when an item falls into water.
- The deconstructor UI shows what the input items deconstruct to (particularly important now with the lossy deconstruction recipes - it can be risky to deconstruct something just to see what materials it gives out if that results in material loss).
- Wall and device repair costs in outposts are calculated based on the amount of damage on your sub, instead of always having a fixed price.
- Inflamed lung doesn't affect characters that don't need oxygen.
- Added swarm behavior for crawler husks.
- Added some more oomph to nuclear explosions.
- Adjust the alpha of the outpost service icons according to distance to make it easier to estimate where the NPC is at. Show the title of the NPC when hovering the cursor over the icon.
- Added "unlockmission" console command.
- Added "setcampaignmetadata" console command (may be useful for modders creating custom scripted events for the campaign).
- Changed how NPC "titles" work. Previously we defined "titles" for the pirates (e.g. "Pirate Lord" and such), and the title replaced the name of the NPC (which made their dialog a little awkward). Now we display both the name and the title over the character, and special outpost NPCs also have titles.
- Gave diving masks to most NPCs.
- Changed the burn overlay formula: now also the non-affected limbs get half of the effect, because the sharp contrast between limbs looked weird.
- Restored the 3-shell Railgun rack as a legacy option.
- Reworded the "respawn with penalty" prompt to make it less confusing: you always get a penalty to your skills when you die now, and Reaper's Tax is an "extra penalty" you get on top of that if you opt to respawn mid-round. The intention behind this is to incur a cost to respawning, as it shouldn't be possible to get unlimited free reinforcements and supplies mid-round.
- Made SIGTERM close the linux server gracefully.
- Made respawn items (suits, scooters) spawn in the respawn shuttle's cabinets when possible.
- Show a healthbar on items (e.g. eggs and thalamus organs) when damaging them with handheld weapons (melee or ranged).

Submarines: 
- Added a new intermediate transport sub, Camel.
- Added submarine tiers. Higher-tier submarines can be upgraded further than lower-tier submarines.
- Overhauled and balanced submarine upgrades.
- Added Large Weapon Hardpoints.
- Added Flak Cannon and Double Coilgun as new Large Weapons.
- Railgun is now considered a Large Weapon.
- Added an upgrade that adds a mineral scanner to nav terminals and sonar monitors.cannon
- Submarine class now affects which upgrades are available for the sub.
- Removed the Deep Diver class: the way we see it, Deep Divers didn't have a clear enough role in the game, especially considering that hull upgrades served pretty much the same purpose. In practice, the only clear benefit of a Deep Diver was being able to get through the very last levels of the campaign, and having to switch to one just for that purpose wasn't fun. Now any submarine with full hull upgrades can get all the way to the end of the campaign.
- Fixed messy wiring in Typhon 2's bottom left hardpoint.
- Winterhalter and Remora are now Scout class ships.
- Added some loose vents and panels to Herja, Winterhalter and Barsuk, fixed invisible "loose panel" (news stand) in Orca 2.
- Fixed floating light component in Orca 2.
- Medical fabricator now consumes 500 power on all submarines, to be consistent with other fabricators.
- Updated prices of all submarines to match tiers.
- Gave Typhon 2 better stats and even more firepower, to outclass the original Typhon.
- Improved R-29's speed and gave it a Flak Cannon.
- Added Large Weapon hardpoints to Berilia to make it a Tier 3 transport.
- Tweaked the hulls and waypoints around Herja's top docking hatch to make it easier for bots to reach and weld.
- Fixed a waypoint/hull issue in Typhon's stowage compartment (waypoint in such a tight space the bots couldn't reach it).

Balance:
- "Mission cheesing" by repeatedly undocking and redocking to an outpost to reroll the mission events no longer works: new mission events don't reappear until one "world step" has passed (~10 minutes or traversing through one level).
- Balance pass on handheld weapons: adjusted reload times, damages, stun durations, recoil and ammo stack sizes.
- Reduced tools' structure damage (dual-wielded storage containers no longer chew through submarine walls in seconds).
- Increased heavy ruin wall health to make it less easy to cheese your way into the artifact room in ruins.
- Made boomstick fire in bursts of 2 (similar to deadeye carbide) to prevent ridiculous fire rates with quick-reloading.
- Added EMP effect to nuclear depth charges for consistency.
- Pulse Laser and Railgun now have similar power consumption as other turrets.
- Changed how skill levels affect the quality of fabricated items. Previously having a skill level equal to or higher than the item's skill requirement would result in a good quality item, meaning that practically everyone could e.g. fabricate good quality oxygen tanks. Now your skill needs to be >20% from the minimum skill requirement towards 100 (e.g. if the item requires 20 skill to fabricate, 36 results in a higher quality item).
- Reduced PUCS's radiation resistance from 100% to 90%. Complete invulnerability to radiation has way too much potential for exploits and overpowered strategies.
- Adjusted supplies in pirate submarines.
- Turned some weapons' burn damage into explosion damage.
- Made the extra sales from "traveling tradesman" talent stack.
- Terminal ignores empty signals.
- Reduced commonness of molochs (as they can take a lot of time to kill, running into multiple of them can quickly become a chore)
- Removed steel requirement for depth charges. Fabricate decoy depth charges from depth charges, rather than from the base material.
- Reduced the Pulse Laser tri-laser bolt spread.
- Explosions are now calculated differently, using the number of limbs to divide the damage (up to a maximum of 15 limbs). Adjusted explosion damage values to match new calculations.
- Coilgun costs 5000 marks to install, Pulse Laser and Chaingun 6000. Large turrets each cost 7500 each.
- Made mudraptor eggs modestly profitable for farming (decreased cost from shop, increased deconstruction yields).
- Mineral yield and spawn rates rebalance: minerals found are now much more dependent on location (biome, cave, abyss).
- Balanced existing mineral missions: adjusted rewards & required minerals, and required some minerals to be handed over to the outposts as proof of their existence.
- Rebalanced Engine Force values to better match hull size. Most Scouts (Azimuth, Orca2, Remora, Winterhalter) are now faster. Humpback, Typhon and Orca are slightly slower.

Multiplayer:
- Fixed missions sometimes unlocking in incorrect locations in MP campaign, making them either unselectable or causing a "mission mismatch" error when the round starts.
- Fixed clients downloading submarines they already have from the server if the mods those submarines are in are not currently enabled.
- Significantly sped up file transfers (mods, submarine files, campaign saves).
- Clients who've recently joined (by default 2 minutes) are not allowed to vote to kick others, and vote kicking someone always requires at least 2 votes.
- Servers don't allow selecting hidden jobs (jobs only used by NPCs) as job preferences.
- The minimum kick vote counts are no longer rounded down. Previously if you had for example four players on the server and the minimum vote count set to 60%, kicking would require 2 votes, now it requires 3.
- Fixed inventory and wallet resetting if a campaign round ends when a client's character has spawned, but the client is not currently controlling it (e.g. due to getting kicked to the lobby).
- Fixed spectator checkbox overlapping with the character info if you get kicked to the lobby mid-round.
- Fixed "kick" button staying disabled indefinitely if you vote to kick someone and the vote doesn't go through.
- Fixed Steamworks publish tab showing the "free weekend" message when using Steam family sharing.
- Minor tweaks to the end of PvP missions to make them a little less underwhelming: instead of ending the round immediately when one team is dead (without even giving enough time to see the enemy die), there's a brief delay, a message box and a camera transition to let the players see what happened.
- Fixed PvP team assignment sometimes being wildly imbalanced, even when there were enough players with no preference to make the team sizes equal.
- Fixed clients getting stuck in the loading screen if they happen to disconnect at the right moment between rounds.
- Fixed bank balance not getting corrected if it's become desynced by e.g. client-side commands.
- Fixed server not registering a client's character as disconnected if the client disconnects and reconnects before the round has fully started, causing the client to get stuck as a spectator when they rejoin.
- Fixed clients disabling their client-side-only mods when they join a server.
- Fixed hull/item repairs purchased from an outpost sometimes not getting applied client-side.
- Fixed "missing entity" errors in a specific situation in multiplayer. Occurred when a respawn shuttle was enabled and loaded on the server (= i.e. in a non-outpost level), and a client disconnected and immediately reconnected. This would cause the client to deselect the respawn shuttle and make them start the round without loading one, leading to the "missing entity" issues due to the shuttle only existing server-side.
- Fixed damage visuals not showing on characters who've died off-screen.
- Fixed ability to upgrade the sub when there's a switch pending in multiplayer.
- Fixed friendly fire and karma always showing up as disabled on dedicated servers in the server list.
- Fixed spineling spikes fired by a human with spineling genes not damaging any human characters (enemies in PvP, pirates in pirate missions) when friendly fire is disabled.
- Fixed "invalid ExecuteAttack message: limb index out of bounds" errors when you join a server where a character has fired spineling spikes with spineling genes mid-round.
- Fixed "entity not found" errors if a shuttle or submarine ends up absurdly deep in multiplayer (>100 km). We don't even know how someone managed to pull this off.
- Fixed rapidly clicking on the mission giver sometimes not giving all the available missions when the "Use" input is set to LMB. Happened because the conversation logic didn't check if there's another conversation active, causing the server to show a new conversation when clicking the NPC, without interrupting/continuing the previous conversation. 
- Made shockjock event only show for the player triggering the event (making it visible for everyone works kind of weirdly, when the event involves talking to an NPC next to the character who triggered the event).
- Fixed outpost events getting stuck at the last ConversationAction if another client has finished the action.

Optimization:
- Updated our runtime to .NET 6, which should yield significant performance improvements. Do note that this unfortunately means we'll have to drop support for macOS versions older than 10.15, but we have taken some measures to help the affected Mac players continue having access to Barotrauma. More info here https://store.steampowered.com/news/app/602960/view/3367025204056277713.
- Optimized afflictions that apply other afflictions on the character (e.g. radiation sickness, drunkenness, opiate withdrawal).
- Optimizations to the talent system, particularly when the talent menu is open and when there's a large number of talents (e.g. when using mods that make all talents available to every class). 
- Physics optimization: fixed submerged items' physics bodies staying active indefinitely even after they've come to rest due to buoyant forces being applied on them constantly. Now we stop updating bodies that have come to rest on the floor and aren't light enough to float.
- Optimized AI objectives that make bots fetch items (combat, contain item, decontain item, get item).

Submarine editor:
- Fixed door gaps not appearing in the sub editor until you select the door.
- Fixed sub editor background images not saving.
- Fixed turret lightsource rotation not refreshing in the sub editor when flipping the item.
- Fixed prefab placement breaking in the sub editor if LMB is held while moving the cursor outside of the selection panel.
- Fixed several instances of janky UI interactions in the submarine editor: dragging the selection rectangle now works even if the cursor reaches into the prefab list; letting go of a dragged entity works even if the cursor reaches into the prefab list; the dragged entity no longer goes invisible when reaching into the prefab list.
- Made PowerContainer recharge speed always default to 0.
- Fixed adding resizeable items (like ladders) not being registered in the sub editor's command history, preventing undoing it.
- Changed default reactor output from 10,000 kW to 5000 kW.
- Decreased Winterhalter reactor output and increased its fuel consumption rate.
- Fixed some gap issues in Winterhalter.
- Fixed medics not having access to the toxin cabinet in Barsuk.
- Fixed medic, engineer and mechanic spawnpoints having no tags in Typhon.
- Fixed crashing when trying to multi-edit a string value in the sub editor.
- Fixed dragged objects becoming invisible if you bring the cursor over a UI element in the sub editor.
- Fixed screwdrivers and wires in your "inventory" being included in the total item count in the sub editor's wiring mode.
- Fixed entities that were below the cursor when starting to resize a structure staying highlighted during resizing.
- Fixed sub editor treating the autosave interval as minutes instead of seconds (saving every 300 minutes instead of 300 seconds).

Fixes:
- Fixed "power flowback" issue in turrets. As of the power rework, wires connected to the same input or output pin of a device are considered to be in the same grid, which in practice meant a turret could be connected to another supercapacitor through the power_in connection of another turret, even if there was no direct connection between the 1st turret and the supercapacitor. Now the turrets (and electrical discharge coils) need to be wired directly to the supercapacitor.
- Fixed brief freezes when monsters spawn mid-round.
- Fixed turrets linked to the same loader messing up the upgrade store UI and causing item swaps to cost more than they should.
- Fixed submarines always saving in the root folder of a local mod, instead of the subfolder they were originally in.
- Fixed Reaper's Tax not stacking.
- Fixes to ruin decals in a bunch of ruin modules.
- Fixed a waypoint issue in the Alien_Entrance3 ruin module.
- Removed oxygen tanks from DockingModule_01_Colony.
- Fixed duct block's misaligned broken sprite.
- Fixed status monitor calculating linked hulls' water amounts incorrectly (displaying the average of their water percentages, which isn't correct if the hulls aren't the same size).
- Fixed inactive components (components not currently sending any signal) not reactivating if their output is set to a non-empty value.
- Fixed missing gap in SecurityModule_02.
- Fixed lack of outpost events in difficulties past 80 (which no longer occur normally but still exist in old saves and mods). 
- Fixed lithium and magnesium descriptions.
- Adjusted hulls in DockingModule_02_Colony to prevent bots from jumping off the ledge.
- Fixed motion sensors detecting pets as monsters (pets are now a separate target type).
- Fixed helmets not protecting against concussions.
- Fixed safety harness not protecting against lacerations.
- Fixed increasing an item's HealthMultiplier not increasing the current condition (so e.g. doubling the item's max health would cause it to have 50% condition).
- Fixed successive event dialogs in the same prompt scrolling the prompt back up and then down.
- Fixed missing "pirateclothes" inventory icon.
- Made bots better at figuring out which button controls a door when there's some complex circuit involved. Previously the bots would try to find a button connected to any of the door's connections via wires/circuits, now only the toggle and set_state inputs are considered.
- Bots now clearly prefer using buttons linked to the door in the sub editor. Can be used as another way to help bots figure out which button they should press in situations with multiple buttons and complex door control logic.
- Fixed bots failing to find a path to a couple of spots on Herja.
- Fixed alien materials (physicorium, incendium, fulgurium, dementonite, paralyxis) not being shown on the mineral scanner.
- Another fix to cave generation to prevent it from creating impassable paths.
- Fixed inability to use manual assignment for bot orders with options.
- Fixed all boolean components (And, Or, Xor) using the And Component's tooltip for the "timeframe" property.
- Fixed boolean operator component (And, Or, Xor) timeframes not working correctly in some situations (non-zero timeframe, empty false output). The component would deactivate as soon as it stops sending an output, which could prevent some inputs from timing out (meaning that the component could send a signal again as soon as it receives signal A, even if signal B hasn't been received within the timeframe).
- Fixed PUCS consuming the medical item inside it when a welding fuel or incendium tank is inserted.
- Fixed a level generation issue that sometimes made the level impassable if there happened to be a cave right above the outpost.
- Fixed holes on sloped walls being impossible to pass through when you're swimming straight down/up (or straight right/left depending on the wall): the walls are technically considered either horizontal or vertical (depending on the angle of the slope), and you would have to swim in a direction perpendicular to this "technical" direction of the wall.
- Fixed retrying the Hognose mission making a new Hognose join your crew every time.
- Fixed idling NPCs sometimes getting stuck on ladders.
- Fixed mirrored turrets being displayed backwards on the status monitor.
- Fixed character's hands getting "stuck" if you handcuff yourself while dragging someone.
- Fixed dragged character's arms not being pulled towards you, making it look like you're dragging them without touching if you run or walk away while dragging.
- Fixed dragged bots slowly moving constantly, preventing them from switching to the normal standing pose.
- Fixed bots having trouble fixing leaks in multi-hull rooms: they were required to be in the same hull as the leak, which prevented them from fixing leaks in e.g. R-29's bilge.
- Fixed combat missions not ending the round if both crews are dead.
- Fixed bots stating the name of the character they're firing at with turrets, making it seem like they know the name of every pirate they come across and magically recognize them through the walls of the enemy sub.
- Fixed Chaingun rotation speed not being affected by the weapons skill.
- Fixed crashing when using ':' in item assembly names on Linux platforms.
- Fixed ImmuneToPressure ability flag being ignored on characters who don't need air (in practice meaning that you can get killed by pressure if you get huskified even if you have a talent that makes you immune to pressure).
- Fixed geneticmaterialcrawler_unresearched3 producing mudraptor genes.
- Fixed linked subs still sometimes getting placed on the wrong side of the docking port when switching subs.
- Fixes to ruin door connections, wiring and connection panels.
- Fixed "insurance policy" giving the money to the dead character instead of the bank.
- Fixed damage to mirrored wall pieces resetting between rounds.
- Increased the minimum width of cave tunnels to prevent impassable paths.
- Fixed deconstructor input slots becoming unlocked when starting a new round while the deconstructor is running.
- Fixed Grenade Launcher quality doing basically nothing, because it increased the minuscule amount of blunt force trauma the grenade causes on impact instead of the explosion damage.
- Fixed vitality modifiers not being taken into account in the readings in the health interface. For example, gunshot wounds on the head cause a x2 larger vitality drop than on other limbs, but this wasn't displayed on the health interface.
- Fixed Planet Neon Sign sprite bleed.
- Fixed level resource spawn rate not properly respecting the resource spawn chance values of level generation parameters.
- Fixed some text overflows in the hiring menu when using a small HUD scale.
- Fixed name on an ID card resetting to the original name if you rename a character and then start a new round.
- Fixed handcuffs in the backmost hand being drawn in front of the character.
- Fixed water splashes appearing in an incorrect hull when a character's limb moves from a flooded hull to another hull, where the limb is no longer underwater.
- Fixed crashing when a signal causes a wired item to be dropped (e.g. when you attach a detonator to a destructible ice wall and blow it up). 
- Oxygen generators and shelves don't fill up oxygen tanks when on fire. Caused repeated explosions when the tank constantly refilled and re-exploded.
- Fixed "gene harvester" and "deep sea slayer" working on all enemies, not just monsters.
- Fixed floating point inaccuracy sometimes preventing items from being used as fabrication ingredients (e.g. an oxygen generator may sometimes only fill tanks up to something like 99.9998%, which prevented it from being used in recipes that require a full tank).
- Fixed item picking timer (e.g. detaching an item from a wall) ticking down when the game is paused.
- Fixed outpost supply cabinets missing the oxygen tank spawns.
- Made the water current outside the levels start from the same point where monsters start heading towards the level, to make sure monsters can't escape too far from subs with a weak engine. 
- Fixed hardened diving knife recipe.
- Fixed probability multiplier not being shown in wearable tooltip if the damage multiplier is 1.
- Yet another attempt to prevent beacon missions from failing for apparently no reason: sonar monitors won't get damaged by water after the beacon's been activated.
- Fixed text selection in a textbox stopping when the cursor goes outside the box.
- Fixed fire, breach and intruder report icons not being shown to anyone.
- Fixed missing/unwired lighting in ResearchModule_02_Colony.
- Remove particles when switching screens (otherwise e.g. particles from the previous round are still in the level if you happen to be looking at the right spot).
- Thalamus or ice walls can't be welded.
- Quick-reloading tries to reload the item whose contained items have the lowest condition. In other words, if you've equipped 2 weapons, quick-reloading reloads the one with the least ammo instead of the one that's the first in your inventory.
- Fixed erroneous dementonite and depleted fuel tool recipes.
- Fixed swapping a scaled turret/hardpoint causing the new one to be misplaced.
- Fixed inability to upgrade the sub or do maintenance if you buy and opt to switch to a new sub, and then go to the submarine switch terminal to cancel the switching.
- Fixed stolen items becoming non-stolen when deconstructed.
- Fixed ItemContainer UI popping up (with no visible inventory slot) when you pick one up, e.g. picking up a detonator from the floor.
- Fixed "[E] Rewire" hover text being shown on attachable items that haven't been attached to a wall (even though they can't be rewired until attached).
- Fixed trying to bind multiple console commands to the same key with the "bindkey" command crashing the game.
- Fixed high-quality revolvers having no difference to normal-quality ones. They should get a 10% damage boost per quality level but didn't, due to incorrectly configured quality stats.
- Fixed multiple monster missions sometimes spawning the monsters close to each other, causing them to attack each other.
- Fixed monsters sometimes using the wrong animation parameters while idling (or moving slowly).
- Fixed nuclear depth decoy using the same sprite as the normal depth decoy.
- Fixed fractal guardian VitalityMultipliers being configured incorrectly (using the "type" attribute but with affliction identifiers instead of types).
- Fixed incorrectly sized thalamus wall colliders, added background sprites to the walls.
- Fixed "tried to overwrite a submarine that's not in a local package" error when loading and trying to save a submarine autosave file.
- Fixed location portraits sometimes not showing up in the mission tab. Happened when we initialized the mission tab before the portrait had been loaded.
- Fixed Coilguns and Chainguns not always playing the firing sound when fired. Happened because their audio clips were so long (albeit mostly silent) that firing them continuously led to a ton of clips playing simultaneously, exhausting the available audio channels.
- Fixed monster missions' sonar marker being placed incorrectly if a monster ends up inside the sub, making it look as if the monster was far outside the level. This often made it look like the monster was moving away from the sub when trying to approach its position as it appeared on the sonar?
- Fixed bandolier (and other items that give bonuses when worn) giving bonuses when the item is held.
- Fixed mod texts being briefly misaligned when scrolling down the list of unpublished mods.
- Fixed light sprite rotation not getting refreshed when placing an attachable item on a wall when lighting has been disabled with console commands.
- Fixed supercapacitors showing 1% as the initial recharge rate because the recharge rate defaulted to 10.
- Fixed some ending options of the "good samaritan" outpost event not ending the event.
- Fixed random (non-mission) events disappearing from outposts when you save and quit.

Modding:
- The tutorials are now implemented using the scripted event system, and are fully moddable. New tutorials can be implemented in xml or using the event editor, and the system could potentially be used for other types of content too (scripted "scenarios" perhaps?).
- Added DamageMultiplier and LaunchImpulse to Turret. LaunchImpulse is now defined on turrets instead of ammunition (total impulse is the sum of turret + ammunition).
- Added SnapRopeOnNewAttack property to Attacks: allows characters to switch attacks without snapping ropes from previous attacks.
- Added dividebylimbcount to Explosion, which determines whether the damage is spread out among limbs (if set to true).
- UpgradeCategories with no upgrades in them are hidden from the upgrade menu (i.e. if you modify the upgrades so some of the vanilla categories no longer contain any upgrades, those categories won't be shown).
- Added CheckTalentAction, which can be used in events to check whether a target has unlocked a specific talent.
- Changed how submarine upgrades are calculated: now no longer adds previous levels' cost to the price, but rather relies on higher increasehigh values.
- Made NPC personality traits a separate content type instead of defining them in the localization files.
- Fixed OnDeath status effects defined in afflictions not working. Did not affect any vanilla content.
- Fixed crash when controlling a character with more than 10 "Any" inventory slots. Did not affect any vanilla content.
- Fixed custom husk appendages' textures failing to load.
- Added new properties to StatusEffect's SpawnCharacter feature: Stun, AfflictionOnSpawn, AfflictionStrength, TransferControl, RemovePreviousCharacter, TransferBuffs, TransferAfflictions, TransferInventory.
- Fixed bots always choosing their "personality trait" from the first 6 even if more are modded in.
- Fixed affliction names and descriptions being empty if they're not available in the selected language or configured in the affliction .xml file directly.
- Fixed custom husk afflictions not always working properly, because the vanilla husk affliction was sometimes used instead of the custom husk affliction.
- Fixed ExtraLoad working the wrong way around on PowerTransfer components that generate/consume power (the extra load would supply power to the grid). Does not affect the vanilla game, because neither junction boxes or relays generate or consume power.
- Fixed crashing if Afflictions defined in an Attack can't be found.
- Fixed crashing if a Throwable has an OnActive StatusEffect that removes or kills the user.
- Fixed items/structures falling back to the description defined in the .xml even if it's empty, if the description is not defined for the selected language. Now descriptions fall back to English when not defined for the selected language.
- Fixed the "reloadwearables" and "loadwearable" console commands crashing the game when used outside the character editor.
- Fixed character editor crash if you first reload textures and then recreate the ragdoll.
- Fixed inability to localize item names if the name is defined directly in the item config.
- Allowed defining where mineral mission resources are spawned using the "positiontype" attribute. The supported types are "MainPath", "SidePath", "Cave", and "AbyssCave".
- Fixed console errors when trying to check int values with PropertyConditionals.
- Fixed melee weapon's StrikingPowerMultiplier only affecting the afflictions defined in the Attack, not the ones defined in the status effect.

---------------------------------------------------------------------------------------------------------
v0.18.15.2 (MacOS only)
---------------------------------------------------------------------------------------------------------

- Fixed crashes on MacOS 10.13 and 10.14. This seems to have happened because Microsoft quietly dropped support for these versions in .NET Core in late 2021, and we didn't realize until this hotfix when we deployed with a sufficiently new version of the technology. 
- Fixed inability to use the voice chat on some MacOS versions, due to the game not having permissions to access the microphone as a result of the aforementioned .NET Core upgrade.

---------------------------------------------------------------------------------------------------------
v0.18.15.1
---------------------------------------------------------------------------------------------------------

- Fixed frequent crashing in the submarine editor. The crashes were caused by modifying multiple entities at the same time, such as by selecting an entity of the same type as the last entity that was edited.
- Fixed dragged objects becoming invisible if you bring the cursor over a UI element in the submarine editor.
- Fixed a bug that sometimes caused radio voice chat to be muffled.

---------------------------------------------------------------------------------------------------------
v0.18.15.0
---------------------------------------------------------------------------------------------------------

Changes:
- Show a warning when trying to switch to a submarine that's low on fuel or to a submarine that has no manually placed items to prevent softlocking the campaign if you switch to a sub that has no fuel. Whether a submarine is considered to have manually placed items can be set when saving it in the submarine editor (the checkbox "manually outfitted" in the saving dialog).
- Also show the low fuel warning when leaving an outpost without enough fuel.
- Handheld sonars can't detect minerals from inside the sub.
- Changed the plus and minus button in the campaign settings into arrows. The button on the right increases difficulty, which in the case of the starting balance and supplies means reducing them, making the plus and minus buttons misleading.
- Reduced costs of handheld weapon ammunition significantly.
- Up revolver & harpoon shop availability (especially at military outposts / armory merchants)
- Slightly reduced effectiveness of harpoons and revolver round to compensate for the cheaper / more available ammo.
- Changed recipes for Handcannon, Assault Rifle and Auto-Shotgun. Weapon crafting is more expensive, to compensate for cheaper ammo.
- Adjusted numerous other recipes and price costs of materials. Previously little used materials (like tin) are now used more.
- Partially reintroduced the "toggle inventory" keybind, now called "toggle entity list". Even though toggling the in-game inventory is no longer possible, the keybind can be used to change the hotkey for toggling the sub editor's entity list.

Fixes:
- Fixed shuttles getting misplaced when switching and transferring items to a new sub with shuttles.
- Fixed inability to damage items (such as monster eggs) with melee weapons or handheld weapons.
- Fixed "failed to parse the string 'COLOR.GUI.GREEN' to Color" errors when using the submarine upgrade interface in Spanish.
- Fixed items with a projectile component (e.g. bullets, harpoons, syringes) going through external walls when dropped.
- Fixed incorrect value in the "too many lights" error message in the sub editor.
- Fixed lightcomponent not getting refreshed when flipping a lightcomponent horizontally.
- Fixed extra cargo defined in the server settings spawning every round in multiplayer campaign.
- Fixes wreck corpses' damage visuals (bloodstains, burns) not showing client-side. 
- Fixed wearables that are worn (or held) in multiple limbs applying skill bonuses multiple times (e.g. when holding a bandolier with both hands).
- Fixed console error when deselecting all target types from a motion sensor in the sub editor.
- Fixed crashing when multi-editing motion sensor targets in the sub editor.
- Fixed one of the path unlock event texts still using the old price (talking about 12,000 mk even though the price is 4,000 mk).
- Fixed money getting incorrectly deducted on the client side when buying items from the vending machine.
- Fixed item transfer taking items from non-interactable containers.
- Made depleted fuel sprite darker to match the rest of the "depleted" items.
- Fixed PUCS's autoinjection feature sometimes causing performance drops in multiplayer.
- Fixed "tried to overwrite a submarine that's not in a local package" error when you delete a sub that's in a local package and try to resave it.
- Fixed misaligned broken duffelbag sprite.
- Fixed full-white x-ray monitors.
- Fixed FPS drop when adjusting character appearance in the campaign setup menu or server lobby.
- Fixed tunnels at the beginning or end of the level sometimes being too narrow to pass through (especially with a small sub) when there's no outpost at that side of the level. 
- Fixed missing background sprite in duct block.
- Fixed water particles not showing up when water is flowing down a duct block.
- Fixed changing the scale of resizeable structures (such as background doors) messing up the outline of linked subs in the sub editor.
- Fixed non-player-team interactable items getting transferred on sub switch.
- Fixed ballast flora root emitting particles when damaged client-side, even if it's already been destroyed.
- Fixed recycle recipes for Piercing Ammunition Box and Pulse Tri-Laser Fuel Box.
- Fixed some lights (e.g. vending machines, neon lights, holographics displays) looking different in the sub editor than they do in-game.
- Fixed undocked shuttles remaining undocked if you save and start a new game with the same submarine during the same session. Restarting the game fixed the issue though. 
- Fixed sonar markers going crazy if the start and end locations have the same name + added some more variety to location names to prevent duplicate location names.
- Fixed multiediting an ItemComponent modifying all the components of that type in all the selected items (e.g. when editing the 1st light component of a switch, all lights in all switches would be edited).
- Fixed melee weapons not damaging structures from outside.

Modding:
- Fixed removing a door mid-round crashing the game. Does not affect the vanilla game, because doors are never removed mid-round.
- Fixed having a vending machine in your inventory crashing the game due to the 0-capacity input inventory of the machine.

---------------------------------------------------------------------------------------------------------
v0.18.12.0
---------------------------------------------------------------------------------------------------------

- Fixed medical doctor tutorial throwing an error and freezing in most languages other than English.
- Fixed occasional disconnects with the error "the given key was not present in the dictionary" when giving orders or reporting things in multiplayer.
- Fixed occasional crashes caused by AIObjectivePumpWater.
- Fixed certain looping item sounds (oxygen generators, vents, reactor) being too quiet to hear.
- Fixed one of texts not appearing in the "captive souls" event.
- Fixed inability to fabricate rubber shells.

Modding:
- Fixed crashing when a MonsterEvent fails to find the character prefab.

---------------------------------------------------------------------------------------------------------
v0.18.11.0
---------------------------------------------------------------------------------------------------------

Bugfixes:
- Disabled project-wide invariant globalization, which was meant to address "couldn't find a valid ICU package installed on the system" errors on some Linux distributions. The fix caused issues with case-insensitive comparisons and converting to upper or lower case in non-latin alphabets.
- Fixed tutorial characters spawning without a headset.
- Fixed inability to bind keys to LMB by clicking on the input box.

---------------------------------------------------------------------------------------------------------
v0.18.10.0
---------------------------------------------------------------------------------------------------------

- Fixed "index out of range" error when joining a server where's someone's rewired items.
- Fixed some mission messages being displayed as "missionmessage0.nameofthemission".

---------------------------------------------------------------------------------------------------------
v0.18.9.0
---------------------------------------------------------------------------------------------------------

- Updated translations.
- Fixed crashing when a mod includes event sets that reference a non-existent event.
- Backwards compatibility: readded some mission events we'd removed since the previous update.

---------------------------------------------------------------------------------------------------------
v0.18.8.0 (3rd Anniversary Update)
---------------------------------------------------------------------------------------------------------

Balancing:
- Added some new campaign settings: starting balance, amount of starting items and difficulty.
- Cargo mission reward of construction materials has been reduced to be less balance-breaking.
- Revisited all item spawns. Drastically reduced and adjusted the spawns everywhere. Disabled some spawns in campaign. All the subs should now start with a bare minimum in the campaign.
- Reduced selling price to ~25% of base price to avoid getting too rich from looting too early/easily
- Increased effect of "Requested Goods" to be 2x to compensate for the decreased selling price.
- Alien artifacts and trinkets can still be sold for a high price at research stations. (2x modifier, to compensate for the reduced selling price)
- Removed batteries from Headset, to reduce the value of selling/deconstructing these.
- Duffelbag deteriorates over time when in use, and now is carried with both hands.
- All items now deconstruct into less materials than it takes to construct them. Avoiding infinite construction/deconstruction loops for easy skill leveling.
- (Temporarily?) Removed most hand-placed items from the vanilla subs to make balancing and debugging the auto item placement easier.
- Revisited crew corpse spawns. The id cards are no longer manually placed. The cards found from the crew now actually work.
- Minor adjustments to bandit loadouts.
- Changes to chaingun. Now fires 500 shots instead of 200 per ammo box, at the cost of DPS.
- Added shredder rounds for chaingun, as an option against armoured targets. 
- Adjusted the armor penetration of all turrets.
- Made location evolution take a little longer, colonies cannot be formed closer than three steps to another colony.
- Made wreck missions a little more common.
- Adjustments to the preferred containers (= where things are spawned and where they should be placed).
- Changes to the existing missions and how they are distributed. Added new missions.
- Reduced the costs for unlocking the biomes.
- Adjustments to the monster spawns.
- Changes to the item "gating". Some items don't appear early in the game anymore.
- Adjustments to the mission specific variants of the monsters.
- Added a large Crawler variant for some missions (removed the Swarmcrawler that was used for crawler missions).
- Halved Mudraptors' priority for eating dead bodies.
- Reduce nausea chance of energy drink to 25%.
- Changes to the campaign progression in general.
- Changes to the level generation parameters, especially in Cold Caverns and the Ridge.
- Changes to the level resources distribution.
- Changes to the event manager settings (that affect the monster spawns).
- Adjusted and normalized the item loadouts for all the jobs.

Chat improvements:
- Chat mode (radio/local) can be toggled using a dropdown next to the chat box or with a dedicated "ToggleChatMode" keybind (R by default).
- Voice chat now has only one push-to-talk keybind (V by default) which respects the selected chat mode.
- There's now a dedicated "ActiveChat" keybind (T by default) to open the chat using the currently active chat mode.
- If you want to keep the chat keybinds the way they were (separate keybinds for local and radio), you can rebind the "Chat" and "RadioChat" inputs back to T and R and the new "ToggleChatMode" and "ActiveChat" inputs to something else.

Changes and additions:
- Added damage overlays to characters (characters who've taken damage look damaged).
- Added two new beacon stations.
- Added a bunch of new UI sounds (tickbox toggling, confirming transactions, increase/decrease sounds for number inputs, cart sound for adding/removing items in store interfaces, selecting/clicking components, sliders and modlist).
- Added UI volume slider.
- Show a verification prompt if an automated circuit tries to make the submarine undock from or dock with an outpost. Prevents campaign getting softlocked if someone rewires the docking port in a way that makes it dock/undock immediately at the start of around.
- Color subs in the sub editor's list to indicate whether they're vanilla, workshop or local subs, added a tooltip that explains why some of them cannot be deleted through the editor.
- ID cards can now be purchased from outposts. The card gets assigned the appropriate tags for the character doing the purchase.
- Clients need to wait 1 minute if their vote gets rejected before they can start another vote of the same type.
- Increased the priority of explosion particles to make it less likely for them to not appear when the particle limit has been reached.
- Made matriarch genes slowly heal bleeding (not just afflictions of the type "damage") to get it to be more in line with the description.
- Adjusted small water flow sounds: lower max volume, lerp volume according to the water flow (-> small leaks are much more quiet).
- Added energy drinks and protein bars to vending machines.
- Reduced Winterhalter engine power drain (from 6000 total to 4250).
- Decorative level objects (plants and whatnot) can spawn on outpost walls.
- Adjustments on the particle effects of chaingun and coilgun.
- Added non-lethal rubber bullets for riot shotgun.
- Added a server setting to change if the looted money goes to the player or to the bank.
- Improved tooltips in the wallet menu to make their function more clear.
- Corpses can now be grabbed in singleplayer to loot money.
- Made the crew wallet menu update when the players permissions change.
- Prevented selling items from submarine containers tagged with "dontsellitems", instead of "donttakeitems".
- Removed merchant balance effect on item prices.
- Replaced "item sell value" with the location reputation effect on the store interface.
- Hide AppData path from tooltips in the sub editor to prevent exposing the user's name.
- Made the descriptions of some materials (that used to just say "useful for crafting") more descriptive. 
- Increased oxygen generator output in some vanilla subs.
- Made handheld sonar beacon sound less grating.
- The client who initiated a vote cannot take part in that vote (except if they're the only client who can vote, in which case the vote automatically passes).
- Made flashlight flicker before the battery runs out.
- Added some lootable money to corpses found in wrecks.
- Removed the small equipment indicators next to the character portrait.
- Weapon holders now use the tag "mountableweapon" instead of "weapon" to determine which items can be placed in them. Allows tagging non-weapon items as mountable in the holder, without making bots consider it a weapon due to the "weapon" tag. Also allows to keep some weapons not-mountable.
- Ammunition Shelf can now also store Depth Charges ("depthchargeammo" tag added) 
- Doors and hatches can now be mirrored in the sub editor (making them open from top to bottom, or from right to left).
- Depth charges can be stored in coilgun ammo shelves.
- Adding preview images to wrecks, beacon stations, outposts or enemy subs isn't allowed in the sub editor (unnecessarily bloats up their file size, as the preview images aren't visible anywhere).

Performance:
- Improved the performance statistics view that's enabled with the "showperf" console command: more fine-grained stats and easier-to-read visuals.
- Optimized AI pathfinding when they're trying to find a safe hull. Particularly noticeable in colonies when the NPCs are fleeing from something.
- Optimized character status effects (e.g. health regen and other constant damage reductions).
- Optimized watcher's acid clouds.
- Optimized loading submarines. Reduces loading times especially when there's lots of items in the sub.
- Lighting optimization: now some unimportant (dim and small) lights are hidden when there's lots of light sources visible on the screen at the same time. The maximum number of visible lights can be adjusted in the game settings.
- Lighting optimization: the number of light recalculations per frame is limited, meaning that when there's lots of moving, shadow-casting lights visible, the game doesn't try to recalculate the shadows all at the same time.
- Lighting optimization: simplify the light rendering when zoomed very far out (e.g. when looking through a periscope).
- Optimized status effects that modify items' conditions every frame (for example, oxygen tank shelves that fill up oxygen tanks).
- Optimized many status effects by making them only execute once per second instead of every frame (most importantly, diving suits and volatile fuel rods).
- Optimized talents: buffs are applied to characters periodically instead of every frame.
- Optimized the logic that bots use to determine the safety of hulls.
- Optimized items: stop updating items that don't need to be updated more aggressively.
- Optimized bot AIs: in particular, the cleanup, repair, pump water and load items objectives. Should significantly improve performance when the bots are doing these objectives when there's a large number of items in the sub.
- Optimized entity culling logic (determines which items/structures are currently visible in the screen).
- Optimized a bunch of textures.

Fixes:
- Fixed server not refreshing the power grid when a client disconnects and reconnects a power wire.
- Fixed hull updates not being sent if the water/oxygen/fire in the hull doesn't change server-side, preventing the hull's status from getting corrected if a client somehow ends up out of sync.
- Fixed ballast flora sometimes becoming unkillable in multiplayer.
- Attempt to fix tab menu crew list sometimes getting stuck to a broken state at the beginning of a round.
- Fixed inability to access the character tab in the tab menu when dead (preventing you from creating a new character).
- Fixed occasional "hash calculation for content package xxxx didn't match expected hash" errors when updating/enabling certain mods.
- Fixed preview sometimes breaking in the character customization menu when switching the hair or accessories on Linux or Mac.
- Fixed fonts not getting rescaled when changing resolution.
- Fixed misplaced hull in the beacon stations.
- Fixed ability to pick up items and take items from other characters when controlling a character whose inventory is inaccessible while alive.
- Fixed message box about a too large preview image not being shown when trying to publish one in the Workshop (instead throwing the generic "publishing failed" error).
- Fixed Venture airlock (missing button, inner door wiring).
- Fixed level floor not being visible on the sonar.
- Fixed bots being unable to shoot with a turret whose line of sight is blocked by another turret (even though the projectiles can go through the turret).
- Fixed switching a sub making its preview image disappear from the submarine switch menu.
- Fixed an issue where the client was adding mission rewards into the bank on their screen causing desync.
- Fixed item assemblies still getting misaligned when saving.
- Fixed crashing when there's no audio device available (no speakers/headset connected) and a character enters water.
- Fixed crashing when trying to save an item assembly with a space at the end of the name.
- Fixed crashing when a character tries to operate a turret from outside the sub.
- Fixed submarine name being set to a truncated value in the submarine save dialog if the submarine name text at the top of the screen gets truncated, leading to a crash if you try to save the sub with that name.
- Fixed devices whose power consumption is set to 0 not working when not connected to a grid.
- Fixed outpost NPCs choosing the item to spawn for the device they're operating randomly, occasionally causing them to for example load reactors with volatile rods.
- Clients replicate sending chat messages to wifi components in mp. Fixes radio-linked wifi components not receiving the signals client-side.
- Fixed tab menu staying open during loading screens.
- Signal components' and terminals' sprites don't mirror horizontally in mirrored subs (what's a DNA, RO, ROX or XEGER component??).
- Fixed inability to rewire any docking ports in outpost levels, even if the port is not docked with anything (should only apply to the port docked with the outpost).
- Fixed "Ignore This" orders being wiped when loading an existing multiplayer campaign save.
- Fixed abyss area being very small in the Aphotic Plateau, preventing the abyss monster from reaching you if you go deep enough.
- Fixed status monitor displaying small amounts of water as 1% even though water detectors output 0%.
- Fixed autopilot conflicting with VELOCITY_IN inputs (now signals override the autopilot for 1 second). 
- Fixed ConversationAction getting interrupted when opening an input-blocking menu in single player.
- Fixed sprite bleed in chaingun ammunition boxes.
- Fixed appearance of specific named NPCs being inconsistent (e.g. Captain Hognose sometimes being a woman or not having an eyepatch).
- Fixed certain scripted events getting stuck if you switch characters in single player (e.g. the events that require you to interact with fliers on the wall).
- Fixed crashing when the source of a rope is removed (e.g. when a latcher despawns while latched on to the sub).
- Fixed votes always going through if no-one votes.
- Fixed energy drink giving x10 more haste when used via the health interface.
- Fixed the monster spawns for the new game plus not working (currently a placeholder set).
- Fixed monsters spawning from missions not avoiding the engines.
- Split campaign state networking messages into multiple ones. Previously all the campaign-related data (map state, reputation, upgrades, purchased items, selected missions) was included in the same message, and whenever anything in the data changed, the server would send all of it to clients. This would cause performance and bandwidth issues in some situations, for example when reputation was changing rapidly. 
- Fixed some pumps in Kastrull working without power.
- Fixed quick-reloading working incorrectly when trying to reload from a stack that doesn't fully fit in the weapon (e.g. when double clicking on a full stack of revolver rounds with a half-loaded revolver in hand).
- Fixed inability to quick-reload weapons with more than 1 inventory slot (e.g. autoshotgun).
- Fixed outpost NPCs having x3 more health than they should.
- Fixed morbusine not killing NPCs with higher-than-default health.
- Fixed graphics errors when using Razer Cortex overlay.
- Fixed bots being unable to repair Winterhalter's top hatch.
- Fixed server crashing if you disable all mission types and try to start a mission round.
- Fixed Chinese/Japanese/Korean text not wrapping properly on terminals.
- Fixed bots sometimes walking towards a wall or holding the ladders when they are idling.
- Fixed "main docking port" property not being taken into account when placing outposts (= the outpost was placed with the assumption that the docking port closest to the sub's center is the main docking port). Sometimes caused the outpost to be placed too close to the level walls, preventing the sub from docking with it.
- Fixed ladders not being visible in the sub preview.
- Fixed some UI elements being too large when switching from a large resolution to a smaller one, or vice versa.
- Fixed weapon holder sprite depth.
- Fixed level editor's test mode generating a different level than the editor itself.
- Fixed ballast flora branches that have been disconnected from the root not being considered disconnected after a level transition (allowing them to keep growing).
- Fixed "set default bindings" not doing anything in the settings menu.
- Fixed door/hatch gaps not getting moved when snapping to grid in the sub editor.
- Vertically mirrored beds can't be laid on.
- Fixed wrecked reactors being forced to non-interactable even if made interactable in the sub editor.
- Fixed keybinds shown in the controls tab not refreshing when resetting the binds.
- Hopefully fixed colonies sometimes not including some modules (most often the armory module).
- Fixed ready checks sometimes ending at a slightly different time client-side compared to the server, allowing you to answer the prompt even though the time to answer already ended server-side.
- Fixed large terminal welcome messages going slightly outside the bounds of the listbox.
- Fixed overlapping in the tab menu's mission tab when there's more than one mission selected.
- Fixed fabricators and deconstructors playing the sounds even if they're out of power.
- Fixed occasional "hash mismatch for downloaded mod" errors on Linux.
- Fixed clients occasionally spawning as the old character after they've opted to create a new one. Only happened if the client hadn't died and was still controlling the old character at the end of the round.
- When a client creates a character with a new name, the client's name is changed to match it after they spawn as that character.
- Fixed enabled mods getting disabled when updating them in the mods menu.
- Fixed a rounding error in Sprite.DrawTiled that sometimes caused an extra 1-pixel line on some scaled and flipped structures (e.g. certain wall pieces scaled to 0.6).
- Fixed Orca 2 still using the old chaingun charge time.

Modding:
- Added "mod lists" which can be used to enable/disable sets of mods more easily.
- Option to choose which local mod(s) to add a submarine to when saving one in the submarine editor.
- Mods can be unsubscribed from by right-clicking on them in the mod list, and it's possible to unsubscribe from multiple ones at the same time by using ctrl+click or shift+click to select more than one.
- Local mods can be merged in the mod list by selecting the ones you want to merge and selecting "merge all selected" from the right-click context menu.
- Better filtering in the mod list: option to only show local mods, Workshop mods, published mods, submarines and/or item assemblies.
- Added "SameInventory" spawn position type to status effects (allows spawning items in the same inventory the entity applying the effect is in).
- Added support for multiple light components in wearables.
- Fixed permanent stats given by talents not getting synced to clients in multiplayer (doesn't affect any vanilla talents).
- Fixed nullref exception when trying to trigger a location type change to a type that doesn't exist (doesn't happen in the vanilla game).
- Added an extra tag to the "canned heat" talent to make it easier to add custom upgradeable tanks that aren't compatible with vanilla tools.
- Option to make status effects drop the items contained inside the target item (usage example in the duffel bag).
- Level object, cave and mineral commonness can be defined based on the biome instead of the level generation parameters (= no need to define commonness for "coldcavernsbasic", "coldcavernsmaze" etc separately).
- Option to define ConversationAction texts directly in the event xml (instead of having to always define them in a spearate text file).
- Extended CustomInterface functionality with NumberInput elements that allow using float values ("numbertype") and defining the increment size ("step") the number of decimal places ("decimalplaces"). (Thanks, mLuby!)
- Implemented <clear/> element for removing all the child elements of an element in a variant file.
- TriggerComponent now supports negative forces: negative force value will cause the it to pull triggerers towards it.
- Multiple TriggerComponent properties can now be modified through signals and CustomInterface components.


---------------------------------------------------------------------------------------------------------
v0.17.16.0
---------------------------------------------------------------------------------------------------------

Changes:
- Added some tutorial information to the data sent to GameAnalytics.

Fixes:
- Fixed an exploit that allowed modified clients to execute console commands server-side without the appropriate permissions.
- Fixed NPCs spawning without any items when the system language is set to Turkish.

---------------------------------------------------------------------------------------------------------
v0.17.15.0
---------------------------------------------------------------------------------------------------------

Fixes:
- Fixed crashing if a custom language doesn't configure NPC personality traits or conversations.
- Fixed crashing when you try to disguise as someone else when using a mod that overrides the vanilla human config.
- Fixed characters getting instakilled if you dive too deep in the sub editor test mode.

---------------------------------------------------------------------------------------------------------
v0.17.14.0
---------------------------------------------------------------------------------------------------------

Changes:
- Display both wallet and bank balance on campaign interfaces when the player has access to the bank funds.

Fixes:
- Hopefully fixed the frequent "SteamP2P connection timed out" errors during loading screens.
- Fixed "missing entity" error when a character who's stats have been modified by a talent gets removed (e.g. eaten by a monster, despawning).
- If starting a multiplayer round takes a long time, instead of throwing the "did not receive STARTGAMEFINALIZE message" error, you're asked whether you want to keep waiting or return to the lobby.
- Fixed "failed to parse the string 'COLOR.GUI.GREEN' to Color" errors when using the submarine upgrade interface in Spanish.
- Fixed junction boxes not deteriorating over time.
- Fixed turrets being able to fire without consuming power when the power is wired to some other connection than power_in.
- Fixed broken supercapacitors providing unlimited power to turrets.
- Fixed IsMale/IsFemale properties resetting when saving and reloading (not used by the vanilla game).
- Fixed haloperidol not healing psychosis.
- Fixed ballast flora sometimes becoming unkillable client-side when entering a new level.
- Fixed the Server Log button overlapping campaign interfaces by hiding it whenever a campaign interface is open.
- Fixed an inconsistency in the assault rifle mag recipe.
- Fixed job not showing up in ID card description.
- Fixed store interface not being updated when the player balance changes.

---------------------------------------------------------------------------------------------------------
v0.17.13.0
---------------------------------------------------------------------------------------------------------

Changes:
- Players who are allowed to manage money in the multiplayer campaign can use money directly from the bank without having to transfer it to their wallet first.
- Managing money always requires permissions: unlike other campaign-related permissions, not having anyone with permissions on the server doesn't give everyone permissions.

Fixes:
- Fixed deconstructors, fabricators and research stations not being powered in some colony modules.
- Fixed power connections not getting recalculated server-side when disconnecting and reconnecting a wire.
- Fixed client context menu not working in the tab menu if the client's not controlling a character.
- Fixed preview image disappearing when saving a sub.
- Fixed custom jobid tags not working on ID cards.
- Fixed crashing with the error "Coroutine Barotrauma.SinglePlayerCampaign+<DoLoadInitialLevel>d__16 threw an exception" when trying to give items to a human prefab instance that has no item sets configured.
- Fixed installed mods list not refreshing when uninstalling an unsubscribed mod.
- Fixed outpost reactors using mechanical skill for repairs instead of electrical.
- Fixed outdated Dugong preview image.
- Fixed Deadeye Carbine firing an inconsistent number of rounds per burst in multiplayer.
- Fixed crashing when launching the server with a fresh config file due to the language being set to None.
- Fixed crashing on startup if the workshop mod directory doesn't exist.
- Fixed "Canned Heat" not having an effect on oxygenite tanks.
- Fixed entity list's search results being in a random order in the sub editor.
- Fixed crashing when trying to view an item assembly that contains entities that can't be found in the sub editor.
- Fixed bots not taking medical items' negative effects into account when determining which meds to use, often leading to overdoses/suffocation when using opiates.
- Fixed bots trying to clean up items into deconstructors.
- Fixed clients failing to spawn items with console commands when there's a structure prefab with the same identifier (e.g. ladders).
- Fixed characters being unable to gain skills added by a mod if the job doesn't initially have those skills defined.
- Automatically correct linked submarine paths in the submarine editor.
- Fixed electrical discharge coils sometimes working with insufficient power.
- Fixed crashing when creating a humanoid character in character editor.
- Fixed cargo missions putting cargo in non-interactable and hidden-in-game containers.
- Fixed only the first Powered component being considered when determining how much power an item is supplying to the grid. Prevented alien generators from working.
- Fixed textbox's text position breaking when there's overflow and you're editing in the middle of the string.

---------------------------------------------------------------------------------------------------------
v0.17.12.0
---------------------------------------------------------------------------------------------------------

- Updated translations.

---------------------------------------------------------------------------------------------------------
v0.17.11.0
---------------------------------------------------------------------------------------------------------

Fixes:
- Fixed occasional crash when talking to an outpost merchant.
- Fixed cargo missions putting cargo in non-interactable and hidden-in-game containers.
- Don't show wallet info on character portrait in other multiplayer game modes than the campaign.
- Fixed certainstructure names not showing up properly in the submarine editor in languages other than English.
- Fixed relays that have "can be overloaded" set to true breaking when overloaded (should never happen because relays can't be repaired).
- Fixed occasional mission mismatch errors in multiplayer when there's a hunting grounds or beacon mission in the level.

---------------------------------------------------------------------------------------------------------
v0.17.10.0 (Urban Expanses)
---------------------------------------------------------------------------------------------------------

Changes and additions:
- Overhauled colonies: completely new modules, improved layouts, new structures and items, new events.
- Split outposts stores into several different vendors who sell different types of items.
- New store (and sub editor) categories: weapon, medical, diving, and fuel. Reorganized the items into categories.
- Adjusted the amount of colonies in Cold Caverns.
- Added personal wallets. Everyone in the crew now has their personal wallet that they can use to purchase whatever they wish in outposts. The host (or people with campaign management permissions) can distribute a portion of the mission rewards to the crew or transfer money from the shared funds to the players.
- Reworked campaign permissions: removed BuyItems and CampaignStore permissions (no longer needed, since everyone can buy), added ManageMap and ManageHires permissions, ManageCampaign allows gives you all the other campaign-related permissions.
- Items can be purchased from outpost vending machines using the personal wallet.
- Reworked the power distribution logic. Should fix unstability and inconsistencies in power grids involving relays and batteries.
- Adjustments to reactors and supercapacitors to prevent the increased supercapacitor loads from crippling the subs on default recharge rates: slightly increased Humpback reactor output and decreased the default recharge rate of the capacitors, reduced recharge rates in the 3 new subs and set the supercapacitor efficiency to match the rest of the subs.
- Ballast flora improvements: improved damage visuals, branches die when cut from the root, the flora regenerates health at a rate relative to it's size.
- Made text displays and terminals craftable/attachable/detachable.
- Made Concat component's separator field editable mid-round.
- Made Deadeye Carbine fire in bursts.
- Animation adjustment: The head now rotates towards the mouse cursor while aiming or swimming.
- Swim animation adjustment: The body now rotates towards the aim target also when the character is moving, and not only while staying still. Moving while not facing the movement direction results in reduced movement speed.
- Set the bottom hole probability to 0 in Cold Caverns, which reduces the size and the frequency of holes in the level bottom.
- Characters spawn at a spawnpoint appopriate for their job when using the console command "spawn [job] inside".
- Added "low_oxygen" output to oxygen detectors.
- Beacon missions can spawn other types of monsters than just crawlers.
- Made supercapacitors take some damage when they're being charged faster than 70%.
- Increased Orca 2's reactor output.
- Adjustments to mission distribution: only easy missions at the beginning of the campaign, moved some of the more difficult missions later into the campaign.
- Made Not Component's ContinuousOutput property editable in-game.
- Show warnings when saving a sub in the sub editor if any of the entity counts (walls, items, lights, etc) are very high, don't allow saving if the light counts are above the upper limits.
- Added "power_value_out" and "load_value_out" connections to relays, batteries and supercapacitors.
- Boosted the structure damage from the small crawler eggs from 150 to 200.
- Adjusted structure and item damage for coilgun ammunition: piercing 50% less damage, exploding 100% more damage (from explosions), physicorium 50% more damage.
- Don't populate the abyss in difficulty levels 0 to 10 in single mission mode.
- Modified Selkie emergency hatch: can only use it if the shuttle is flooded.
- Reduce the probability for the coilgun to dismember limbs (or break armor).
- Removed submarine download confirmation prompt. All subs that are required to play in a server will be downloaded automatically, which shouldn't be a problem since they're only stored temporarily.
- Buffed ethanol's and tobacco's effects.
- Renamed "details" to "manage" and "permissions" to "rank" in the client management context menu to make them a little more clear.
- Changes to character aiming behavior.
- Water no longer dirties up walls.
- Disabled store category buttons for categories that contain no items.

Modding:
- An extensive rewrite of how the game handles content packages and loading content. Addresses a ton of issues, inconsistencies and usability issues regarding modding.
- The Mods folder has been replaced by folders called "WorkshopMods" and "LocalMods". "WorkshopMods" is used to store mods installed from the Workshop, and any mods stored in it should never need to be modified manually. "LocalMods" is used for developing mods: installing/updating mods never modifies the contents of this folder to prevent any work from being lost.
- Submarines are no longer saved in the Submarines folder, because it made it easy to get vanilla and custom subs mixed up. The sub editor now automatically creates a new local mod for each saved submarine.
- Remade the Workshop menu and made it a tab of the settings menu.
- More robust handling of mod load order, overrides and variants. 
- Clients now download the mods a server is using directly from the server, fixing content mismatches when for example trying to join a server that uses outdated mods.
- Mods now have version numbers to make it easier to determine which of the players are out of date.
- The Workshop preview images are no longer saved into the game folder, fixing the folder gradually growing in size as you use browse mods in the Workshop menu.
- Switching languages no longer requires restarting the game.
- Music can be overridden by identifiers.
- Reimplemented ServerExecutable to be usable in non-core packages. Now, players must select a server executable from a dropdown in the "Host server" menu if multiple are available.
- Character gender and ethnicity are no longer hard-coded: modders can use any kind of arbitrary tags to categorize character sprites.- Option to set the condition of an item spawned with status effects.
- Added new "accessiblebyowner" property to inventories. Allows making a character able to access their inventory even when "accessiblewhenalive" is false.
- Fixed clients not gaining control of the final stage of a husk affliction when "controlhusk" is enabled.
- When using a mod that doesn't set the InitialCount of any job, choose the first 3 jobs as the starting crew. Otherwise the crew customization menu will be empty and starting the campaign will lead to an immediate game over.
- Made it possible for attack StatusEffects to target the character doing the attack instead of the limb by using "Parent" as the target type.
- Using RemoveCharacter on a limb removes the character that limb belongs to.
- Fixed editing human character in the character editor sometimes making the inventory inaccessible.
- Fixed character editor crashing when trying to copy a character (unstable only).
- ItemContainers apply the OnContaining effects even when the item is broken. Doesn't affect any vanilla items.
- Ropes attached to limbs now automatically snap when another attack is chosen.
- Ropes can now be set to break from the end instead of always breaking from the middle (see the new abyss monster for an example).
- Ropes can be set to break if they are in too steep angle to the target.
- Projectiles always stick permanently unless a stick duration is defined.
- Characters (with deformable sprites) can be set to be drawn after (on top of) other characters. Normally characters are drawn in the order of spawning.
- AI Triggers can now be permanent.
- Added a generic damage threshold that currently defines how much damage the character needs to take from a single hit to hit the avoiding and releasing captured targets.
- Added a support for multiple identifiers and types in the limb health definitions.
- Added a support for min range for ranged attacks.
- Fixed monsters not being able to shoot faster than every ~1.5 second if they change the attacking limb.
- Added new after attack behaviors: Reverse and ReverseUntilCanAttack.
- Fixed "targetcontaineditem" still not working correctly.
- Fixed crashing when trying to remove fog of war at the very edges of the campaign map. Doesn't affect the vanilla game because there's enough padding at the edges of the map.
- Made DockingPort.ApplyEffectsOnDocking editable in the sub editor.
- Option to make missions force a ruin in the level if there isn't one.
- Character editor: don't check the validity of the texture path when copying humans (because the path is not valid and will be parsed later). Allows creating custom human characters by copying the vanilla human (even though they are not fully supported).
- Level editor no longer attempts to save the vanilla content.

Monsters:
- Added Latcher, a new abyss monster.
- Added a difficulty hierarchy for the abyss monsters. Easier monsters should spawn more frequently on an easier difficulty level, the harder should spawn more frequently on higher difficulty levels. Currently the new abyss monster is defined as the easiest, and Endworm the hardest. Charybdis is in between.
- Revisited endworm: the armor now breaks less easily, reduced the change of cutting the worm towards the head, adjusted the bleeding speed.
- Adjusted abyss resource spawning: less resources per level, the number of resources is relative to the difficulty, the spawned resources aren't guaranteed to always be the 5 least common alien materials.
- Made molochs, abyss monsters and fractal guardians immune to poisons.
- Fixed monsters sometimes trying to follow targets after losing the track of them even when they should be falling back from them (according to the after attack behavior).
- Fixed monsters sometimes using the after attack behavior of the current attack even when the cooldown of that attack is not active.
- Fixed monsters sometimes being unable to target the submarine, because their attack was incorrectly considered invalid.
- Fixed fractal guardians fleeing to a shelter immediatedly after taking some damage when they have targeted the guardian pod once and have not changed the target yet (e.g. if you shoot a guardian that is returning from the pod and if it has not yet spotted you).
- Adjusted the probabilities for spawning the Thalamus in the wrecks.
- Rebalanced mudraptors: slightly more health, less damage at head.
- Crawler: adjusted the vitality multipliers of hands and tail from 50% to 75%.
- Fixed Giant Spineling targeting doors after being attacked, which it shouldn't do by design. Might affect other creatures too.
- Fixed calyxanide not damaging the "naturally spawning" husks.
- Giant Spineling doesn't flee anymore when being shot with coilgun, chaingun, or small arms.
- Adjusted the kill hammerhead missions.

Balance:
- Increased the price of calyxanide to make it more in line with the price of husk eggs.
- Fixed wrecked supply cabinets being treated as normal supply cabinets. Reduces the amount of loot spawned in them.
- Adjust the medical item spawns in wreck and abandoned  med cabinets: less powerful medicines. Basic ingredients and consumables are more common, but come in low quantities.
- Increased the amount of scrap in wrecks.
- Increased Gene Splicer's price from 200 to 500.
- Increase the commonness of Esperite and Galena, which are sources of lead.

AI:
- Fixed bots accidentally shooting with a weapon if they have it equipped when they try to use the underwater scooter.
- Fixed bots still sometimes getting stuck when trying to get something from or put something to secure lockers.
- Fixed bots acting weird while trying to use underwater scooters inside.
- Fixed bots failing to heal characters in a docked sub/shuttle.
- Adjusted bot behavior around ballast flora: priority of some objectives now drops to 0 when the target's been claimed by ballast flora, items claimed by ballast flora aren't valid targets for some objectives anymore.
- Made bot healing dialog reflect if CPR was performed or not.
- Fixed security from the player's own crew attacking the player in multiplayer when the player attacks someone in an outpost.
- Fix bots not ignoring items marked to be "Hidden In Game".
- Bots prefer not to take diving suits off in rooms marged with the "IsWetRoom" flag.
- Docking ports are now automatically considered as "wet rooms".
- Fixed bots trying to target through doors and walls even though there's no line of sight between the end node and the target.
- Added some dialogue to bots when they get infected with the husk infection.
- Fixed bots sometimes getting stuck to doors when they are trying to fix a hull behind it. Happened because the goto objective was completed before the bot could open the door.
- Attempt to fix a crash in AIObjectiveExtinguishFire.
- Fixed bots not being able to repair leaks between rooms (leaks that are not in the outer walls).
- Waypoint fixes on abandoned outpost modules, some regular outpost modules, and Winterhalter.
- Fixed bots occasionally getting stuck while climbing ladders connecting outpost modules.
- Fixes to waypoint generator, mainly on stairs.
- Fixed a null reference exception when a bot is dismissed while being told to follow the player and still in the combat state.
- Fixed items flagged as "HiddenInGame" being considered interactable and therefore e.g. valid repair targets.
- Fixed outpost guards not arresting the offender when it's very far from them.
- Fixed bots sometimes failing to navigate back to the sub (when they are on the other side of the sub than where the hatch is).

Talents:
- Fix to yet another issue that sometimes prevented unlocking additional talents after unlocking "All-seeing Eye".
- Fixed "Curiosity" talent not giving experience to allies.
- Removing or changing order priority doesn't trigger the "Commander" talent buff.
- Fixed "Mass Production" talent allowing you to power devices by tinkering.
- Fixed "Pyromaniac" giving 39.9% damage resistance instead of 40%.
- Fixed ability to tinker indefinitely by interrupting the tinkering by switching to repairing the item.
- Fixed "Trusted Captain" and "Esteemed Captain" giving medals even when no missions have been completed.
- Fixed disconnected players preventing talents that require everyone to survive from working (e.g. "Field Medic", "Bootcamp").
- Fixed "Deep Sea Slayer" always giving you a 50% buff to harpoons regardless if you're inside or not.
- Fixed "Deep Sea Slayer" talent not affecting explosive harpoons.

Fixes:
- Fixed monsters being able to attack with practically no cooldown when they're taking constant damage from a player.
- Fixed crawler eggs not being displayed on the sonar.
- Fixed aiming being slightly off when crouching and not moving.
- Fixed item interfaces getting misaligned when there's several linked item UIs visible at the same time.
- Fixed inability to interact with doors/hatches through docking ports.
- Fixed escort missions failing if the escorted characters are in a shuttle docked to the main sub.
- Fixed pumps rounding the pumping rate value to -39 instead of -40.
- Fixed shell shields dropping from moloch's inventories when they spawn (because they could only be placed in hand slots which the molochs don't have).
- Fixed linked subs not being taken into account in the cargo capacity displayed in the sub's info panel.
- Fixed ID card descriptions disappearing between rounds.
- Fixed ID card description not being added if the ID card tags are empty.
- Fixed "error" text in the medical clinic UI when trying to heal a character who's disconnected.
- Fixed texts overlapping on health scanner hud when using a text scale above 100%.
- Fixed "snap to grid" not working on structures.
- Update items' hulls after creating the hulls between docking ports. Fixes e.g. water detectors between docking ports still thinking they're outside after the ports lock and the area between them drains.
- Fixed decorative sprites rotating incorrectly on vertically mirrored items.
- Disable collisions between subs when "locking" the docking ports between them. Fixes the ports leaving a gap between them if some structures of the sub prevent them from aligning exactly.
- Fixed wifi components ignoring signals to the "signal_in" connection if the signal originated from another wifi component that can't transmit to this one (i.e. if a wifi component passes a signal through a wire to another wifi component that uses a different channel).
- Fixed dropped signal components being drawn behind devices (now they're only drawn behind devices when attached to a wall).
- Fixed SMGs autofilled into the subs sometimes spawning without magazines.
- Fixed misaligned "Label Number 6" decal.
- Attempt to fix occasional performance drops in the store interface.
- Fixed clients seeing a blank server lobby if they join when a round is running with respawning disabled.
- Fixed arithmetic and trigonometric components not passing the sender of the signal forwards, preventing e.g. helm skill from boosting engines if the signal goes through a component.
- Fixed occasional crashes when transitioning between levels with showperf enabled in multiplayer campaign.
- Fixed wearables not affecting movement speed when godmode is on.
- Fixes periscopes not focusing on turrets if there's certain components (e.g. arithmetic components) between them.
- Fixed crashing when trying to use the "dumpeventtexts" command with no arguments or a disallowed path.
- Made smoke detectors a little more sensitive (should fix small fires sometimes not being detected even if they're in the same room).
- Fixed reactor sometimes not catching fire again if you start overheating it again immediately after a fire.
- Fixed recycling a non-empty SMG magazine dropping the bullet inside it on the floor.
- Fixed EntitySpawnerComponent's SpawnAreaOffset.Y being inverted.
- Fixed gaps generating incorrectly on "Shell A 70 Degrees".
- Fixed items powered by battery cells not working correctly (certain devices like handheld sonar beacons never powering up, and items staying powered indefinitely when you put in a battery and take it out). Unstable only.
- Fixed turret lights starting in an incorrect rotation in the sub editor.
- Fixed "commander" talent still not correctly giving the buff (giving orders that a character already had didn't move the buff). Unstable only.
- Fixed nav terminals sometimes determining which docking port the docking button controls incorrectly (specifically, when the correct docking port is also connected to other ports).
- Fixed an exploit in the depleted fuel SMG magazine recipe.
- Fixed reactor gauges' background sticking out from the gauges when selecting a reactor in the editor.
- Fixed fractal guardians fleeing to the shelter immediatedly after taking some damage when they have targeted the guardian pod once and have not changed the target yet (e.g. if you shoot a guardian that is returning from the pod and if it has not yet spotted you).
- Fixed Crawler Broodmother regenerating really fast while eating. Broodmother no longer eats her own eggs.
- Fixed spinelings accidentally killing each other with their spikes.
- Fixed burn being ignored in the damagemodifier of Charybdis' head. The jaw worked correctly. Affects pulse laser damage for example.
- Fixed lights that are drawn behind subs counting as shadow-casting in the sub editor.
- Fixed server host creating 2 disconnect message boxes if the server crashes.
- Fixed text scale not being taken into account on scrolling text displays.
- Re-filled Typhon 2 oxygen tank shelves.
- Fixed spawnpoint editing panel being too small on large resolutions.
- Fixed inability to equip one-handed items when there's a suitable container in the other hand (e.g. flashlight when there's a storage container in the other hand).
- Cargo missions don't require the cargo to be inside a hull: being in the sub is enough. Fixes inability to complete cargo missions with unconventional subs where the cargo is stored outside hulls.
- Fixed non-equipped items that can't be put into a duffel bag disappearing when a character despawns.
- Fixed incorrect animation parameters being used for swimming while wearing a regular diving suit.
- Fixed projectiles sometimes staying attached to the target even when they are far from it.
- Fixed multiplayer campaign saves with semicolons or pipes in their name causing "path to a save file was empty" errors in the server lobby.
- Fixed performance drops in multiplayer when someone attacks the outpost NPCs and causes the reputation to drop.
- Moved the showperf view to the right to prevent it from overlapping with the crew list.
- Fixed status monitor's electrical view and item finder not showing items in docked subs.
- The sound of crowbaring a door open can't be heard from other subs.
- Fixed "a gaze into the abyss" achievement working unreliably. The achievement didn't unlock until you returned to 50% of the crush depth, which isn't possible in some levels (e.g. if the level starts at 3500 m and crush depth at 5000 m). Now it's unlocked if you get to 500 m above the crush depth or to the end of the level.
- Fixed certain achievements (last man standing, lone sailor, finishing a round with a specific job) not unlocking if you're in a docked sub instead of the main sub at the end of the round.
- Readjusted all sitting animations so that they characters shouldn't twitch anymore while sitting.
- Doubled the rate limit for medical clinic which should reduce "No response from server" errors.
- Fixed swimming characters sometimes being unable to stand up on stairs/platforms even if the water is shallow enough.
- Fixed guitar and harmonica being rendered on top of the water effect.
- Fixed guitar, harmonica, accordion and captains pipe having neutral buoyancy.
- Fixed mid-round joining clients not seeing subs purchased during that round.
- Fixed research station being repairable by clicking on it instead of pressing E.
- Fixed medical curtains disappearing before they're off-screen.
- Fixed karma preset being forced to default when starting a new server.
- Fixed Herja's rear motion detector being connected to an incorrect display, and the bottom turret display having an incorrect text.
- Fixed crash caused by selection not being cleared when autocompleting or running a console command.
- Fixed occasional performance dips when spineling spikes get stuck to the sub's exterior walls.
- Fixed item assemblies getting misaligned with the grid after saving.
- Fixed "Shell A 18" not aligning with the other shell pieces.
- Fixed welding tool's, plasma cutter's and watering can's particle effects getting "clamped" to the edges of the hull they're inside.
- Fixed permission icon in the client list not updating mid-round.
- Fixed "lock default wires" server setting not affecting docked subs.
- Fixed Dugong's small pumps working without power.
- Fixed buttons in structure editing menu using a different style than other types of entities in the sub editor.

---------------------------------------------------------------------------------------------------------
v0.16.7.0
---------------------------------------------------------------------------------------------------------

- Fixed excessive loading times when playing in Chinese, Japanese or Korean.
- Fixed certain logic components (and/or/xor with an empty output and non-empty false output) stopping to work altogether when they stop sending a signal.
- Fixes to crashes when trying to interact with certain elements in the server lobby while getting disconnected.

---------------------------------------------------------------------------------------------------------
v0.16.6.1
---------------------------------------------------------------------------------------------------------

- Fixed captain tutorial being impossible to complete due to the docking button not activating on the nav terminal.
- Fixed door lights appearing to be off in the tutorials.
- Fixed crashing when you try to use the hotkeys or double-clicking to put an item inside another item you're holding in your left hand, but there's an item with no inventory in your right hand. 
- Fixed inability to repair research stations.
- Fixed status monitors crashing the game if the selected UI style doesn't define "IconOverflowIndicator".
- Fixed crashing when trying to view the specs window of a sub that hasn't been saved yet (= if you create a new sub, go to the test mode and open the submarine tab in the tab menu).
- Fixed some of Spineling's spikes getting hidden for 30 seconds instead of 15.

---------------------------------------------------------------------------------------------------------
v0.16.6.0 (Rising Tide)
---------------------------------------------------------------------------------------------------------

Changes and additions:
- Added a medical clinic to outposts that allows you to heal your crew for a price.
- Added three new sub: Barsuk, Herja and Winterhalter.
- Improvements and polish to the human sprites.
- Improvements and polish to clothing and headgear sprites.
- Added the Submarine tab to the multiplayer campaign store to allow selling items on the submarine.
- Prevented selling items from submarine containers tagged with "donttakeitems", e.g. constructors, deconstructors.
- Added new campaign store related client permissions: use campaign store, buy items, sell inventory items, and sell submarine items.
- Entities can be grouped together and the groups selectively hidden in the submarine editor.
- Balanced mission rewards, commonness and difficulties.
- Added some new decorative items and structures.
- Adjusted medical items' effects on bleeding and burns. Bandages, plastiseal and antibiotic glue are now much more effective at treating them, and morphine & fentanyl only heal them by a negligible amount.
- Heavily increased supercapacitor's power consumption and made the recharge speed increase exponentially when the recharge rate is increased.
- Optimizations to signal logic, status effects and property conditionals.
- Item update optimizations.
- Optimizations to gap logic.
- Optimized multiplayer store interface.
- Added "separator" property to Concat Component.
- Added "power_value_out" and "load_value_out" connections to junction boxes.
- Added "set_output" connection to Greater Than Component, Equals Component and Regex Component.
- Made alien materials spawn in abyss islands.
- Exposed wall healths in the sub editor.
- Modified Orca 2 and R-29 reactor values so they're more in line with other subs.
- Made ballast flora toxins more visible and made them emit a sound.
- Made impacts toss items around less effectively, especially when the item is heavy.
- "Allow rewiring" server setting doesn't affect wrecks, pirate subs or ruins.
- Added an option to disable all in-game hints to the hint message box.
- Option to make sonar displays center on the connected sonar transducer.
- Made the sizes of signal components consistent (32x32px, they also align to the grid now).
- Don't allow fabricators to take items from linked containers the user doesn't have access to.
- Connected diving suit lockers to oxygen in vanilla subs.
- Pulse laser ammo can be bought from outposts and cities.
- Chaingun tweaks: doubled turning speed when firing, reduced charging up time, reduced ammo consumption and made the ammo boxes more expensive.
- Simplified Remora drone docking system.
- Show notifications about reputation changes mid-round.
- Escorted NPCs drop the items they took from the sub (like suits) at the end of the round.
- Added warnings when the game fails to run the physics at the desired 60 updates per second (which would cause rubberbanding in multiplayer). The warnings are shown below the FPS when the client is running slowly, and in the debug console of the host/moderators/admins when the server is.
- Made turret icons on the minimap gray instead of red when not manned (easy to think there's something wrong with the turret when it's red).
- Abandoned outpost's oxygen generators now consume power.
- Made characters crouch a little lower (enough to make it possible to shoot while standing behind a crouching character).
- Added a "sendchatmessage" console command with an option to configure the color of the message.
- Added button to align selected items and wire nodes to grid to the sub editor.
- Allow using cheats in editors.
- Don't show "hidden in-game" docking ports on the sonar, option to disable the docking port's particle and sound effects.
- The prompt about forbidden words in the server's name is only shown when trying to start a public server.
- Show prices in the submarine specs window (previously there was no way to see a sub's price in the server lobby).
- Allow wiring non-interactable items and accessing non-interactable containers in the sub editor.
- Chaingun projectiles and canister shells cause lacerations instead of gunshot wounds.
- Added recycle recipe to SMG magazines.
- Significantly reduced the speed at which welding tools fix walls.
- Changed the small arms max stack sizes to either 6 or 12 when the clip size is 6. Makes it less tedious to use the extra ammunition.
- Added damage sounds to doors when they take 10 or more damage.
- Made outpost containers' sprite depths more consistent with other containers.
- Added tags to outpost medical compartments and made them linkable.
- Mission completion and failure icons are now displayed mid-round in the tab menu.

Monsters:
- Added 3 new monster variants: Giant Spineling, Crawler Broodmother and Veteran Mudraptor.
- An overall balance and behavior fix pass on all monsters. Feedback is welcome.
- Monster mission reward and difficulty level adjustments.
- Adjustments to the random monster spawn events.
- Adjusted the loot dropped by Crawler Broodmother, Giant Spineling, and Bonethresher.
- Moloch Pupa and Hammerhead Matriarch now also drop some loot.
- Crawler Eggs now deconstruct into suplhuric acid (and adrenaline gland, if they are not the smallest variants).
- Fixed mudraptors being unable to hit the targets that are very near.
- Fixed monsters sometimes getting stuck near the Humpback's bottom railgun.
- Fixed monsters getting stuck on trying to reach open gaps that are on the other side of the sub.
- Fixed aggressive boarders not being aggressive enough inside the player sub, because they couldn't target things that were blocked by a wall.
- Fixed Molochs not doing anything when there's babies around.
- Fixed Mudraptors not staying together in swarms.
- Fixed monsters continuing to eat a characters who've been revived with console commands (leading to weird results, such as the character being able to run around after being dismembered)..
- Fixed some monsters, like crawlers, trying to target walls with lots of gaps even though there are better targets closer to them.
- Fixed monsters being unable to target inner walls when they are technically outside of the sub (= when there's no hull where they are). Such places, between the outer and the inner walls, can be found e.g. in Humpback.
- Tigerthreshers can now target doors.
- Monsters that try to get inside the sub, should now notice and priorize doors more overall. Affects e.g. Mudraptors, and to lesser extent Crawlers (and Tigerthreshers).
- Monsters' burns don't heal by themselves.
- Fixed hammerhead matriarchs sometimes spawning in low-difficulty levels.
- Fixed endworm not having a burn damage modifier in the right tooth.
- Changed Golden Hammerhead's behavior towards stronger monsters.

AI:
- The order of the crew list is saved between rounds in single player.
- Indicate when a bot is following someone else than you on the crew list's order icons.
- When quick-assigning orders, prioritize the characters with the same Operate order only when they are targeting the same item.
- When quick-assigning orders, don't prioritize characters with the same Maintenance order. Otherwise, Maintenance orders will always be quick-assigned to characters who already have the samer order. This will prevent giving out multiple Maintenance orders of the same type to multiple characters using the quick-assignment logic.
- Allow quick-assigning the same kind of Operate order to multiple characters. Previously, it would always be given to the character that already had the same kind of order.
- Added a new "Assault Enemy" order: bots with the order will seek out and attack any hostile characters in any connected submarines or outposts.
- Made the order quick-assigning logic prefer characters who don't have the order yet (among the characters with the appropriate job).
- Made it possible to use the order quick-assignment to give the Fix Leaks order to all character (although mechanics, engineers, and assistants are still preferred).
- Fixed bots sometimes getting stuck while trying to fix a leak that's not in the same sub (e.g. bot in Remora and the leak in the drone).
- Reduced the range where the bots can spot enemies outside of the sub.
- Improved bots' ability to return back to the submarine from caves.
- Fixed oxygen shards from old saves still being used as oxygen sources by bots.
- Fixed bots getting stuck in certain spots with ladders (e.g. Berilia's reactor room).
- Fixed contextual "clean up" order not being visible for weapons.
- Defined preferred containers for some items and added "locker" as the secondary preferred container for most items. Helps bots clean up things even when they can't find the primary container for the items.
- Fixed bots sometimes halting briefly next to a door when they shouldn't.
- "Fight intruders" order doesn't make the bots enter abandoned outposts to fight the enemies there.
- Disable aggressive behavior towards the player for the friendly crew members in single player (= accidental friendly fire never turns the security hostile in single player).
- Fixed bots saying they can't find items to load when someone takes an item they were targeting.
- Fixed bots saying they can't reach a leak when someone else fixes it before them.
- Fixed bots sometimes trying to adjust auto-controlled pumps when doing the autonomous Pump Water objective.
- Arrested pirate captains don't try to give orders to their crew.
- Change how captains (and theoretically other bots with an autonomous fight intruders order) behave: instead of idling around, they'll flee to the safety. And if there's no security officers around, they should fight the enemy aggressively.
- Fixed bots filling target containers with items that can't be refilled/recharged when given the Load Items order (e.g. putting welding fuel tanks in oxygen tank shelves).
- Made bots prefer the same fuel rods or ammo as already loaded when they're operating a reactor or a turret and need to find new ones.
- Bots that follow a character who's going inside/outside stick closer to the character they're following. Helps the bots to get back inside with you.
- Fixed pets becoming hostile towards the crew and other pets if a human attacks the character they're protecting.
- Fixed pirates not operating turrets when they have no power. 
- Fixed bots not unequipping diving suits when they have an order but not actively following it (i.e. they are on idle).
- Fixed Operate orders not being dismissed automatically when another character is ordered to operate the same device.
- Fixed the dialogue reserved for rearranging character orders not being used in multiplayer.
- Fixed bots sometimes getting stuck on ladders while swimming.
- Fixed bots returning to the sub even when they have an active wait order. Happened when the order was given inside and then when e.g. the character is controlled by the player, and then when the player changes the character, the bot falls to the "find safety objective", because it's not allowed to stay outside.
- Bots can find buttons connected to a door using links made in the sub editor. Allows working around complex circuits that prevent the bots from figuring out which button controls a door.
- Fixed bots taking battery cells from portable pumps without considering their condition when acting on the Recharge Battery Cells order.
- Fixed bots not always reacting to monsters when they should be able to see them, while swimming outside.
- Fixed bots accidentally damaging friendly characters while trying to hit Swarmfeeders latched on to them.
- Fixed bots not using melee weapons when there's Swarmfeeders latched on to them.
- Fixed bots being able to shoot without any delay if they already have a weapon equipped.
- Fixed bots dropping the syringe inside PUCS when replacing the oxygen tank.
- Fixed bots sometimes failing to find a path to a docked shuttle or drone.
- Fixed NPCs reacting to combat between other characters when they shouldn't (e.g. when they don't witness it).
- Fixed bots not re-equipping body armor/ballistic helmet/something else when they drop the diving gear.
- Fixed bots having issues with some stairs. Note: these changes might require alterations on stair waypoints. Currently the generator doesn't do perfect job there. Look for the examples on how to fix them manually in the vanilla subs.
- Fixed bots sometimes trying to put items they're cleaning up into containers inside fabricators/deconstructors (e.g. an oxygen tank into a diving suit in a fabricator).
- Fixed bots equipping gene splicers when cleaning them up, causing the genetic material to get destroyed when the bot puts the splicer in a container.

Talents:
- Removed the special stat boosts from "Olympian" (now it only increases the skill cap to 200).
- Halved the amount of damage "Still Kicking" heals (100 -> 50)
- Reduced gunshot wounds inflicted by handcannon.
- "True Potential" only has a chance of instakilling things smaller than a moloch.
- Halved damage buff from "Quickdraw" (80% -> 40%).
- Reduced skill gain from "Field Medic" (7 -> 3).
- Nerfed "Warlord" (20% chance of doubling the damage -> 5% chance).
- Reduced damage buff from "Expert Commando" (40% -> 20%).
- Health scanner doesn't show buffs from talents.
- Fixed "unused talent points" indicator staying visible after all talents have been unlocked if the character's gained extra talent points from other talents.
- Fixed incorrect talents sometimes unlocking server-side when unlocking "All-Seeing Eye". Happened because the server checked how many talents the client can unlock before applying All-Seeing Eye, which meant that the 3 extra talents would not be available, and the server would leave the last 3 talents unlocked.
- Fixed "Inspired to Act" talent only giving a skill bonus of 9.98 instead of 10.
- Fixed "Atmos Machine" talent not spawning psychosis artifacts or alien pistols.
- Fixed "Hazardous Materials" considering any reactor outside the main sub (e.g. beacon station) a wreck reactor.
- Fixed ranged weapons (including turrets) triggering "Electrochemist" talent's stun.

Bugfixes:
- Fixes character resetting in MP campaign if you join mid-round and don't get to spawn in before the next round in a campaign you've previously played in.
- Fixed equipping two of the same genetic material and then unequipping one of them removing all the genetic effects.
- Fixed "novice seafarer", "experienced seafarer" and "naval architect" achievements being possible to unlock even if cheats are enabled.
- Fixed kills in multiplayer sessions not progressing the "xenocide" and "genocide" achievements, and kills being reported to Steam unreliably.
- Fixed clients not spawning the respawn shuttle if they join after the server had disabled the shuttle mid-round, leading to an "entity not found" kick.
- Fixed medical effects being different when the medical item is fired with a syringe gun.
- Fixed wall healths being half of what they should be on vanilla subs, increased structure damages to compensate.
- Fixed fabricator sometimes desyncing in MP when some of the ingredients are in the user's inventory.
- Fixed clients trying to reconnect to SteamP2P indefinitely if establishing the initial connection fails, eventually leading to a crash.
- Fixed "allow linking wifi to chat" server setting causing syncing problems with headsets. The setting wasn't synced with clients who don't have settings management permissions, which would cause them to get some of the wifi components' properties mixed up and sometimes prevent them from communicating using the headsets.
- Fixed motion detector requiring the target's velocity to be higher than the specified minimum velocity, instead of higher than or equal. As a result, a minimum velocity of 0 would not sometimes detect targets in range.
- Fixed an exploit that allowed combining genetic materials in deconstructors.
- Fixed "fixitems" command setting genetic materials' condition to 100.
- Fixed "reset to prefab" not resetting wall healths.
- Fixed certain logic components not passing forwards the character who sent the signal, preventing e.g. the character who undocked a drone from being logged or the character who killed something from being determined if the signal activates a weapon.
- Orca 2: Fixed missing power wires to a couple small pumps, neutral ballast level, gunnery marked as wet room. Added a duct block between upper and lower deck. Some minor visual fixes.
- Fixed voronoi sites sometimes getting placed outside the level's bounds, leading to messed up level geometry.
- Fixed turrets always starting at rotation 0 at the beginning of the round (instead of halfway between the min/max angles like in the editor).
- Fixed changing a delay component's delay using the editing hud not having an effect in-game when the component is receiving a continuous signal.
- Take structures/items with a collider into account when calculating a sub's dimensions (as opposed to just hulls). Fixes dimensions being incorrect in the submarine's info if the sub includes structures that extend far outside the hulls.
- Fixed crashing when swimming up from hull to another in a specific kind of hull configuration (two hulls side-by-side, with a gap leading up to another one).
- Fixed oxygen shards from old saves still being used as oxygen sources by bots.
- Fixed changes not being applied to all selected items when multi-editing a string field in the sub editor and deselecting the items without applying the changes by pressing enter.
- The game doesn't try to save a campaign if an exception occurs at any point during the saving process (should fix rare occurrences of campaign saves getting corrupted).
- Don't allow signals to deactivate ItemContainers. Fixes portable pumps' "toggle" input not working.
- Fixed removed items staying visible on the status monitor's electrical tab.
- Fixed plants still using the old values in old saves (i.e. dying too fast when not watered).
- Outposts can't request the "psychosisartifact_event" item (an event-specific special artifact that looks identical to the normal ones).
- Fixed size of a door's gap relative to the door changing when rescaling the door in the sub editor.
- Fixed fabricator consuming all the suitable ingredients when the ingredient is configured using a tag instead of an identifier (e.g. fabricating a stun gun dart would consume all the wires in the input slots).
- Fixed motion detector's detect offset getting mirrored when copying a mirrored detector.
- Fixed status monitor's submarine blueprint refreshing when initiating docking with a shuttle, instead of when the docking ports lock (sometimes causing the shuttle to appear slightly off from the docking port on the monito).
- Fixed fabricator failing to stack oxygenite tanks.
- Fixed items in the player's inventory not getting highlighted as valid ingredients when using a fabricator.
- Attempt to fix a rare crash caused by ScalableFont.DrawStringWithColors.
- Fixed freezing when trying to enable GameAnalytics from the settings menu on Mac.
- Fixed locked connection panel and non-interactable lights in R-29.
- Fixed Delay Component failing to parse set_delay inputs on systems that use comma as the decimal separator.
- Fixed charge rate not being displayed correctly on batteries in Chinese.
- Fixed junction box load not being displayed on status monitors in Russian.
- Fixed oxygen tanks being misaligned in oxygen generators.
- Fixed motion sensor not being able to detect subs in the sub editor test mode.
- Fixed recycled volatile fulgurium rods incorrectly using mechanical instead of electrical skill.
- Consider the character who severed a limb as the character who inflicted the afflictions caused by severing the limb. + Consider the character who caused bleeding as the character who caused the resulting bloodloss. Fixes achievements not unlocking and talents not triggering if you kill a target by cutting its limbs off or by making it bleed to death.
- Fixed characters sometimes becoming momentarily unresponsive when swimming out from a hull.
- Fixed speed penalty caused by the vegetation in caves sometimes not disappearing after passing through the vegetation.
- Fixed links from a docking port to a linked sub not being considered valid in the sub editor (only a link from linked sub to a docking port). Now the order of the link doesn't matter.
- Fixed repair window showing up if you use a periscope wired to a broken device.
- Fixed sonar getting misaligned when switching to the docking mode (the amount of misalignment being relative to the distance of the docking port from the sub's center).
